/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:21 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "colorbar.h"
#include "caxis.h"

static double __Array0_r[2] = { 0.0, 90.0 };

static double __Array1_r[2] = { 0.0, 1.0 };

static double __Array2_r[2] = { 0.0, 1.0 };

static mxArray * Mcolorbar_gcda(int nargout_);
static mxArray * mlfColorbar_gcda(void);
static void mlxColorbar_gcda(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]);

/*
 * The function "Mcolorbar" is the implementation version of the "colorbar"
 * M-function from file "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines
 * 1-209). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function handle=colorbar(loc)
 */
static mxArray * Mcolorbar(int nargout_, mxArray * loc) {
    mxArray * handle = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * ax = mclGetUninitializedArray();
    mxArray * az = mclGetUninitializedArray();
    mxArray * cdatamapping = mclGetUninitializedArray();
    mxArray * ch = mclGetUninitializedArray();
    mxArray * changeNextPlot = mclGetUninitializedArray();
    mxArray * d = mclGetUninitializedArray();
    mxArray * edge = mclGetUninitializedArray();
    mxArray * el = mclGetUninitializedArray();
    mxArray * h = mclGetUninitializedArray();
    mxArray * hasimage = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * n = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mxArray * nargout = mclInitialize(mlfScalar(nargout_));
    mxArray * origNextPlot = mclGetUninitializedArray();
    mxArray * pos = mclGetUninitializedArray();
    mxArray * rect = mclGetUninitializedArray();
    mxArray * space = mclGetUninitializedArray();
    mxArray * stripe = mclGetUninitializedArray();
    mxArray * t = mclGetUninitializedArray();
    mxArray * typ = mclGetUninitializedArray();
    mxArray * ud = mclGetUninitializedArray();
    mxArray * units = mclGetUninitializedArray();
    mlfAssign(&nargin_, mlfNargin(0, loc, NULL));
    mclValidateInputs("colorbar", 1, &loc);
    mclCopyArray(&loc);
    /*
     * %COLORBAR Display color bar (color scale).
     * %   COLORBAR('vert') appends a vertical color scale to the current
     * %   axis. COLORBAR('horiz') appends a horizontal color scale.
     * %
     * %   COLORBAR(H) places the colorbar in the axes H. The colorbar will
     * %   be horizontal if the axes H width > height (in pixels).
     * %
     * %   COLORBAR without arguments either adds a new vertical color scale
     * %   or updates an existing colorbar.
     * %
     * %   H = COLORBAR(...) returns a handle to the colorbar axis.
     * 
     * %   Clay M. Thompson 10-9-92
     * %   Copyright (c) 1984-98 by The MathWorks, Inc.
     * %   $Revision: 5.31 $  $Date: 1998/07/24 18:08:03 $
     * 
     * %   If called with COLORBAR(H) or for an existing colorbar, don't change
     * %   the NextPlot property.
     * changeNextPlot = 1;
     */
    mlfAssign(&changeNextPlot, mlfScalar(1.0));
    /*
     * 
     * if nargin<1, loc = 'vert'; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(1.0)))) {
        mlfAssign(&loc, mxCreateString("vert"));
    }
    /*
     * 
     * % Catch colorbar('delete') special case -- must be called by the deleteFcn.
     * if nargin==1 & strcmp(loc,'delete'),
     */
    {
        mxArray * a_ = mclInitialize(mlfEq(nargin_, mlfScalar(1.0)));
        if (mlfTobool(a_)
            && mlfTobool(
                 mlfAnd(a_, mlfStrcmp(loc, mxCreateString("delete"))))) {
            mxDestroyArray(a_);
            /*
             * ax = gcbo;
             */
            mlfAssign(&ax, mlfNGcbo(1, NULL));
            /*
             * if strcmp(get(ax,'tag'),'TMW_COLORBAR'), ax=get(ax,'parent'); end
             */
            if (mlfTobool(
                  mlfStrcmp(
                    mlfGet(ax, mxCreateString("tag"), NULL),
                    mxCreateString("TMW_COLORBAR")))) {
                mlfAssign(&ax, mlfGet(ax, mxCreateString("parent"), NULL));
            }
            /*
             * ud = get(ax,'userdata');
             */
            mlfAssign(&ud, mlfGet(ax, mxCreateString("userdata"), NULL));
            /*
             * if isfield(ud,'PlotHandle') & ishandle(ud.PlotHandle) & ...
             */
            {
                mxArray * a_ = mclInitialize(
                                 mlfIsfield(ud, mxCreateString("PlotHandle")));
                if (mlfTobool(a_)) {
                    mlfAssign(
                      &a_,
                      mlfAnd(
                        a_,
                        mlfFeval(
                          mclValueVarargout(),
                          mlxIshandle,
                          mlfIndexRef(ud, ".PlotHandle"),
                          NULL)));
                } else {
                    mlfAssign(&a_, mlfScalar(0));
                }
                if (mlfTobool(a_)) {
                    mlfAssign(
                      &a_,
                      mlfAnd(a_, mlfIsfield(ud, mxCreateString("origPos"))));
                } else {
                    mlfAssign(&a_, mlfScalar(0));
                }
                if (mlfTobool(a_)
                    && mlfTobool(
                         mlfAnd(
                           a_,
                           mlfNot(
                             mlfFeval(
                               mclValueVarargout(),
                               mlxIsempty,
                               mlfIndexRef(ud, ".origPos"),
                               NULL))))) {
                    mxDestroyArray(a_);
                    /*
                     * isfield(ud,'origPos') & ~isempty(ud.origPos)
                     * units = get(ud.PlotHandle,'units');
                     */
                    mlfAssign(
                      &units,
                      mlfGet(
                        mlfIndexRef(ud, ".PlotHandle"),
                        mxCreateString("units"),
                        NULL));
                    /*
                     * set(ud.PlotHandle,'units','normalized');
                     */
                    mclAssignAns(
                      &ans,
                      mlfNSet(
                        0,
                        mlfIndexRef(ud, ".PlotHandle"),
                        mxCreateString("units"),
                        mxCreateString("normalized"),
                        NULL));
                    /*
                     * set(ud.PlotHandle,'position',ud.origPos);
                     */
                    mclAssignAns(
                      &ans,
                      mlfNSet(
                        0,
                        mlfIndexRef(ud, ".PlotHandle"),
                        mxCreateString("position"),
                        mlfIndexRef(ud, ".origPos"),
                        NULL));
                    /*
                     * set(ud.PlotHandle,'units',units);
                     */
                    mclAssignAns(
                      &ans,
                      mlfNSet(
                        0,
                        mlfIndexRef(ud, ".PlotHandle"),
                        mxCreateString("units"),
                        units,
                        NULL));
                } else {
                    mxDestroyArray(a_);
                }
            /*
             * end
             */
            }
            /*
             * if isfield(ud,'DeleteProxy') & ishandle(ud.DeleteProxy)
             */
            {
                mxArray * a_ = mclInitialize(
                                 mlfIsfield(ud, mxCreateString("DeleteProxy")));
                if (mlfTobool(a_)
                    && mlfTobool(
                         mlfAnd(
                           a_,
                           mlfFeval(
                             mclValueVarargout(),
                             mlxIshandle,
                             mlfIndexRef(ud, ".DeleteProxy"),
                             NULL)))) {
                    mxDestroyArray(a_);
                    /*
                     * delete(ud.DeleteProxy)
                     */
                    mlfDelete(mlfIndexRef(ud, ".DeleteProxy"), NULL);
                } else {
                    mxDestroyArray(a_);
                }
            /*
             * end
             */
            }
            /*
             * if ~isempty(legend)
             */
            if (mlfTobool(mlfNot(mlfIsempty(mlfNLegend(1, NULL, NULL))))) {
                /*
                 * legend % Update legend
                 */
                mclPrintAns(&ans, mlfNLegend(0, NULL, NULL));
            /*
             * end
             */
            }
            /*
             * return
             */
            goto return_;
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * ax = [];
     */
    mlfAssign(&ax, mclCreateEmptyArray());
    /*
     * if nargin==1,
     */
    if (mlfTobool(mlfEq(nargin_, mlfScalar(1.0)))) {
        /*
         * if ishandle(loc)
         */
        if (mlfTobool(mlfIshandle(loc))) {
            /*
             * ax = loc;
             */
            mlfAssign(&ax, loc);
            /*
             * if ~strcmp(get(ax,'type'),'axes'),
             */
            if (mlfTobool(
                  mlfNot(
                    mlfStrcmp(
                      mlfGet(ax, mxCreateString("type"), NULL),
                      mxCreateString("axes"))))) {
                /*
                 * error('Requires axes handle.');
                 */
                mlfError(mxCreateString("Requires axes handle."));
            /*
             * end
             */
            }
            /*
             * units = get(ax,'units'); set(ax,'units','pixels');
             */
            mlfAssign(&units, mlfGet(ax, mxCreateString("units"), NULL));
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                ax,
                mxCreateString("units"),
                mxCreateString("pixels"),
                NULL));
            /*
             * rect = get(ax,'position'); set(ax,'units',units)
             */
            mlfAssign(&rect, mlfGet(ax, mxCreateString("position"), NULL));
            mclPrintAns(
              &ans, mlfNSet(0, ax, mxCreateString("units"), units, NULL));
            /*
             * if rect(3) > rect(4), loc = 'horiz'; else loc = 'vert'; end
             */
            if (mlfTobool(
                  mlfGt(
                    mlfIndexRef(rect, "(?)", mlfScalar(3.0)),
                    mlfIndexRef(rect, "(?)", mlfScalar(4.0))))) {
                mlfAssign(&loc, mxCreateString("horiz"));
            } else {
                mlfAssign(&loc, mxCreateString("vert"));
            }
            /*
             * changeNextPlot = 0;
             */
            mlfAssign(&changeNextPlot, mlfScalar(0.0));
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * % Determine color limits by context.  If any axes child is an image
     * % use scale based on size of colormap, otherwise use current CAXIS.
     * 
     * ch = get(gcda,'children');
     */
    mlfAssign(
      &ch, mlfGet(mlfColorbar_gcda(), mxCreateString("children"), NULL));
    /*
     * hasimage = 0; t = [];
     */
    mlfAssign(&hasimage, mlfScalar(0.0));
    mlfAssign(&t, mclCreateEmptyArray());
    /*
     * cdatamapping = 'direct';
     */
    mlfAssign(&cdatamapping, mxCreateString("direct"));
    /*
     * 
     * for i=1:length(ch),
     */
    for (mclForStart(&iterator_0, mlfScalar(1.0), mlfLength(ch), NULL);
         mclForNext(&iterator_0, &i);
         ) {
        /*
         * typ = get(ch(i),'type');
         */
        mlfAssign(
          &typ,
          mlfGet(mlfIndexRef(ch, "(?)", i), mxCreateString("type"), NULL));
        /*
         * if strcmp(typ,'image'),
         */
        if (mlfTobool(mlfStrcmp(typ, mxCreateString("image")))) {
            /*
             * hasimage = 1;
             */
            mlfAssign(&hasimage, mlfScalar(1.0));
            /*
             * cdatamapping = get(ch(i), 'CDataMapping');
             */
            mlfAssign(
              &cdatamapping,
              mlfGet(
                mlfIndexRef(ch, "(?)", i),
                mxCreateString("CDataMapping"),
                NULL));
        /*
         * elseif strcmp(typ,'surface') & ...
         */
        } else {
            mxArray * a_ = mclInitialize(
                             mlfStrcmp(typ, mxCreateString("surface")));
            if (mlfTobool(a_)
                && mlfTobool(
                     mlfAnd(
                       a_,
                       mlfStrcmp(
                         mlfGet(
                           mlfIndexRef(ch, "(?)", i),
                           mxCreateString("FaceColor"),
                           NULL),
                         mxCreateString("texturemap"))))) {
                mxDestroyArray(a_);
                /*
                 * strcmp(get(ch(i),'FaceColor'),'texturemap') % Texturemapped surf
                 * hasimage = 2;
                 */
                mlfAssign(&hasimage, mlfScalar(2.0));
                /*
                 * cdatamapping = get(ch(i), 'CDataMapping');
                 */
                mlfAssign(
                  &cdatamapping,
                  mlfGet(
                    mlfIndexRef(ch, "(?)", i),
                    mxCreateString("CDataMapping"),
                    NULL));
            /*
             * elseif strcmp(typ,'patch') | strcmp(typ,'surface')
             */
            } else {
                mxDestroyArray(a_);
                {
                    mxArray * a_ = mclInitialize(
                                     mlfStrcmp(typ, mxCreateString("patch")));
                    if (mlfTobool(a_)
                        || mlfTobool(
                             mlfOr(
                               a_,
                               mlfStrcmp(typ, mxCreateString("surface"))))) {
                        mxDestroyArray(a_);
                        /*
                         * cdatamapping = get(ch(i), 'CDataMapping');
                         */
                        mlfAssign(
                          &cdatamapping,
                          mlfGet(
                            mlfIndexRef(ch, "(?)", i),
                            mxCreateString("CDataMapping"),
                            NULL));
                    } else {
                        mxDestroyArray(a_);
                    }
                }
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * if ( strcmp(cdatamapping, 'scaled') )
     */
    if (mlfTobool(mlfStrcmp(cdatamapping, mxCreateString("scaled")))) {
        /*
         * % Treat images and surfaces alike if cdatamapping == 'scaled'
         * t = caxis;
         */
        mlfAssign(&t, mlfNCaxis(1, NULL, NULL));
        /*
         * d = (t(2) - t(1))/size(colormap,1);
         */
        mlfAssign(
          &d,
          mlfMrdivide(
            mlfMinus(
              mlfIndexRef(t, "(?)", mlfScalar(2.0)),
              mlfIndexRef(t, "(?)", mlfScalar(1.0))),
            mlfSize(mclValueVarargout(), mlfColormap(NULL), mlfScalar(1.0))));
        /*
         * t = [t(1)+d/2  t(2)-d/2];
         */
        mlfAssign(
          &t,
          mlfHorzcat(
            mlfPlus(
              mlfIndexRef(t, "(?)", mlfScalar(1.0)),
              mlfMrdivide(d, mlfScalar(2.0))),
            mlfMinus(
              mlfIndexRef(t, "(?)", mlfScalar(2.0)),
              mlfMrdivide(d, mlfScalar(2.0))),
            NULL));
    /*
     * else
     */
    } else {
        /*
         * if hasimage,
         */
        if (mlfTobool(hasimage)) {
            /*
             * t = [1, size(colormap,1)]; 
             */
            mlfAssign(
              &t,
              mlfHorzcat(
                mlfScalar(1.0),
                mlfSize(mclValueVarargout(), mlfColormap(NULL), mlfScalar(1.0)),
                NULL));
        /*
         * else
         */
        } else {
            /*
             * t = [1.5  size(colormap,1)+.5];
             */
            mlfAssign(
              &t,
              mlfHorzcat(
                mlfScalar(1.5),
                mlfPlus(
                  mlfSize(
                    mclValueVarargout(), mlfColormap(NULL), mlfScalar(1.0)),
                  mlfScalar(.5)),
                NULL));
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * h = gcda;
     */
    mlfAssign(&h, mlfColorbar_gcda());
    /*
     * 
     * if nargin==0,
     */
    if (mlfTobool(mlfEq(nargin_, mlfScalar(0.0)))) {
        /*
         * % Search for existing colorbar
         * ch = get(findobj(gcf,'type','image','tag','TMW_COLORBAR'),{'parent'}); ax = [];
         */
        mlfAssign(
          &ch,
          mlfGet(
            mlfFindobj(
              mlfGcf(),
              mxCreateString("type"),
              mxCreateString("image"),
              mxCreateString("tag"),
              mxCreateString("TMW_COLORBAR"),
              NULL),
            mlfCellhcat(mxCreateString("parent"), NULL),
            NULL));
        mlfAssign(&ax, mclCreateEmptyArray());
        /*
         * for i=1:length(ch),
         */
        for (mclForStart(&iterator_0, mlfScalar(1.0), mlfLength(ch), NULL);
             mclForNext(&iterator_0, &i);
             ) {
            /*
             * ud = get(ch{i},'userdata');
             */
            mlfAssign(
              &ud,
              mlfGet(
                mlfIndexRef(ch, "{?}", i), mxCreateString("userdata"), NULL));
            /*
             * d = ud.PlotHandle;
             */
            mlfAssign(&d, mlfIndexRef(ud, ".PlotHandle"));
            /*
             * if prod(size(d))==1 & isequal(d,h), 
             */
            {
                mxArray * a_ = mclInitialize(
                                 mlfEq(
                                   mlfProd(
                                     mlfSize(mclValueVarargout(), d, NULL),
                                     NULL),
                                   mlfScalar(1.0)));
                if (mlfTobool(a_)
                    && mlfTobool(mlfAnd(a_, mlfIsequal(d, h, NULL)))) {
                    mxDestroyArray(a_);
                    /*
                     * ax = ch{i}; 
                     */
                    mlfAssign(&ax, mlfIndexRef(ch, "{?}", i));
                    /*
                     * pos = get(ch{i},'Position');
                     */
                    mlfAssign(
                      &pos,
                      mlfGet(
                        mlfIndexRef(ch, "{?}", i),
                        mxCreateString("Position"),
                        NULL));
                    /*
                     * if pos(3)<pos(4), loc = 'vert'; else loc = 'horiz'; end
                     */
                    if (mlfTobool(
                          mlfLt(
                            mlfIndexRef(pos, "(?)", mlfScalar(3.0)),
                            mlfIndexRef(pos, "(?)", mlfScalar(4.0))))) {
                        mlfAssign(&loc, mxCreateString("vert"));
                    } else {
                        mlfAssign(&loc, mxCreateString("horiz"));
                    }
                    /*
                     * changeNextPlot = 0;
                     */
                    mlfAssign(&changeNextPlot, mlfScalar(0.0));
                    /*
                     * % Make sure image deletefcn doesn't trigger a colorbar('delete')
                     * % for colorbar update
                     * set(get(ax,'children'),'deletefcn','')
                     */
                    mclPrintAns(
                      &ans,
                      mlfNSet(
                        0,
                        mlfGet(ax, mxCreateString("children"), NULL),
                        mxCreateString("deletefcn"),
                        mxCreateString(""),
                        NULL));
                    /*
                     * break; 
                     */
                    mclDestroyForLoopIterator(&iterator_0);
                    break;
                } else {
                    mxDestroyArray(a_);
                }
            /*
             * end
             */
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * origNextPlot = get(gcf,'NextPlot');
     */
    mlfAssign(
      &origNextPlot, mlfGet(mlfGcf(), mxCreateString("NextPlot"), NULL));
    /*
     * if strcmp(origNextPlot,'replacechildren') | strcmp(origNextPlot,'replace'),
     */
    {
        mxArray * a_ = mclInitialize(
                         mlfStrcmp(
                           origNextPlot, mxCreateString("replacechildren")));
        if (mlfTobool(a_)
            || mlfTobool(
                 mlfOr(
                   a_, mlfStrcmp(origNextPlot, mxCreateString("replace"))))) {
            mxDestroyArray(a_);
            /*
             * set(gcf,'NextPlot','add')
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                mlfGcf(),
                mxCreateString("NextPlot"),
                mxCreateString("add"),
                NULL));
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * if loc(1)=='v', % Append vertical scale to right of current plot
     */
    if (mlfTobool(
          mlfEq(
            mlfIndexRef(loc, "(?)", mlfScalar(1.0)), mxCreateString("v")))) {
        /*
         * 
         * if isempty(ax),
         */
        if (mlfTobool(mlfIsempty(ax))) {
            /*
             * units = get(h,'units'); set(h,'units','normalized')
             */
            mlfAssign(&units, mlfGet(h, mxCreateString("units"), NULL));
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                h,
                mxCreateString("units"),
                mxCreateString("normalized"),
                NULL));
            /*
             * pos = get(h,'Position'); 
             */
            mlfAssign(&pos, mlfGet(h, mxCreateString("Position"), NULL));
            /*
             * [az,el] = view;
             */
            mlfAssign(&az, mlfNView(2, &el, NULL, NULL));
            /*
             * stripe = 0.075; edge = 0.02; 
             */
            mlfAssign(&stripe, mlfScalar(0.075));
            mlfAssign(&edge, mlfScalar(0.02));
            /*
             * if all([az,el]==[0 90]), space = 0.05; else space = .1; end
             */
            if (mlfTobool(
                  mlfAll(
                    mlfEq(
                      mlfHorzcat(az, el, NULL),
                      mlfDoubleMatrix(1, 2, __Array0_r, NULL)),
                    NULL))) {
                mlfAssign(&space, mlfScalar(0.05));
            } else {
                mlfAssign(&space, mlfScalar(.1));
            }
            /*
             * set(h,'Position',[pos(1) pos(2) pos(3)*(1-stripe-edge-space) pos(4)])
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                h,
                mxCreateString("Position"),
                mlfHorzcat(
                  mlfIndexRef(pos, "(?)", mlfScalar(1.0)),
                  mlfIndexRef(pos, "(?)", mlfScalar(2.0)),
                  mlfMtimes(
                    mlfIndexRef(pos, "(?)", mlfScalar(3.0)),
                    mlfMinus(
                      mlfMinus(mlfMinus(mlfScalar(1.0), stripe), edge), space)),
                  mlfIndexRef(pos, "(?)", mlfScalar(4.0)),
                  NULL),
                NULL));
            /*
             * rect = [pos(1)+(1-stripe-edge)*pos(3) pos(2) stripe*pos(3) pos(4)];
             */
            mlfAssign(
              &rect,
              mlfHorzcat(
                mlfPlus(
                  mlfIndexRef(pos, "(?)", mlfScalar(1.0)),
                  mlfMtimes(
                    mlfMinus(mlfMinus(mlfScalar(1.0), stripe), edge),
                    mlfIndexRef(pos, "(?)", mlfScalar(3.0)))),
                mlfIndexRef(pos, "(?)", mlfScalar(2.0)),
                mlfMtimes(stripe, mlfIndexRef(pos, "(?)", mlfScalar(3.0))),
                mlfIndexRef(pos, "(?)", mlfScalar(4.0)),
                NULL));
            /*
             * ud.origPos = pos;
             */
            mlfIndexAssign(&ud, ".origPos", pos);
            /*
             * 
             * % Create axes for stripe and
             * % create DeleteProxy object (an invisible text object in
             * % the target axes) so that the colorbar will be deleted
             * % properly.
             * ud.DeleteProxy = text('parent',h,'visible','off',...
             */
            mlfIndexAssign(
              &ud,
              ".DeleteProxy",
              mlfNText(
                1,
                mxCreateString("parent"),
                h,
                mxCreateString("visible"),
                mxCreateString("off"),
                mxCreateString("tag"),
                mxCreateString("ColorbarDeleteProxy"),
                mxCreateString("handlevisibility"),
                mxCreateString("off"),
                mxCreateString("deletefcn"),
                mxCreateString("eval('delete(get(gcbo,''userdata''))','')"),
                NULL));
            /*
             * 'tag','ColorbarDeleteProxy',...
             * 'handlevisibility','off',...
             * 'deletefcn','eval(''delete(get(gcbo,''''userdata''''))'','''')');
             * ax = axes('Position', rect);
             */
            mlfAssign(&ax, mlfNAxes(1, mxCreateString("Position"), rect, NULL));
            /*
             * setappdata(ax,'NonDataObject',[]); % For DATACHILDREN.M
             */
            mlfSetappdata(
              ax, mxCreateString("NonDataObject"), mclCreateEmptyArray(), NULL);
            /*
             * set(ud.DeleteProxy,'userdata',ax)
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                mlfIndexRef(ud, ".DeleteProxy"),
                mxCreateString("userdata"),
                ax,
                NULL));
            /*
             * set(h,'units',units)
             */
            mclPrintAns(
              &ans, mlfNSet(0, h, mxCreateString("units"), units, NULL));
        /*
         * else
         */
        } else {
            /*
             * axes(ax);
             */
            mclAssignAns(&ans, mlfNAxes(0, ax, NULL));
            /*
             * ud = get(ax,'userdata');
             */
            mlfAssign(&ud, mlfGet(ax, mxCreateString("userdata"), NULL));
        /*
         * end
         */
        }
        /*
         * 
         * % Create color stripe
         * n = size(colormap,1);
         */
        mlfAssign(
          &n, mlfSize(mclValueVarargout(), mlfColormap(NULL), mlfScalar(1.0)));
        /*
         * image([0 1],t,(1:n)','Tag','TMW_COLORBAR','deletefcn','colorbar(''delete'')'); set(ax,'Ydir','normal')
         */
        mclAssignAns(
          &ans,
          mlfNImage(
            0,
            mlfDoubleMatrix(1, 2, __Array1_r, NULL),
            t,
            mlfCtranspose(mlfColon(mlfScalar(1.0), n, NULL)),
            mxCreateString("Tag"),
            mxCreateString("TMW_COLORBAR"),
            mxCreateString("deletefcn"),
            mxCreateString("colorbar('delete')"),
            NULL));
        mclPrintAns(
          &ans,
          mlfNSet(
            0, ax, mxCreateString("Ydir"), mxCreateString("normal"), NULL));
        /*
         * set(ax,'YAxisLocation','right')
         */
        mclPrintAns(
          &ans,
          mlfNSet(
            0,
            ax,
            mxCreateString("YAxisLocation"),
            mxCreateString("right"),
            NULL));
        /*
         * set(ax,'xtick',[])
         */
        mclPrintAns(
          &ans,
          mlfNSet(0, ax, mxCreateString("xtick"), mclCreateEmptyArray(), NULL));
        /*
         * 
         * % set up axes deletefcn
         * set(ax,'tag','Colorbar','deletefcn','colorbar(''delete'')')
         */
        mclPrintAns(
          &ans,
          mlfNSet(
            0,
            ax,
            mxCreateString("tag"),
            mxCreateString("Colorbar"),
            mxCreateString("deletefcn"),
            mxCreateString("colorbar('delete')"),
            NULL));
    /*
     * 
     * elseif loc(1)=='h', % Append horizontal scale to top of current plot
     */
    } else if (mlfTobool(
                 mlfEq(
                   mlfIndexRef(loc, "(?)", mlfScalar(1.0)),
                   mxCreateString("h")))) {
        /*
         * 
         * if isempty(ax),
         */
        if (mlfTobool(mlfIsempty(ax))) {
            /*
             * units = get(h,'units'); set(h,'units','normalized')
             */
            mlfAssign(&units, mlfGet(h, mxCreateString("units"), NULL));
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                h,
                mxCreateString("units"),
                mxCreateString("normalized"),
                NULL));
            /*
             * pos = get(h,'Position');
             */
            mlfAssign(&pos, mlfGet(h, mxCreateString("Position"), NULL));
            /*
             * stripe = 0.075; space = 0.1;
             */
            mlfAssign(&stripe, mlfScalar(0.075));
            mlfAssign(&space, mlfScalar(0.1));
            /*
             * set(h,'Position',...
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                h,
                mxCreateString("Position"),
                mlfHorzcat(
                  mlfIndexRef(pos, "(?)", mlfScalar(1.0)),
                  mlfPlus(
                    mlfIndexRef(pos, "(?)", mlfScalar(2.0)),
                    mlfMtimes(
                      mlfPlus(stripe, space),
                      mlfIndexRef(pos, "(?)", mlfScalar(4.0)))),
                  mlfIndexRef(pos, "(?)", mlfScalar(3.0)),
                  mlfMtimes(
                    mlfMinus(mlfMinus(mlfScalar(1.0), stripe), space),
                    mlfIndexRef(pos, "(?)", mlfScalar(4.0))),
                  NULL),
                NULL));
            /*
             * [pos(1) pos(2)+(stripe+space)*pos(4) pos(3) (1-stripe-space)*pos(4)])
             * rect = [pos(1) pos(2) pos(3) stripe*pos(4)];
             */
            mlfAssign(
              &rect,
              mlfHorzcat(
                mlfIndexRef(pos, "(?)", mlfScalar(1.0)),
                mlfIndexRef(pos, "(?)", mlfScalar(2.0)),
                mlfIndexRef(pos, "(?)", mlfScalar(3.0)),
                mlfMtimes(stripe, mlfIndexRef(pos, "(?)", mlfScalar(4.0))),
                NULL));
            /*
             * ud.origPos = pos;
             */
            mlfIndexAssign(&ud, ".origPos", pos);
            /*
             * 
             * % Create axes for stripe and
             * % create DeleteProxy object (an invisible text object in
             * % the target axes) so that the colorbar will be deleted
             * % properly.
             * ud.DeleteProxy = text('parent',h,'visible','off',...
             */
            mlfIndexAssign(
              &ud,
              ".DeleteProxy",
              mlfNText(
                1,
                mxCreateString("parent"),
                h,
                mxCreateString("visible"),
                mxCreateString("off"),
                mxCreateString("tag"),
                mxCreateString("ColorbarDeleteProxy"),
                mxCreateString("handlevisibility"),
                mxCreateString("off"),
                mxCreateString("deletefcn"),
                mxCreateString("eval('delete(get(gcbo,''userdata''))','')"),
                NULL));
            /*
             * 'tag','ColorbarDeleteProxy',...
             * 'handlevisibility','off',...
             * 'deletefcn','eval(''delete(get(gcbo,''''userdata''''))'','''')');
             * ax = axes('Position', rect);
             */
            mlfAssign(&ax, mlfNAxes(1, mxCreateString("Position"), rect, NULL));
            /*
             * setappdata(ax,'NonDataObject',[]); % For DATACHILDREN.M
             */
            mlfSetappdata(
              ax, mxCreateString("NonDataObject"), mclCreateEmptyArray(), NULL);
            /*
             * set(ud.DeleteProxy,'userdata',ax)
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                mlfIndexRef(ud, ".DeleteProxy"),
                mxCreateString("userdata"),
                ax,
                NULL));
            /*
             * set(h,'units',units)
             */
            mclPrintAns(
              &ans, mlfNSet(0, h, mxCreateString("units"), units, NULL));
        /*
         * else
         */
        } else {
            /*
             * axes(ax);
             */
            mclAssignAns(&ans, mlfNAxes(0, ax, NULL));
            /*
             * ud = get(ax,'userdata');
             */
            mlfAssign(&ud, mlfGet(ax, mxCreateString("userdata"), NULL));
        /*
         * end
         */
        }
        /*
         * 
         * % Create color stripe
         * n = size(colormap,1);
         */
        mlfAssign(
          &n, mlfSize(mclValueVarargout(), mlfColormap(NULL), mlfScalar(1.0)));
        /*
         * image(t,[0 1],(1:n),'Tag','TMW_COLORBAR','deletefcn','colorbar(''delete'')'); set(ax,'Ydir','normal')
         */
        mclAssignAns(
          &ans,
          mlfNImage(
            0,
            t,
            mlfDoubleMatrix(1, 2, __Array2_r, NULL),
            mlfColon(mlfScalar(1.0), n, NULL),
            mxCreateString("Tag"),
            mxCreateString("TMW_COLORBAR"),
            mxCreateString("deletefcn"),
            mxCreateString("colorbar('delete')"),
            NULL));
        mclPrintAns(
          &ans,
          mlfNSet(
            0, ax, mxCreateString("Ydir"), mxCreateString("normal"), NULL));
        /*
         * set(ax,'ytick',[])
         */
        mclPrintAns(
          &ans,
          mlfNSet(0, ax, mxCreateString("ytick"), mclCreateEmptyArray(), NULL));
        /*
         * 
         * % set up axes deletefcn
         * set(ax,'tag','Colorbar','deletefcn','colorbar(''delete'')')
         */
        mclPrintAns(
          &ans,
          mlfNSet(
            0,
            ax,
            mxCreateString("tag"),
            mxCreateString("Colorbar"),
            mxCreateString("deletefcn"),
            mxCreateString("colorbar('delete')"),
            NULL));
    /*
     * 
     * else
     */
    } else {
        /*
         * error('COLORBAR expects a handle, ''vert'', or ''horiz'' as input.')
         */
        mlfError(
          mxCreateString(
            "COLORBAR expects a handle, 'vert', or 'horiz' as input."));
    /*
     * end
     */
    }
    /*
     * 
     * if ~isfield(ud,'DeleteProxy'), ud.DeleteProxy = []; end
     */
    if (mlfTobool(mlfNot(mlfIsfield(ud, mxCreateString("DeleteProxy"))))) {
        mlfIndexAssign(&ud, ".DeleteProxy", mclCreateEmptyArray());
    }
    /*
     * if ~isfield(ud,'origPos'), ud.origPos = []; end
     */
    if (mlfTobool(mlfNot(mlfIsfield(ud, mxCreateString("origPos"))))) {
        mlfIndexAssign(&ud, ".origPos", mclCreateEmptyArray());
    }
    /*
     * ud.PlotHandle = h;
     */
    mlfIndexAssign(&ud, ".PlotHandle", h);
    /*
     * set(ax,'userdata',ud)
     */
    mclPrintAns(&ans, mlfNSet(0, ax, mxCreateString("userdata"), ud, NULL));
    /*
     * axes(h)
     */
    mclPrintAns(&ans, mlfNAxes(0, h, NULL));
    /*
     * set(gcf,'NextPlot',origNextPlot)
     */
    mclPrintAns(
      &ans,
      mlfNSet(0, mlfGcf(), mxCreateString("NextPlot"), origNextPlot, NULL));
    /*
     * if ~isempty(legend)
     */
    if (mlfTobool(mlfNot(mlfIsempty(mlfNLegend(1, NULL, NULL))))) {
        /*
         * legend % Update legend
         */
        mclPrintAns(&ans, mlfNLegend(0, NULL, NULL));
    /*
     * end
     */
    }
    /*
     * if nargout>0, handle = ax; end
     */
    if (mlfTobool(mlfGt(nargout, mlfScalar(0.0)))) {
        mlfAssign(&handle, ax);
    }
    /*
     * 
     * %--------------------------------
     * function h = gcda
     */
    return_:
    mclValidateOutputs("colorbar", 1, nargout_, &handle);
    mxDestroyArray(ans);
    mxDestroyArray(ax);
    mxDestroyArray(az);
    mxDestroyArray(cdatamapping);
    mxDestroyArray(ch);
    mxDestroyArray(changeNextPlot);
    mxDestroyArray(d);
    mxDestroyArray(edge);
    mxDestroyArray(el);
    mxDestroyArray(h);
    mxDestroyArray(hasimage);
    mxDestroyArray(i);
    mxDestroyArray(loc);
    mxDestroyArray(n);
    mxDestroyArray(nargin_);
    mxDestroyArray(nargout);
    mxDestroyArray(origNextPlot);
    mxDestroyArray(pos);
    mxDestroyArray(rect);
    mxDestroyArray(space);
    mxDestroyArray(stripe);
    mxDestroyArray(t);
    mxDestroyArray(typ);
    mxDestroyArray(ud);
    mxDestroyArray(units);
    /*
     * %GCDA Get current data axes
     * 
     * h = datachildren(gcf);
     * if isempty(h) | any(h == gca)
     * h = gca;
     * else
     * h = h(1);
     * end
     * 
     */
    return handle;
}

/*
 * The function "mlfNColorbar" contains the nargout interface for the
 * "colorbar" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines 1-209). This
 * interface is only produced if the M-function uses the special variable
 * "nargout". The nargout interface allows the number of requested outputs to
 * be specified via the nargout argument, as opposed to the normal interface
 * which dynamically calculates the number of outputs based on the number of
 * non-NULL inputs it receives. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
mxArray * mlfNColorbar(int nargout, mxArray * loc) {
    mxArray * handle = mclGetUninitializedArray();
    mlfEnterNewContext(0, 1, loc);
    handle = Mcolorbar(nargout, loc);
    mlfRestorePreviousContext(0, 1, loc);
    return mlfReturnValue(handle);
}

/*
 * The function "mlfColorbar" contains the normal interface for the "colorbar"
 * M-function from file "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines
 * 1-209). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfColorbar(mxArray * loc) {
    int nargout = 1;
    mxArray * handle = mclGetUninitializedArray();
    mlfEnterNewContext(0, 1, loc);
    handle = Mcolorbar(nargout, loc);
    mlfRestorePreviousContext(0, 1, loc);
    return mlfReturnValue(handle);
}

/*
 * The function "mlfVColorbar" contains the void interface for the "colorbar"
 * M-function from file "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines
 * 1-209). The void interface is only produced if the M-function uses the
 * special variable "nargout", and has at least one output. The void interface
 * function specifies zero output arguments to the implementation version of
 * the function, and in the event that the implementation version still returns
 * an output (which, in MATLAB, would be assigned to the "ans" variable), it
 * deallocates the output. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlfVColorbar(mxArray * loc) {
    mxArray * handle = mclUnassigned();
    mlfEnterNewContext(0, 1, loc);
    handle = Mcolorbar(0, loc);
    mlfRestorePreviousContext(0, 1, loc);
    mxDestroyArray(handle);
}

/*
 * The function "mlxColorbar" contains the feval interface for the "colorbar"
 * M-function from file "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines
 * 1-209). The feval function calls the implementation version of colorbar
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxColorbar(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: colorbar Line: 1 Column:"
            " 0 The function \"colorbar\" was called with m"
            "ore than the declared number of outputs (1)"));
    }
    if (nrhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: colorbar Line: 1 Column:"
            " 0 The function \"colorbar\" was called with m"
            "ore than the declared number of inputs (1)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mplhs[0] = Mcolorbar(nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mcolorbar_gcda" is the implementation version of the
 * "colorbar/gcda" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines 209-219). It
 * contains the actual compiled code for that M-function. It is a static
 * function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function h = gcda
 */
static mxArray * Mcolorbar_gcda(int nargout_) {
    mxArray * h = mclGetUninitializedArray();
    /*
     * %GCDA Get current data axes
     * 
     * h = datachildren(gcf);
     */
    mlfAssign(&h, mlfDatachildren(mlfGcf()));
    /*
     * if isempty(h) | any(h == gca)
     */
    {
        mxArray * a_ = mclInitialize(mlfIsempty(h));
        if (mlfTobool(a_)
            || mlfTobool(mlfOr(a_, mlfAny(mlfEq(h, mlfGca(NULL)), NULL)))) {
            mxDestroyArray(a_);
            /*
             * h = gca;
             */
            mlfAssign(&h, mlfGca(NULL));
        /*
         * else
         */
        } else {
            mxDestroyArray(a_);
            /*
             * h = h(1);
             */
            mlfAssign(&h, mlfIndexRef(h, "(?)", mlfScalar(1.0)));
        }
    /*
     * end
     */
    }
    mclValidateOutputs("colorbar/gcda", 1, nargout_, &h);
    /*
     * 
     */
    return h;
}

/*
 * The function "mlfColorbar_gcda" contains the normal interface for the
 * "colorbar/gcda" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines 209-219). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
static mxArray * mlfColorbar_gcda(void) {
    int nargout = 1;
    mxArray * h = mclGetUninitializedArray();
    mlfEnterNewContext(0, 0);
    h = Mcolorbar_gcda(nargout);
    mlfRestorePreviousContext(0, 0);
    return mlfReturnValue(h);
}

/*
 * The function "mlxColorbar_gcda" contains the feval interface for the
 * "colorbar/gcda" M-function from file
 * "C:\MATLABR11\toolbox\matlab\graph3d\colorbar.m" (lines 209-219). The feval
 * function calls the implementation version of colorbar/gcda through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxColorbar_gcda(int nlhs,
                             mxArray * plhs[],
                             int nrhs,
                             mxArray * prhs[]) {
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: colorbar/gcda Line: 209 Colu"
            "mn: 0 The function \"colorbar/gcda\" was called wi"
            "th more than the declared number of outputs (1)"));
    }
    if (nrhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: colorbar/gcda Line: 209 Colu"
            "mn: 0 The function \"colorbar/gcda\" was called wi"
            "th more than the declared number of inputs (0)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mplhs[0] = Mcolorbar_gcda(nlhs);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
}
