/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:21 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "listdlg.h"

static double __Array0_r[2] = { 160.0, 300.0 };

static double __Array1_r[2] = { 3.0, 4.0 };

/*
 * The function "Mlistdlg" is the implementation version of the "listdlg"
 * M-function from file "C:\MATLABR11\toolbox\matlab\uitools\listdlg.m" (lines
 * 1-225). It contains the actual compiled code for that M-function. It is a
 * static function and must only be called from one of the interface functions,
 * appearing below.
 */
/*
 * function [selection,value] = listdlg(varargin)
 */
static mxArray * Mlistdlg(mxArray * * value, int nargout_, mxArray * varargin) {
    mxArray * selection = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * btn_wid = mclGetUninitializedArray();
    mxArray * cancel_btn = mclGetUninitializedArray();
    mxArray * cancelstring = mclGetUninitializedArray();
    mxArray * ex = mclGetUninitializedArray();
    mxArray * ffs = mclGetUninitializedArray();
    mxArray * fig = mclGetUninitializedArray();
    mxArray * fig_props = mclGetUninitializedArray();
    mxArray * figname = mclGetUninitializedArray();
    mxArray * fp = mclGetUninitializedArray();
    mxArray * fus = mclGetUninitializedArray();
    mxArray * h = mclGetUninitializedArray();
    mxArray * i = mclGetUninitializedArray();
    mxArray * initialvalue = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * listbox = mclGetUninitializedArray();
    mxArray * listsize = mclGetUninitializedArray();
    mxArray * liststring = mclGetUninitializedArray();
    mxArray * ok_btn = mclGetUninitializedArray();
    mxArray * okstring = mclGetUninitializedArray();
    mxArray * prompt_text = mclGetUninitializedArray();
    mxArray * promptstring = mclGetUninitializedArray();
    mxArray * s = mclGetUninitializedArray();
    mxArray * selectall_btn = mclGetUninitializedArray();
    mxArray * smode = mclGetUninitializedArray();
    mxArray * stype = mclGetUninitializedArray();
    mxArray * uh = mclGetUninitializedArray();
    mxArray * v = mclGetUninitializedArray();
    mxArray * w = mclGetUninitializedArray();
    /*
     * %LISTDLG  List selection dialog box.
     * %   [SELECTION,OK] = LISTDLG('ListString',S) creates a modal dialog box 
     * %   which allows you to select a string or multiple strings from a list.
     * %   SELECTION is a vector of indices of the selected strings (length 1
     * %   in the single selection mode).  Can be [] on the Mac, and will be []
     * %   when OK is 0.
     * %   OK is 1 if you push the OK button, or 0 if you push the Cancel 
     * %   button or close the figure.
     * %   Double-clicking on an item or pressing <CR> when multiple items are
     * %   selected has the same effect as clicking the OK button.
     * %
     * %   Inputs are in parameter,value pairs:
     * %
     * %   Parameter       Description
     * %   'ListString'    cell array of strings for the list box.
     * %   'SelectionMode' string; can be 'single' or 'multiple'; defaults to
     * %                   'multiple'.
     * %   'ListSize'      [width height] of listbox in pixels; defaults
     * %                   to [160 300].
     * %   'InitialValue'  vector of indices of which items of the list box
     * %                   are initially selected; defaults to the first item.
     * %   'Name'          String for the figure's title. Defaults to ''.
     * %   'PromptString'  string matrix or cell array of strings which appears 
     * %                   as text above the list box.  Defaults to {}.
     * %   'OKString'      string for the OK button; defaults to 'OK'.
     * %   'CancelString'  string for the Cancel button; defaults to 'Cancel'.
     * %   'uh'            uicontrol button height, in pixels; default = 18.
     * %   'fus'           frame/uicontrol spacing, in pixels; default = 8.
     * %   'ffs'           frame/figure spacing, in pixels; default = 8.
     * %
     * %   A 'Select all' button is provided in the multiple selection case.
     * %
     * %   Example:
     * %     d = dir;
     * %     str = {d.name};
     * %     [s,v] = listdlg('PromptString','Select a file:',...
     * %                     'SelectionMode','single',...
     * %                     'ListString',str)
     * 
     * %   T. Krauss, 12/7/95, P.N. Secakusuma, 6/10/97
     * %   Copyright (c) 1984-98 by The MathWorks, Inc.
     * %   $Revision: 1.13 $  $Date: 1998/03/26 12:59:11 $
     * 
     * % if first input is an integer, dispatch to callbacks:
     * % listdlg(0) - OK button callback
     * % listdlg(1) - cancel button callback
     * % listdlg(2) - select all button callback
     * % listdlg(4) - double-click to choose the entry  (Addition by PNS)
     * 
     * if isstr(varargin{1})
     */
    if (mlfTobool(
          mlfFeval(
            mclValueVarargout(),
            mlxIsstr,
            mlfIndexRef(varargin, "{?}", mlfScalar(1.0)),
            NULL))) {
        /*
         * figname = '';
         */
        mlfAssign(&figname, mxCreateString(""));
        /*
         * smode = 2;   % (multiple)
         */
        mlfAssign(&smode, mlfScalar(2.0));
        /*
         * promptstring = {};
         */
        mlfAssign(&promptstring, mclCreateEmptyCell());
        /*
         * listsize = [160 300];
         */
        mlfAssign(&listsize, mlfDoubleMatrix(1, 2, __Array0_r, NULL));
        /*
         * initialvalue = [];
         */
        mlfAssign(&initialvalue, mclCreateEmptyArray());
        /*
         * okstring = 'Ok';
         */
        mlfAssign(&okstring, mxCreateString("Ok"));
        /*
         * cancelstring = 'Cancel';
         */
        mlfAssign(&cancelstring, mxCreateString("Cancel"));
        /*
         * fus = 8;
         */
        mlfAssign(&fus, mlfScalar(8.0));
        /*
         * ffs = 8;
         */
        mlfAssign(&ffs, mlfScalar(8.0));
        /*
         * uh = 18;
         */
        mlfAssign(&uh, mlfScalar(18.0));
        /*
         * 
         * for i=1:2:length(varargin)
         */
        for (mclForStart(
               &iterator_0,
               mlfScalar(1.0),
               mlfScalar(2.0),
               mlfLength(varargin));
             mclForNext(&iterator_0, &i);
             ) {
            /*
             * 
             * switch lower(varargin{i})
             */
            mxArray * t_ = mclUnassigned();
            mlfAssign(
              &t_,
              mlfFeval(
                mclValueVarargout(),
                mlxLower,
                mlfIndexRef(varargin, "{?}", i),
                NULL));
            /*
             * case 'name'
             */
            if (mclSwitchCompare(t_, mxCreateString("name"))) {
                /*
                 * figname = varargin{i+1};
                 */
                mlfAssign(
                  &figname,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'promptstring'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("promptstring"))) {
                /*
                 * promptstring = varargin{i+1};
                 */
                mlfAssign(
                  &promptstring,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'selectionmode'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("selectionmode"))) {
                /*
                 * switch lower(varargin{i+1})
                 */
                mxArray * t_ = mclUnassigned();
                mlfAssign(
                  &t_,
                  mlfFeval(
                    mclValueVarargout(),
                    mlxLower,
                    mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))),
                    NULL));
                /*
                 * case 'single'
                 */
                if (mclSwitchCompare(t_, mxCreateString("single"))) {
                    /*
                     * smode = 1;
                     */
                    mlfAssign(&smode, mlfScalar(1.0));
                /*
                 * case 'multiple'
                 */
                } else if (mclSwitchCompare(t_, mxCreateString("multiple"))) {
                    /*
                     * smode = 2;
                     */
                    mlfAssign(&smode, mlfScalar(2.0));
                /*
                 * end
                 */
                }
                mxDestroyArray(t_);
            /*
             * case 'listsize'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("listsize"))) {
                /*
                 * listsize = varargin{i+1};
                 */
                mlfAssign(
                  &listsize,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'liststring'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("liststring"))) {
                /*
                 * liststring = varargin{i+1};
                 */
                mlfAssign(
                  &liststring,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'initialvalue'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("initialvalue"))) {
                /*
                 * initialvalue = varargin{i+1};
                 */
                mlfAssign(
                  &initialvalue,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'uh'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("uh"))) {
                /*
                 * uh = varargin{i+1};
                 */
                mlfAssign(
                  &uh,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'fus'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fus"))) {
                /*
                 * fus = varargin{i+1};
                 */
                mlfAssign(
                  &fus,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'ffs'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("ffs"))) {
                /*
                 * ffs = varargin{i+1};
                 */
                mlfAssign(
                  &ffs,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'okstring'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("okstring"))) {
                /*
                 * okstring = varargin{i+1};
                 */
                mlfAssign(
                  &okstring,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * case 'cancelstring'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("cancelstring"))) {
                /*
                 * cancelstring = varargin{i+1};
                 */
                mlfAssign(
                  &cancelstring,
                  mlfIndexRef(varargin, "{?}", mlfPlus(i, mlfScalar(1.0))));
            /*
             * end
             */
            }
            mxDestroyArray(t_);
        /*
         * end
         */
        }
        /*
         * 
         * if isstr(promptstring)
         */
        if (mlfTobool(mlfIsstr(promptstring))) {
            /*
             * promptstring = cellstr(promptstring); 
             */
            mlfAssign(&promptstring, mlfCellstr(promptstring));
        /*
         * end
         */
        }
        /*
         * 
         * if isempty(initialvalue)
         */
        if (mlfTobool(mlfIsempty(initialvalue))) {
            /*
             * initialvalue = 1;
             */
            mlfAssign(&initialvalue, mlfScalar(1.0));
        /*
         * end
         */
        }
        /*
         * 
         * ex = get(0,'defaultuicontrolfontsize')*1.5;  % height extent per line of
         */
        mlfAssign(
          &ex,
          mlfMtimes(
            mlfGet(
              mlfScalar(0.0), mxCreateString("defaultuicontrolfontsize"), NULL),
            mlfScalar(1.5)));
        /*
         * % uicontrol text, in pixels (approximate)
         * 
         * fp = get(0,'defaultfigureposition');
         */
        mlfAssign(
          &fp,
          mlfGet(
            mlfScalar(0.0), mxCreateString("defaultfigureposition"), NULL));
        /*
         * w = 2*(fus+ffs)+listsize(1);
         */
        mlfAssign(
          &w,
          mlfPlus(
            mlfMtimes(mlfScalar(2.0), mlfPlus(fus, ffs)),
            mlfIndexRef(listsize, "(?)", mlfScalar(1.0))));
        /*
         * h = 2*ffs+6*fus+ex*length(promptstring)+listsize(2)+uh+(smode==2)*(fus+uh);
         */
        mlfAssign(
          &h,
          mlfPlus(
            mlfPlus(
              mlfPlus(
                mlfPlus(
                  mlfPlus(
                    mlfMtimes(mlfScalar(2.0), ffs),
                    mlfMtimes(mlfScalar(6.0), fus)),
                  mlfMtimes(ex, mlfLength(promptstring))),
                mlfIndexRef(listsize, "(?)", mlfScalar(2.0))),
              uh),
            mlfMtimes(mlfEq(smode, mlfScalar(2.0)), mlfPlus(fus, uh))));
        /*
         * fp = [fp(1) fp(2)+fp(4)-h w h];  % keep upper left corner fixed
         */
        mlfAssign(
          &fp,
          mlfHorzcat(
            mlfIndexRef(fp, "(?)", mlfScalar(1.0)),
            mlfMinus(
              mlfPlus(
                mlfIndexRef(fp, "(?)", mlfScalar(2.0)),
                mlfIndexRef(fp, "(?)", mlfScalar(4.0))),
              h),
            w,
            h,
            NULL));
        /*
         * 
         * fig_props = { ...
         */
        mlfAssign(
          &fig_props,
          mlfCellhcat(
            mxCreateString("name"),
            figname,
            mxCreateString("resize"),
            mxCreateString("off"),
            mxCreateString("numbertitle"),
            mxCreateString("off"),
            mxCreateString("windowstyle"),
            mxCreateString("modal"),
            mxCreateString("createfcn"),
            mxCreateString(""),
            mxCreateString("position"),
            fp,
            mxCreateString("closerequestfcn"),
            mxCreateString("set(gcf,'userdata','cancel')"),
            NULL));
        /*
         * 'name'                   figname ...
         * 'resize'                 'off' ...
         * 'numbertitle'            'off' ...
         * 'windowstyle'            'modal' ...
         * 'createfcn'              ''    ...
         * 'position'               fp   ...
         * 'closerequestfcn'        'set(gcf,''userdata'',''cancel'')' ...
         * };
         * 
         * fig = figure(fig_props{:});
         */
        mlfAssign(
          &fig,
          mlfNFigure(
            1, mlfIndexRef(fig_props, "{?}", mlfCreateColonIndex()), NULL));
        /*
         * 
         * uicontrol('style','frame',...
         */
        mclPrintAns(
          &ans,
          mlfNUicontrol(
            0,
            mxCreateString("style"),
            mxCreateString("frame"),
            mxCreateString("position"),
            mlfHorzcat(
              mlfScalar(0.0),
              mlfScalar(0.0),
              mlfIndexRef(fp, "(?)", mlfDoubleMatrix(1, 2, __Array1_r, NULL)),
              NULL),
            NULL));
        /*
         * 'position',[0 0 fp([3 4])])
         * uicontrol('style','frame',...
         */
        mclPrintAns(
          &ans,
          mlfNUicontrol(
            0,
            mxCreateString("style"),
            mxCreateString("frame"),
            mxCreateString("position"),
            mlfHorzcat(
              ffs,
              ffs,
              mlfPlus(
                mlfMtimes(mlfScalar(2.0), fus),
                mlfIndexRef(listsize, "(?)", mlfScalar(1.0))),
              mlfPlus(mlfMtimes(mlfScalar(2.0), fus), uh),
              NULL),
            NULL));
        /*
         * 'position',[ffs ffs 2*fus+listsize(1) 2*fus+uh])
         * uicontrol('style','frame',...
         */
        mclPrintAns(
          &ans,
          mlfNUicontrol(
            0,
            mxCreateString("style"),
            mxCreateString("frame"),
            mxCreateString("position"),
            mlfHorzcat(
              ffs,
              mlfPlus(mlfPlus(ffs, mlfMtimes(mlfScalar(3.0), fus)), uh),
              mlfPlus(
                mlfMtimes(mlfScalar(2.0), fus),
                mlfIndexRef(listsize, "(?)", mlfScalar(1.0))),
              mlfPlus(
                mlfPlus(
                  mlfPlus(
                    mlfIndexRef(listsize, "(?)", mlfScalar(2.0)),
                    mlfMtimes(mlfScalar(3.0), fus)),
                  mlfMtimes(ex, mlfLength(promptstring))),
                mlfMtimes(mlfPlus(uh, fus), mlfEq(smode, mlfScalar(2.0)))),
              NULL),
            NULL));
        /*
         * 'position',[ffs ffs+3*fus+uh 2*fus+listsize(1) ...
         * listsize(2)+3*fus+ex*length(promptstring)+(uh+fus)*(smode==2)])
         * 
         * if length(promptstring)>0
         */
        if (mlfTobool(mlfGt(mlfLength(promptstring), mlfScalar(0.0)))) {
            /*
             * prompt_text = uicontrol('style','text','string',promptstring,...
             */
            mlfAssign(
              &prompt_text,
              mlfNUicontrol(
                1,
                mxCreateString("style"),
                mxCreateString("text"),
                mxCreateString("string"),
                promptstring,
                mxCreateString("horizontalalignment"),
                mxCreateString("left"),
                mxCreateString("units"),
                mxCreateString("pixels"),
                mxCreateString("position"),
                mlfHorzcat(
                  mlfPlus(ffs, fus),
                  mlfMinus(
                    mlfIndexRef(fp, "(?)", mlfScalar(4.0)),
                    mlfPlus(
                      mlfPlus(ffs, fus),
                      mlfMtimes(ex, mlfLength(promptstring)))),
                  mlfIndexRef(listsize, "(?)", mlfScalar(1.0)),
                  mlfMtimes(ex, mlfLength(promptstring)),
                  NULL),
                NULL));
        /*
         * 'horizontalalignment','left','units','pixels',...
         * 'position',[ffs+fus fp(4)-(ffs+fus+ex*length(promptstring)) ...
         * listsize(1) ex*length(promptstring)]);
         * end
         */
        }
        /*
         * 
         * btn_wid = (fp(3)-2*(ffs+fus)-fus)/2;
         */
        mlfAssign(
          &btn_wid,
          mlfMrdivide(
            mlfMinus(
              mlfMinus(
                mlfIndexRef(fp, "(?)", mlfScalar(3.0)),
                mlfMtimes(mlfScalar(2.0), mlfPlus(ffs, fus))),
              fus),
            mlfScalar(2.0)));
        /*
         * ok_btn = uicontrol('style','pushbutton',...
         */
        mlfAssign(
          &ok_btn,
          mlfNUicontrol(
            1,
            mxCreateString("style"),
            mxCreateString("pushbutton"),
            mxCreateString("string"),
            okstring,
            mxCreateString("position"),
            mlfHorzcat(mlfPlus(ffs, fus), mlfPlus(ffs, fus), btn_wid, uh, NULL),
            mxCreateString("callback"),
            mxCreateString("listdlg(0)"),
            NULL));
        /*
         * 'string',okstring,...
         * 'position',[ffs+fus ffs+fus btn_wid uh],...
         * 'callback','listdlg(0)');
         * cancel_btn = uicontrol('style','pushbutton',...
         */
        mlfAssign(
          &cancel_btn,
          mlfNUicontrol(
            1,
            mxCreateString("style"),
            mxCreateString("pushbutton"),
            mxCreateString("string"),
            cancelstring,
            mxCreateString("position"),
            mlfHorzcat(
              mlfPlus(mlfPlus(ffs, mlfMtimes(mlfScalar(2.0), fus)), btn_wid),
              mlfPlus(ffs, fus),
              btn_wid,
              uh,
              NULL),
            mxCreateString("callback"),
            mxCreateString("listdlg(1)"),
            NULL));
        /*
         * 'string',cancelstring,...
         * 'position',[ffs+2*fus+btn_wid ffs+fus btn_wid uh],...
         * 'callback','listdlg(1)');
         * 
         * liststring=cellstr(liststring);
         */
        mlfAssign(&liststring, mlfCellstr(liststring));
        /*
         * listbox = uicontrol('style','listbox',...
         */
        mlfAssign(
          &listbox,
          mlfNUicontrol(
            1,
            mxCreateString("style"),
            mxCreateString("listbox"),
            mxCreateString("position"),
            mlfHorzcat(
              mlfPlus(ffs, fus),
              mlfPlus(
                mlfPlus(mlfPlus(ffs, uh), mlfMtimes(mlfScalar(4.0), fus)),
                mlfMtimes(mlfEq(smode, mlfScalar(2.0)), mlfPlus(fus, uh))),
              listsize,
              NULL),
            mxCreateString("string"),
            liststring,
            mxCreateString("backgroundcolor"),
            mxCreateString("w"),
            mxCreateString("max"),
            smode,
            mxCreateString("tag"),
            mxCreateString("listbox"),
            mxCreateString("value"),
            initialvalue,
            mxCreateString("callback"),
            mxCreateString("listdlg(4)"),
            NULL));
        /*
         * 'position',[ffs+fus ffs+uh+4*fus+(smode==2)*(fus+uh) listsize],...
         * 'string',liststring,...
         * 'backgroundcolor','w',...
         * 'max',smode,...
         * 'tag','listbox',...
         * 'value',initialvalue, ...
         * 'callback', 'listdlg(4)');
         * 
         * if smode == 2
         */
        if (mlfTobool(mlfEq(smode, mlfScalar(2.0)))) {
            /*
             * selectall_btn = uicontrol('style','pushbutton',...
             */
            mlfAssign(
              &selectall_btn,
              mlfNUicontrol(
                1,
                mxCreateString("style"),
                mxCreateString("pushbutton"),
                mxCreateString("string"),
                mxCreateString("Select all"),
                mxCreateString("position"),
                mlfHorzcat(
                  mlfPlus(ffs, fus),
                  mlfPlus(mlfPlus(mlfMtimes(mlfScalar(4.0), fus), ffs), uh),
                  mlfIndexRef(listsize, "(?)", mlfScalar(1.0)),
                  uh,
                  NULL),
                mxCreateString("tag"),
                mxCreateString("selectall_btn"),
                mxCreateString("callback"),
                mxCreateString("listdlg(2)"),
                NULL));
            /*
             * 'string','Select all',...
             * 'position',[ffs+fus 4*fus+ffs+uh listsize(1) uh],...
             * 'tag','selectall_btn',...
             * 'callback','listdlg(2)');
             * 
             * if length(initialvalue) == length(liststring)
             */
            if (mlfTobool(
                  mlfEq(mlfLength(initialvalue), mlfLength(liststring)))) {
                /*
                 * set(selectall_btn,'enable','off')
                 */
                mclPrintAns(
                  &ans,
                  mlfNSet(
                    0,
                    selectall_btn,
                    mxCreateString("enable"),
                    mxCreateString("off"),
                    NULL));
            /*
             * end
             */
            }
            /*
             * set(listbox,'callback',['listdlg(3); listdlg(4)'])
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                listbox,
                mxCreateString("callback"),
                mlfHorzcat(mxCreateString("listdlg(3); listdlg(4)"), NULL),
                NULL));
        /*
         * end
         */
        }
        /*
         * 
         * waitfor(fig,'userdata')
         */
        mlfWaitfor(fig, mxCreateString("userdata"), NULL);
        /*
         * 
         * switch get(fig,'userdata')
         */
        {
            mxArray * t_ = mclUnassigned();
            mlfAssign(&t_, mlfGet(fig, mxCreateString("userdata"), NULL));
            /*
             * 
             * case 'ok'
             */
            if (mclSwitchCompare(t_, mxCreateString("ok"))) {
                /*
                 * value = 1;
                 */
                mlfAssign(value, mlfScalar(1.0));
                /*
                 * selection = get(listbox,'value');
                 */
                mlfAssign(
                  &selection, mlfGet(listbox, mxCreateString("value"), NULL));
            /*
             * case 'cancel'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("cancel"))) {
                /*
                 * value = 0;
                 */
                mlfAssign(value, mlfScalar(0.0));
                /*
                 * selection = [];
                 */
                mlfAssign(&selection, mclCreateEmptyArray());
            /*
             * end
             */
            }
            mxDestroyArray(t_);
        }
        /*
         * 
         * delete(fig)
         */
        mlfDelete(fig, NULL);
    /*
     * 
     * else
     */
    } else {
        /*
         * 
         * switch varargin{1}
         */
        mxArray * t_ = mclUnassigned();
        mlfAssign(&t_, mlfIndexRef(varargin, "{?}", mlfScalar(1.0)));
        /*
         * 
         * case 0  % OK button callback
         */
        if (mclSwitchCompare(t_, mlfScalar(0.0))) {
            /*
             * set(gcf,'userdata','ok')
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                mlfGcf(),
                mxCreateString("userdata"),
                mxCreateString("ok"),
                NULL));
        /*
         * 
         * case 1  % cancel button callback
         */
        } else if (mclSwitchCompare(t_, mlfScalar(1.0))) {
            /*
             * set(gcf,'userdata','cancel')
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                mlfGcf(),
                mxCreateString("userdata"),
                mxCreateString("cancel"),
                NULL));
        /*
         * 
         * case 2  % select all button callback
         */
        } else if (mclSwitchCompare(t_, mlfScalar(2.0))) {
            /*
             * listbox = findobj(gcf,'tag','listbox');
             */
            mlfAssign(
              &listbox,
              mlfFindobj(
                mlfGcf(),
                mxCreateString("tag"),
                mxCreateString("listbox"),
                NULL));
            /*
             * selectall_btn = findobj(gcf,'tag','selectall_btn');
             */
            mlfAssign(
              &selectall_btn,
              mlfFindobj(
                mlfGcf(),
                mxCreateString("tag"),
                mxCreateString("selectall_btn"),
                NULL));
            /*
             * set(selectall_btn,'enable','off')
             */
            mclPrintAns(
              &ans,
              mlfNSet(
                0,
                selectall_btn,
                mxCreateString("enable"),
                mxCreateString("off"),
                NULL));
            /*
             * s = get(listbox,'string');
             */
            mlfAssign(&s, mlfGet(listbox, mxCreateString("string"), NULL));
            /*
             * set(listbox,'value',1:length(s));
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                listbox,
                mxCreateString("value"),
                mlfColon(mlfScalar(1.0), mlfLength(s), NULL),
                NULL));
        /*
         * 
         * case 3  % listbox callback
         */
        } else if (mclSwitchCompare(t_, mlfScalar(3.0))) {
            /*
             * listbox = findobj(gcf,'tag','listbox');
             */
            mlfAssign(
              &listbox,
              mlfFindobj(
                mlfGcf(),
                mxCreateString("tag"),
                mxCreateString("listbox"),
                NULL));
            /*
             * selectall_btn = findobj(gcf,'tag','selectall_btn');
             */
            mlfAssign(
              &selectall_btn,
              mlfFindobj(
                mlfGcf(),
                mxCreateString("tag"),
                mxCreateString("selectall_btn"),
                NULL));
            /*
             * v = get(listbox,'value');
             */
            mlfAssign(&v, mlfGet(listbox, mxCreateString("value"), NULL));
            /*
             * s = get(listbox,'string');
             */
            mlfAssign(&s, mlfGet(listbox, mxCreateString("string"), NULL));
            /*
             * if length(s)==length(v)
             */
            if (mlfTobool(mlfEq(mlfLength(s), mlfLength(v)))) {
                /*
                 * set(selectall_btn,'enable','off')
                 */
                mclPrintAns(
                  &ans,
                  mlfNSet(
                    0,
                    selectall_btn,
                    mxCreateString("enable"),
                    mxCreateString("off"),
                    NULL));
            /*
             * else
             */
            } else {
                /*
                 * set(selectall_btn,'enable','on')
                 */
                mclPrintAns(
                  &ans,
                  mlfNSet(
                    0,
                    selectall_btn,
                    mxCreateString("enable"),
                    mxCreateString("on"),
                    NULL));
            /*
             * end
             */
            }
        /*
         * 
         * case 4  % Double-click to choose
         */
        } else if (mclSwitchCompare(t_, mlfScalar(4.0))) {
            /*
             * stype = get(gcf, 'SelectionType');
             */
            mlfAssign(
              &stype, mlfGet(mlfGcf(), mxCreateString("SelectionType"), NULL));
            /*
             * if (strcmp(stype, 'open')),
             */
            if (mlfTobool(mlfStrcmp(stype, mxCreateString("open")))) {
                /*
                 * set(gcf, 'userdata', 'ok');   
                 */
                mclAssignAns(
                  &ans,
                  mlfNSet(
                    0,
                    mlfGcf(),
                    mxCreateString("userdata"),
                    mxCreateString("ok"),
                    NULL));
            /*
             * end;
             */
            }
        /*
         * 
         * end
         */
        }
        mxDestroyArray(t_);
    /*
     * 
     * end
     */
    }
    mclValidateOutputs("listdlg", 2, nargout_, &selection, value);
    mxDestroyArray(ans);
    mxDestroyArray(btn_wid);
    mxDestroyArray(cancel_btn);
    mxDestroyArray(cancelstring);
    mxDestroyArray(ex);
    mxDestroyArray(ffs);
    mxDestroyArray(fig);
    mxDestroyArray(fig_props);
    mxDestroyArray(figname);
    mxDestroyArray(fp);
    mxDestroyArray(fus);
    mxDestroyArray(h);
    mxDestroyArray(i);
    mxDestroyArray(initialvalue);
    mxDestroyArray(listbox);
    mxDestroyArray(listsize);
    mxDestroyArray(liststring);
    mxDestroyArray(ok_btn);
    mxDestroyArray(okstring);
    mxDestroyArray(prompt_text);
    mxDestroyArray(promptstring);
    mxDestroyArray(s);
    mxDestroyArray(selectall_btn);
    mxDestroyArray(smode);
    mxDestroyArray(stype);
    mxDestroyArray(uh);
    mxDestroyArray(v);
    mxDestroyArray(w);
    /*
     * 
     * 
     */
    return selection;
}

/*
 * The function "mlfListdlg" contains the normal interface for the "listdlg"
 * M-function from file "C:\MATLABR11\toolbox\matlab\uitools\listdlg.m" (lines
 * 1-225). This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
mxArray * mlfListdlg(mxArray * * value, ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 1;
    mxArray * selection = mclGetUninitializedArray();
    mxArray * value__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, value, 0);
    mlfEnterNewContext(1, -1, value, varargin);
    if (value != NULL) {
        ++nargout;
    }
    selection = Mlistdlg(&value__, nargout, varargin);
    mlfRestorePreviousContext(1, 0, value);
    mxDestroyArray(varargin);
    if (value != NULL) {
        mclCopyOutputArg(value, value__);
    } else {
        mxDestroyArray(value__);
    }
    return mlfReturnValue(selection);
}

/*
 * The function "mlxListdlg" contains the feval interface for the "listdlg"
 * M-function from file "C:\MATLABR11\toolbox\matlab\uitools\listdlg.m" (lines
 * 1-225). The feval function calls the implementation version of listdlg
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
void mlxListdlg(int nlhs, mxArray * plhs[], int nrhs, mxArray * prhs[]) {
    mxArray * mprhs[1];
    mxArray * mplhs[2];
    int i;
    if (nlhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: listdlg Line: 1 Column: "
            "0 The function \"listdlg\" was called with mor"
            "e than the declared number of outputs (2)"));
    }
    for (i = 0; i < 2; ++i) {
        mplhs[i] = NULL;
    }
    mlfEnterNewContext(0, 0);
    mprhs[0] = NULL;
    mlfAssign(&mprhs[0], mclCreateVararginCell(nrhs, prhs));
    mplhs[0] = Mlistdlg(&mplhs[1], nlhs, mprhs[0]);
    mlfRestorePreviousContext(0, 0);
    plhs[0] = mplhs[0];
    for (i = 1; i < 2 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 2; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[0]);
}
