/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_diagnose.h"

/*
 * The function "Moptim_private_diagnose" is the implementation version of the
 * "optim/private/diagnose" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\diagnose.m" (lines 1-182). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function msg = diagnose(caller,OUTPUT,gradflag,hessflag,constflag,gradconstflag,line_search,OPTIONS,XOUT,non_eq,...
 */
static mxArray * Moptim_private_diagnose(int nargout_,
                                         mxArray * caller,
                                         mxArray * OUTPUT,
                                         mxArray * gradflag,
                                         mxArray * hessflag,
                                         mxArray * constflag,
                                         mxArray * gradconstflag,
                                         mxArray * line_search,
                                         mxArray * OPTIONS,
                                         mxArray * XOUT,
                                         mxArray * non_eq,
                                         mxArray * non_ineq,
                                         mxArray * lin_eq,
                                         mxArray * lin_ineq,
                                         mxArray * LB,
                                         mxArray * UB,
                                         mxArray * funfcn,
                                         mxArray * confcn,
                                         mxArray * f,
                                         mxArray * GRAD,
                                         mxArray * HESS,
                                         mxArray * c,
                                         mxArray * ceq,
                                         mxArray * cGRAD,
                                         mxArray * ceqGRAD) {
    mxArray * msg = mclGetUninitializedArray();
    mxArray * conformula = mclGetUninitializedArray();
    mxArray * funformula = mclGetUninitializedArray();
    mxArray * gradcformula = mclGetUninitializedArray();
    mxArray * gradformula = mclGetUninitializedArray();
    mxArray * hessformula = mclGetUninitializedArray();
    mxArray * pstr = mclGetUninitializedArray();
    mxArray * temp = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/diagnose",
      24,
      &caller,
      &OUTPUT,
      &gradflag,
      &hessflag,
      &constflag,
      &gradconstflag,
      &line_search,
      &OPTIONS,
      &XOUT,
      &non_eq,
      &non_ineq,
      &lin_eq,
      &lin_ineq,
      &LB,
      &UB,
      &funfcn,
      &confcn,
      &f,
      &GRAD,
      &HESS,
      &c,
      &ceq,
      &cGRAD,
      &ceqGRAD);
    /*
     * non_ineq,lin_eq,lin_ineq,LB,UB,funfcn,confcn,f,GRAD,HESS,c,ceq,cGRAD,ceqGRAD);
     * % DIAGNOSE prints diagnostic information about the function to be minimized
     * %    or solved.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.8 $ $Date: 1998/09/30 18:17:18 $
     * 
     * msg = [];
     */
    mlfAssign(&msg, mclCreateEmptyArray());
    /*
     * 
     * pstr = sprintf('\n%s\n%s\n',...
     */
    mlfAssign(
      &pstr,
      mlfSprintf(
        NULL,
        mxCreateString("\\n%s\\n%s\\n"),
        mxCreateString(
          "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"),
        mxCreateString("   Diagnostic Information "),
        NULL));
    /*
     * '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%',...
     * '   Diagnostic Information ');
     * disp(pstr)
     */
    mlfDisp(pstr);
    /*
     * 
     * if ~isempty(funfcn{1})
     */
    if (mlfTobool(
          mlfNot(
            mlfFeval(
              mclValueVarargout(),
              mlxIsempty,
              mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)),
              NULL)))) {
        /*
         * %if isa(funfcn{3},'inline')
         * %funformula = formula(funfcn{3});
         * %else 
         * funformula = funfcn{3};
         */
        mlfAssign(&funformula, mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)));
        /*
         * %end
         * %if isa(funfcn{4},'inline')
         * %   gradformula = formula(funfcn{4});
         * %else 
         * gradformula = funfcn{4};
         */
        mlfAssign(&gradformula, mlfIndexRef(funfcn, "{?}", mlfScalar(4.0)));
        /*
         * %end
         * 
         * %if isa(funfcn{5},'inline')
         * %   hessformula = formula(funfcn{5});
         * %else 
         * hessformula = funfcn{5};
         */
        mlfAssign(&hessformula, mlfIndexRef(funfcn, "{?}", mlfScalar(5.0)));
    /*
     * %end
     * end
     */
    }
    /*
     * 
     * if ~isempty(confcn{1})
     */
    if (mlfTobool(
          mlfNot(
            mlfFeval(
              mclValueVarargout(),
              mlxIsempty,
              mlfIndexRef(confcn, "{?}", mlfScalar(1.0)),
              NULL)))) {
        /*
         * %if isa(confcn{3},'inline')
         * %   conformula = formula(confcn{3});
         * %else 
         * conformula = confcn{3};
         */
        mlfAssign(&conformula, mlfIndexRef(confcn, "{?}", mlfScalar(3.0)));
        /*
         * %end
         * %if isa(confcn{4},'inline')
         * %   gradcformula = formula(confcn{4});
         * %else 
         * gradcformula = confcn{4};
         */
        mlfAssign(&gradcformula, mlfIndexRef(confcn, "{?}", mlfScalar(4.0)));
    /*
     * %end
     * else
     */
    } else {
        /*
         * conformula = '';
         */
        mlfAssign(&conformula, mxCreateString(""));
        /*
         * gradcformula = '';
         */
        mlfAssign(&gradcformula, mxCreateString(""));
    /*
     * end
     */
    }
    /*
     * 
     * disp(['Number of variables: ', int2str(length(XOUT)),sprintf('\n')])
     */
    mlfDisp(
      mlfHorzcat(
        mxCreateString("Number of variables: "),
        mlfInt2str(mlfLength(XOUT)),
        mlfSprintf(NULL, mxCreateString("\\n"), NULL),
        NULL));
    /*
     * if ~isempty(funfcn{1})
     */
    if (mlfTobool(
          mlfNot(
            mlfFeval(
              mclValueVarargout(),
              mlxIsempty,
              mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)),
              NULL)))) {
        /*
         * disp('Functions ')
         */
        mlfDisp(mxCreateString("Functions "));
        /*
         * switch funfcn{1}
         */
        {
            mxArray * t_ = mclUnassigned();
            mlfAssign(&t_, mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)));
            /*
             * case 'fun'
             */
            if (mclSwitchCompare(t_, mxCreateString("fun"))) {
                /*
                 * % display 
                 * disp([' Objective:                            ',funformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Objective:                            "),
                    funformula,
                    NULL));
            /*
             * 
             * case 'fungrad'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fungrad"))) {
                /*
                 * if gradflag
                 */
                if (mlfTobool(gradflag)) {
                    /*
                     * disp([' Objective and gradient:               ',funformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Objective and gradient:               "),
                        funformula,
                        NULL));
                /*
                 * else
                 */
                } else {
                    /*
                     * disp([' Objective:                            ',funformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Objective:                            "),
                        funformula,
                        NULL));
                    /*
                     * disp( '   (set OPTIONS.GradObj=''on'' to use user provided gradient function)') 
                     */
                    mlfDisp(
                      mxCreateString(
                        "   (set OPTIONS.GradObj='on' to use "
                        "user provided gradient function)"));
                /*
                 * end
                 */
                }
            /*
             * 
             * case 'fungradhess'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fungradhess"))) {
                /*
                 * if gradflag & hessflag
                 */
                if (mlfTobool(gradflag)
                    && mlfTobool(mlfAnd(gradflag, hessflag))) {
                    /*
                     * disp([' Objective, gradient and Hessian:      ',funformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Objective, gradient and Hessian:      "),
                        funformula,
                        NULL));
                /*
                 * elseif gradflag
                 */
                } else if (mlfTobool(gradflag)) {
                    /*
                     * disp([' Objective and gradient:               ',funformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Objective and gradient:               "),
                        funformula,
                        NULL));
                    /*
                     * disp( '   (set OPTIONS.Hessian to ''on'' to use user provided Hessian function)') 
                     */
                    mlfDisp(
                      mxCreateString(
                        "   (set OPTIONS.Hessian to 'on' to us"
                        "e user provided Hessian function)"));
                /*
                 * else
                 */
                } else {
                    /*
                     * disp([' Objective:                            ',funformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Objective:                            "),
                        funformula,
                        NULL));
                    /*
                     * disp( '   (set OPTIONS.GradObj=''on'' to use user provided gradient function)')
                     */
                    mlfDisp(
                      mxCreateString(
                        "   (set OPTIONS.GradObj='on' to use "
                        "user provided gradient function)"));
                    /*
                     * disp( '   (set OPTIONS.Hessian to ''on'' to use user provided Hessian function)') 
                     */
                    mlfDisp(
                      mxCreateString(
                        "   (set OPTIONS.Hessian to 'on' to us"
                        "e user provided Hessian function)"));
                /*
                 * end
                 */
                }
            /*
             * 
             * 
             * case 'fun_then_grad'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fun_then_grad"))) {
                /*
                 * disp([' Objective:                            ',funformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Objective:                            "),
                    funformula,
                    NULL));
                /*
                 * if gradflag
                 */
                if (mlfTobool(gradflag)) {
                    /*
                     * disp([' Gradient:                             ',gradformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Gradient:                             "),
                        gradformula,
                        NULL));
                /*
                 * end
                 */
                }
                /*
                 * if hessflag
                 */
                if (mlfTobool(hessflag)) {
                    /*
                     * disp('-->Ignoring OPTIONS.Hessian --no user Hessian function provided')
                     */
                    mlfDisp(
                      mxCreateString(
                        "-->Ignoring OPTIONS.Hessian --no "
                        "user Hessian function provided"));
                /*
                 * end
                 */
                }
            /*
             * 
             * case 'fun_then_grad_then_hess'
             */
            } else if (mclSwitchCompare(
                         t_, mxCreateString("fun_then_grad_then_hess"))) {
                /*
                 * disp([' Objective:                            ',funformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Objective:                            "),
                    funformula,
                    NULL));
                /*
                 * if gradflag & hessflag
                 */
                if (mlfTobool(gradflag)
                    && mlfTobool(mlfAnd(gradflag, hessflag))) {
                    /*
                     * disp([' Gradient:                             ',gradformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Gradient:                             "),
                        gradformula,
                        NULL));
                    /*
                     * disp([' Hessian:                              ',hessformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Hessian:                              "),
                        hessformula,
                        NULL));
                /*
                 * elseif gradflag
                 */
                } else if (mlfTobool(gradflag)) {
                    /*
                     * disp([' Gradient:                             ',gradformula]);
                     */
                    mlfDisp(
                      mlfHorzcat(
                        mxCreateString(
                          " Gradient:                             "),
                        gradformula,
                        NULL));
                /*
                 * end   
                 */
                }
            /*
             * otherwise
             */
            } else {
            /*
             * 
             * end
             */
            }
            mxDestroyArray(t_);
        }
        /*
         * 
         * if ~gradflag
         */
        if (mlfTobool(mlfNot(gradflag))) {
            /*
             * disp(' Gradient:                             finite-differencing')
             */
            mlfDisp(
              mxCreateString(
                " Gradient:                             finite-differencing"));
        /*
         * end
         */
        }
        /*
         * % shape of grad
         * 
         * if ~hessflag & (isequal('fmincon',caller) | isequal('fminunc',caller))
         */
        {
            mxArray * a_ = mclInitialize(mlfNot(hessflag));
            if (mlfTobool(a_)) {
                mxArray * b_ = mclInitialize(
                                 mlfIsequal(
                                   mxCreateString("fmincon"), caller, NULL));
                if (mlfTobool(b_)) {
                    mlfAssign(&b_, mlfScalar(1));
                } else {
                    mlfAssign(
                      &b_,
                      mlfOr(
                        b_,
                        mlfIsequal(mxCreateString("fminunc"), caller, NULL)));
                }
                {
                    int c_0 = mlfTobool(mlfAnd(a_, b_));
                    mxDestroyArray(b_);
                    mxDestroyArray(a_);
                    if (c_0) {
                        /*
                         * disp(' Hessian:                              finite-differencing (or Quasi-Newton)')
                         */
                        mlfDisp(
                          mxCreateString(
                            " Hessian:                              f"
                            "inite-differencing (or Quasi-Newton)"));
                    }
                }
            /*
             * end
             */
            } else {
                mxDestroyArray(a_);
            }
        }
    /*
     * % shape of hess
     * 
     * end
     */
    }
    /*
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     * if ~isempty(confcn{1})
     */
    if (mlfTobool(
          mlfNot(
            mlfFeval(
              mclValueVarargout(),
              mlxIsempty,
              mlfIndexRef(confcn, "{?}", mlfScalar(1.0)),
              NULL)))) {
        /*
         * switch confcn{1}
         */
        mxArray * t_ = mclUnassigned();
        mlfAssign(&t_, mlfIndexRef(confcn, "{?}", mlfScalar(1.0)));
        /*
         * 
         * case 'fun'
         */
        if (mclSwitchCompare(t_, mxCreateString("fun"))) {
            /*
             * disp([' Nonlinear constraints:                ',conformula]);
             */
            mlfDisp(
              mlfHorzcat(
                mxCreateString(" Nonlinear constraints:                "),
                conformula,
                NULL));
        /*
         * case 'fungrad'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("fungrad"))) {
            /*
             * if gradconstflag
             */
            if (mlfTobool(gradconstflag)) {
                /*
                 * disp([' Nonlinear constraints and gradient:   ',conformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Nonlinear constraints and gradient:   "),
                    conformula,
                    NULL));
            /*
             * else
             */
            } else {
                /*
                 * disp([' Nonlinear constraints:                ',conformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Nonlinear constraints:                "),
                    conformula,
                    NULL));
                /*
                 * disp( '   (set OPTIONS.GradConstr to ''on'' to use user provided gradient of constraints function)') 
                 */
                mlfDisp(
                  mxCreateString(
                    "   (set OPTIONS.GradConstr to 'on' to use user"
                    " provided gradient of constraints function)"));
            /*
             * end
             */
            }
        /*
         * 
         * case 'fun_then_grad'
         */
        } else if (mclSwitchCompare(t_, mxCreateString("fun_then_grad"))) {
            /*
             * disp([' Nonlinear constraints:                ',conformula]);
             */
            mlfDisp(
              mlfHorzcat(
                mxCreateString(" Nonlinear constraints:                "),
                conformula,
                NULL));
            /*
             * if gradconstflag
             */
            if (mlfTobool(gradconstflag)) {
                /*
                 * disp([' Nonlinear constraints gradient:       ',gradcformula]);
                 */
                mlfDisp(
                  mlfHorzcat(
                    mxCreateString(" Nonlinear constraints gradient:       "),
                    gradcformula,
                    NULL));
            /*
             * end
             */
            }
        /*
         * 
         * otherwise
         */
        } else {
        /*
         * 
         * end
         */
        }
        mxDestroyArray(t_);
        /*
         * 
         * if ~constflag
         */
        if (mlfTobool(mlfNot(constflag))) {
            /*
             * disp(' Nonlinear constraints:                finite-differencing')
             */
            mlfDisp(
              mxCreateString(
                " Nonlinear constraints:                finite-differencing"));
        /*
         * end
         */
        }
        /*
         * if ~gradconstflag
         */
        if (mlfTobool(mlfNot(gradconstflag))) {
            /*
             * 
             * disp(' Gradient of nonlinear constraints:    finite-differencing')
             */
            mlfDisp(
              mxCreateString(
                " Gradient of nonlinear constraints:    finite-differencing"));
        /*
         * end
         */
        }
        /*
         * disp([sprintf('\n'),'Constraints'])  
         */
        mlfDisp(
          mlfHorzcat(
            mlfSprintf(NULL, mxCreateString("\\n"), NULL),
            mxCreateString("Constraints"),
            NULL));
        /*
         * disp([' Number of nonlinear inequality constraints: ',int2str(non_ineq)])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of nonlinear inequality constraints: "),
            mlfInt2str(non_ineq),
            NULL));
        /*
         * disp([' Number of nonlinear equality constraints:   ',int2str(non_eq)])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of nonlinear equality constraints:   "),
            mlfInt2str(non_eq),
            NULL));
    /*
     * 
     * elseif isequal(caller,'fmincon') | isequal(caller,'fminimax') | ...
     */
    } else {
        mxArray * a_ = mclInitialize(
                         mlfIsequal(caller, mxCreateString("fmincon"), NULL));
        if (mlfTobool(a_)) {
            mlfAssign(&a_, mlfScalar(1));
        } else {
            mlfAssign(
              &a_,
              mlfOr(a_, mlfIsequal(caller, mxCreateString("fminimax"), NULL)));
        }
        if (mlfTobool(a_)) {
            mlfAssign(&a_, mlfScalar(1));
        } else {
            mlfAssign(
              &a_,
              mlfOr(
                a_, mlfIsequal(caller, mxCreateString("fgoalattain"), NULL)));
        }
        if (mlfTobool(a_)
            || mlfTobool(
                 mlfOr(
                   a_, mlfIsequal(caller, mxCreateString("fseminf"), NULL)))) {
            mxDestroyArray(a_);
            /*
             * isequal(caller,'fgoalattain') | isequal(caller,'fseminf')
             * disp([sprintf('\n'),'Constraints'])
             */
            mlfDisp(
              mlfHorzcat(
                mlfSprintf(NULL, mxCreateString("\\n"), NULL),
                mxCreateString("Constraints"),
                NULL));
            /*
             * disp(' Nonlinear constraints:             do not exist')
             */
            mlfDisp(
              mxCreateString(
                " Nonlinear constraints:             do not exist"));
        } else {
            mxDestroyArray(a_);
        }
    /*
     * 
     * end
     */
    }
    /*
     * 
     * disp(' ')
     */
    mlfDisp(mxCreateString(" "));
    /*
     * 
     * 
     * switch caller
     * 
     * case {'fmincon','linprog','quadprog','lsqlin','fminimax','fseminf','fgoalattain'}
     */
    if (mclSwitchCompare(
          caller,
          mlfCellhcat(
            mxCreateString("fmincon"),
            mxCreateString("linprog"),
            mxCreateString("quadprog"),
            mxCreateString("lsqlin"),
            mxCreateString("fminimax"),
            mxCreateString("fseminf"),
            mxCreateString("fgoalattain"),
            NULL))) {
        /*
         * disp([' Number of linear inequality constraints:    ',int2str(lin_ineq)])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of linear inequality constraints:    "),
            mlfInt2str(lin_ineq),
            NULL));
        /*
         * disp([' Number of linear equality constraints:      ',int2str(lin_eq)])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of linear equality constraints:      "),
            mlfInt2str(lin_eq),
            NULL));
        /*
         * disp([' Number of lower bound constraints:          ',int2str(nnz(~isinf(LB)))])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of lower bound constraints:          "),
            mlfInt2str(mlfNnz(mlfNot(mlfIsinf(LB)))),
            NULL));
        /*
         * disp([' Number of upper bound constraints:          ',int2str(nnz(~isinf(UB)))])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of upper bound constraints:          "),
            mlfInt2str(mlfNnz(mlfNot(mlfIsinf(UB)))),
            NULL));
    /*
     * case {'lsqcurvefit','lsqnonlin'}
     */
    } else if (mclSwitchCompare(
                 caller,
                 mlfCellhcat(
                   mxCreateString("lsqcurvefit"),
                   mxCreateString("lsqnonlin"),
                   NULL))) {
        /*
         * disp([' Number of lower bound constraints:          ',int2str(nnz(~isinf(LB)))])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of lower bound constraints:          "),
            mlfInt2str(mlfNnz(mlfNot(mlfIsinf(LB)))),
            NULL));
        /*
         * disp([' Number of upper bound constraints:          ',int2str(nnz(~isinf(UB)))])
         */
        mlfDisp(
          mlfHorzcat(
            mxCreateString(" Number of upper bound constraints:          "),
            mlfInt2str(mlfNnz(mlfNot(mlfIsinf(UB)))),
            NULL));
    /*
     * case {'fsolve','fminunc','fsolves'}
     */
    } else if (mclSwitchCompare(
                 caller,
                 mlfCellhcat(
                   mxCreateString("fsolve"),
                   mxCreateString("fminunc"),
                   mxCreateString("fsolves"),
                   NULL))) {
    /*
     * otherwise
     */
    } else {
    /*
     * end
     */
    }
    /*
     * 
     * if ~isempty(OUTPUT)
     */
    if (mlfTobool(mlfNot(mlfIsempty(OUTPUT)))) {
        /*
         * temp = sprintf('\n%s\n   %s\n','Algorithm selected',OUTPUT.algorithm);
         */
        mlfAssign(
          &temp,
          mlfSprintf(
            NULL,
            mxCreateString("\\n%s\\n   %s\\n"),
            mxCreateString("Algorithm selected"),
            mlfIndexRef(OUTPUT, ".algorithm"),
            NULL));
        /*
         * disp(temp)
         */
        mlfDisp(temp);
    /*
     * end
     */
    }
    /*
     * 
     * pstr = sprintf('\n%s\n%s\n',...
     */
    mlfAssign(
      &pstr,
      mlfSprintf(
        NULL,
        mxCreateString("\\n%s\\n%s\\n"),
        mxCreateString(
          "%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%"),
        mxCreateString(" End diagnostic information "),
        NULL));
    /*
     * '%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%',...
     * ' End diagnostic information ');
     * disp(pstr)
     */
    mlfDisp(pstr);
    mclValidateOutputs("optim/private/diagnose", 1, nargout_, &msg);
    mxDestroyArray(conformula);
    mxDestroyArray(funformula);
    mxDestroyArray(gradcformula);
    mxDestroyArray(gradformula);
    mxDestroyArray(hessformula);
    mxDestroyArray(pstr);
    mxDestroyArray(temp);
    return msg;
}

/*
 * The function "mlfOptim_private_diagnose" contains the normal interface for
 * the "optim/private/diagnose" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\diagnose.m" (lines 1-182). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_diagnose(mxArray * caller,
                                    mxArray * OUTPUT,
                                    mxArray * gradflag,
                                    mxArray * hessflag,
                                    mxArray * constflag,
                                    mxArray * gradconstflag,
                                    mxArray * line_search,
                                    mxArray * OPTIONS,
                                    mxArray * XOUT,
                                    mxArray * non_eq,
                                    mxArray * non_ineq,
                                    mxArray * lin_eq,
                                    mxArray * lin_ineq,
                                    mxArray * LB,
                                    mxArray * UB,
                                    mxArray * funfcn,
                                    mxArray * confcn,
                                    mxArray * f,
                                    mxArray * GRAD,
                                    mxArray * HESS,
                                    mxArray * c,
                                    mxArray * ceq,
                                    mxArray * cGRAD,
                                    mxArray * ceqGRAD) {
    int nargout = 1;
    mxArray * msg = mclGetUninitializedArray();
    mlfEnterNewContext(
      0,
      24,
      caller,
      OUTPUT,
      gradflag,
      hessflag,
      constflag,
      gradconstflag,
      line_search,
      OPTIONS,
      XOUT,
      non_eq,
      non_ineq,
      lin_eq,
      lin_ineq,
      LB,
      UB,
      funfcn,
      confcn,
      f,
      GRAD,
      HESS,
      c,
      ceq,
      cGRAD,
      ceqGRAD);
    msg
      = Moptim_private_diagnose(
          nargout,
          caller,
          OUTPUT,
          gradflag,
          hessflag,
          constflag,
          gradconstflag,
          line_search,
          OPTIONS,
          XOUT,
          non_eq,
          non_ineq,
          lin_eq,
          lin_ineq,
          LB,
          UB,
          funfcn,
          confcn,
          f,
          GRAD,
          HESS,
          c,
          ceq,
          cGRAD,
          ceqGRAD);
    mlfRestorePreviousContext(
      0,
      24,
      caller,
      OUTPUT,
      gradflag,
      hessflag,
      constflag,
      gradconstflag,
      line_search,
      OPTIONS,
      XOUT,
      non_eq,
      non_ineq,
      lin_eq,
      lin_ineq,
      LB,
      UB,
      funfcn,
      confcn,
      f,
      GRAD,
      HESS,
      c,
      ceq,
      cGRAD,
      ceqGRAD);
    return mlfReturnValue(msg);
}

/*
 * The function "mlxOptim_private_diagnose" contains the feval interface for
 * the "optim/private/diagnose" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\diagnose.m" (lines 1-182). The feval
 * function calls the implementation version of optim/private/diagnose through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxOptim_private_diagnose(int nlhs,
                               mxArray * plhs[],
                               int nrhs,
                               mxArray * prhs[]) {
    mxArray * mprhs[24];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/diagnose Line: 1 Col"
            "umn: 0 The function \"optim/private/diagnose\" was calle"
            "d with more than the declared number of outputs (1)"));
    }
    if (nrhs > 24) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/diagnose Line: 1 Col"
            "umn: 0 The function \"optim/private/diagnose\" was calle"
            "d with more than the declared number of inputs (24)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 24 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 24; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      24,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15],
      mprhs[16],
      mprhs[17],
      mprhs[18],
      mprhs[19],
      mprhs[20],
      mprhs[21],
      mprhs[22],
      mprhs[23]);
    mplhs[0]
      = Moptim_private_diagnose(
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7],
          mprhs[8],
          mprhs[9],
          mprhs[10],
          mprhs[11],
          mprhs[12],
          mprhs[13],
          mprhs[14],
          mprhs[15],
          mprhs[16],
          mprhs[17],
          mprhs[18],
          mprhs[19],
          mprhs[20],
          mprhs[21],
          mprhs[22],
          mprhs[23]);
    mlfRestorePreviousContext(
      0,
      24,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15],
      mprhs[16],
      mprhs[17],
      mprhs[18],
      mprhs[19],
      mprhs[20],
      mprhs[21],
      mprhs[22],
      mprhs[23]);
    plhs[0] = mplhs[0];
}
