/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_nlsq.h"
#include "cubici1.h"
#include "cubici3.h"
#include "graderr.h"
#include "searchq.h"

extern mxArray * OPT_STEP;
extern mxArray * OPT_STOP;

static double __Array0_r[1] = { 0.0 };

static double __Array1_r[1] = { 0.0 };

static mxArray * Moptim_private_nlsq(mxArray * * CostFunction,
                                     mxArray * * JAC,
                                     mxArray * * EXITFLAG,
                                     mxArray * * OUTPUT,
                                     int nargout_,
                                     mxArray * funfcn,
                                     mxArray * x_,
                                     mxArray * verbosity,
                                     mxArray * options,
                                     mxArray * CostFunction_,
                                     mxArray * JAC_,
                                     mxArray * YDATA,
                                     mxArray * caller,
                                     mxArray * varargin);
static mxArray * Mnlsq_lsinit(mxArray * * fold,
                              mxArray * * how,
                              int nargout_,
                              mxArray * xnew,
                              mxArray * fnew,
                              mxArray * verbosity,
                              mxArray * levMarq);
static mxArray * mlfNlsq_lsinit(mxArray * * fold,
                                mxArray * * how,
                                mxArray * xnew,
                                mxArray * fnew,
                                mxArray * verbosity,
                                mxArray * levMarq);
static void mlxNlsq_lsinit(int nlhs,
                           mxArray * plhs[],
                           int nrhs,
                           mxArray * prhs[]);

static mlfFunctionTableEntry local_function_table_[1]
  = { { "lsinit", mlxNlsq_lsinit, 4, 3 } };

/*
 * The function "Moptim_private_nlsq" is the implementation version of the
 * "optim/private/nlsq" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 1-413). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [x,CostFunction,JAC,EXITFLAG,OUTPUT] = nlsq(funfcn,x,verbosity,options,CostFunction,JAC,YDATA,caller,varargin)
 */
static mxArray * Moptim_private_nlsq(mxArray * * CostFunction,
                                     mxArray * * JAC,
                                     mxArray * * EXITFLAG,
                                     mxArray * * OUTPUT,
                                     int nargout_,
                                     mxArray * funfcn,
                                     mxArray * x_,
                                     mxArray * verbosity,
                                     mxArray * options,
                                     mxArray * CostFunction_,
                                     mxArray * JAC_,
                                     mxArray * YDATA,
                                     mxArray * caller,
                                     mxArray * varargin) {
    mxArray * x = mclGetUninitializedArray();
    mxArray * CHG = mclGetUninitializedArray();
    mxArray * DerivativeCheck = mclGetUninitializedArray();
    mxArray * DiffMaxChange = mclGetUninitializedArray();
    mxArray * DiffMinChange = mclGetUninitializedArray();
    mxArray * EstSum = mclGetUninitializedArray();
    mxArray * FIRSTF = mclGetUninitializedArray();
    mxArray * GDOLD = mclGetUninitializedArray();
    mxArray * GradF = mclGetUninitializedArray();
    mxArray * GradFactor = mclGetUninitializedArray();
    mxArray * JACFD = mclGetUninitializedArray();
    mxArray * JACOB = mclGetUninitializedArray();
    mxArray * MATL = mclGetUninitializedArray();
    mxArray * MATX = mclGetUninitializedArray();
    mxArray * NewF = mclGetUninitializedArray();
    mxArray * OLDF = mclGetUninitializedArray();
    mxArray * OLDG = mclGetUninitializedArray();
    mxArray * OLDJ = mclGetUninitializedArray();
    mxArray * OLDX = mclGetUninitializedArray();
    mxArray * OX = mclGetUninitializedArray();
    mxArray * PCNT = mclGetUninitializedArray();
    mxArray * SD = mclGetUninitializedArray();
    mxArray * XOUT = mclGetUninitializedArray();
    mxArray * currstepsize = mclGetUninitializedArray();
    mxArray * estf = mclGetUninitializedArray();
    mxArray * fbest = mclGetUninitializedArray();
    mxArray * formatstr = mclGetUninitializedArray();
    mxArray * gcnt = mclGetUninitializedArray();
    mxArray * gdnew = mclGetUninitializedArray();
    mxArray * gradflag = mclGetUninitializedArray();
    mxArray * how = mclGetUninitializedArray();
    mxArray * iter = mclGetUninitializedArray();
    mclForLoopIterator iterator_0;
    mxArray * levMarq = mclGetUninitializedArray();
    mxArray * lineSearchType = mclGetUninitializedArray();
    mxArray * maxFunEvals = mclGetUninitializedArray();
    mxArray * maxIter = mclGetUninitializedArray();
    mxArray * newf = mclGetUninitializedArray();
    mxArray * newstep = mclGetUninitializedArray();
    mxArray * nfun = mclGetUninitializedArray();
    mxArray * nonZeroSum = mclGetUninitializedArray();
    mxArray * num = mclGetUninitializedArray();
    mxArray * numFunEvals = mclGetUninitializedArray();
    mxArray * numGradEvals = mclGetUninitializedArray();
    mxArray * numberOfVariables = mclGetUninitializedArray();
    mxArray * status = mclGetUninitializedArray();
    mxArray * steplen = mclGetUninitializedArray();
    mxArray * stepsize = mclGetUninitializedArray();
    mxArray * sumabsJAC = mclGetUninitializedArray();
    mxArray * temp = mclGetUninitializedArray();
    mxArray * tolFun = mclGetUninitializedArray();
    mxArray * tolX = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/nlsq",
      8,
      &funfcn,
      &x_,
      &verbosity,
      &options,
      &CostFunction_,
      &JAC_,
      &YDATA,
      &caller);
    mclCopyInputArg(&x, x_);
    mclCopyInputArg(CostFunction, CostFunction_);
    mclCopyInputArg(JAC, JAC_);
    /*
     * %NLSQ Solves non-linear least squares problems.
     * %   NLSQ is the core code for solving problems of the form:
     * %   min  sum {FUN(X).^2}    where FUN and X may be vectors or matrices.   
     * %             x
     * %
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.13 $  $Date: 1998/07/30 16:31:50 $
     * %   Andy Grace 7-9-90.
     * 
     * %   The default algorithm is the Levenberg-Marquardt method with a 
     * %   mixed quadratic and cubic line search procedure.  A Gauss-Newton
     * %   method is selected by setting  OPTIONS.LevenbergMarq='on'. 
     * %
     * 
     * % ------------Initialization----------------
     * 
     * 
     * XOUT = x(:);
     */
    mlfAssign(&XOUT, mlfIndexRef(x, "(?)", mlfCreateColonIndex()));
    /*
     * % numberOfVariables must be the name of this variable
     * numberOfVariables = length(XOUT);
     */
    mlfAssign(&numberOfVariables, mlfLength(XOUT));
    /*
     * how = [];
     */
    mlfAssign(&how, mclCreateEmptyArray());
    /*
     * 
     * numFunEvals = 0;
     */
    mlfAssign(&numFunEvals, mlfScalar(0.0));
    /*
     * numGradEvals = 0;
     */
    mlfAssign(&numGradEvals, mlfScalar(0.0));
    /*
     * 
     * OUTPUT = [];
     */
    mlfAssign(OUTPUT, mclCreateEmptyArray());
    /*
     * iter = 0;
     */
    mlfAssign(&iter, mlfScalar(0.0));
    /*
     * JACOB = [];
     */
    mlfAssign(&JACOB, mclCreateEmptyArray());
    /*
     * EXITFLAG = 1;  %assume convergence
     */
    mlfAssign(EXITFLAG, mlfScalar(1.0));
    /*
     * currstepsize = 0;
     */
    mlfAssign(&currstepsize, mlfScalar(0.0));
    /*
     * 
     * % Global parameters for outside control of leastsq
     * % OPT_STOP is used for prematurely stopping the optimization
     * % OPT_STEP is set to 1 during major (non-gradient finding) iterations
     * %          set to 0 during gradient finding and 2 during line search
     * %          this can be useful for plotting etc.
     * global OPT_STOP OPT_STEP;
     * OPT_STEP = 1;
     */
    mlfAssign(&OPT_STEP, mlfScalar(1.0));
    /*
     * OPT_STOP = 0;
     */
    mlfAssign(&OPT_STOP, mlfScalar(0.0));
    /*
     * 
     * formatstr=' %5.0f       %5.0f   %13.6g %12.3g %12.3g  ';
     */
    mlfAssign(
      &formatstr,
      mxCreateString(" %5.0f       %5.0f   %13.6g %12.3g %12.3g  "));
    /*
     * 
     * OPT_STEP = 0;  % No longer a major step
     */
    mlfAssign(&OPT_STEP, mlfScalar(0.0));
    /*
     * 
     * nfun=length(CostFunction);
     */
    mlfAssign(&nfun, mlfLength(*CostFunction));
    /*
     * 
     * gradflag =  strcmp(optimget(options,'Jacobian'),'on');
     */
    mlfAssign(
      &gradflag,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("Jacobian"), NULL),
        mxCreateString("on")));
    /*
     * tolX = optimget(options,'tolx');
     */
    mlfAssign(&tolX, mlfOptimget(options, mxCreateString("tolx"), NULL));
    /*
     * % lineSearchType of 0 means quadcubic (the default)
     * lineSearchType = strcmp(optimget(options,'linesearchtype'),'cubicpoly');
     */
    mlfAssign(
      &lineSearchType,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("linesearchtype"), NULL),
        mxCreateString("cubicpoly")));
    /*
     * % levMarq=1 is the default and means use levenbergmarquardt
     * levMarq = strcmp(optimget(options,'levenbergMarq'),'on');
     */
    mlfAssign(
      &levMarq,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("levenbergMarq"), NULL),
        mxCreateString("on")));
    /*
     * 
     * tolFun = optimget(options,'tolfun');
     */
    mlfAssign(&tolFun, mlfOptimget(options, mxCreateString("tolfun"), NULL));
    /*
     * DiffMinChange = optimget(options,'diffminchange');
     */
    mlfAssign(
      &DiffMinChange,
      mlfOptimget(options, mxCreateString("diffminchange"), NULL));
    /*
     * DiffMaxChange = optimget(options,'diffmaxchange');
     */
    mlfAssign(
      &DiffMaxChange,
      mlfOptimget(options, mxCreateString("diffmaxchange"), NULL));
    /*
     * DerivativeCheck = strcmp(optimget(options,'Derivativecheck'),'on');
     */
    mlfAssign(
      &DerivativeCheck,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("Derivativecheck"), NULL),
        mxCreateString("on")));
    /*
     * maxFunEvals = optimget(options,'maxfunevals');
     */
    mlfAssign(
      &maxFunEvals, mlfOptimget(options, mxCreateString("maxfunevals"), NULL));
    /*
     * maxIter = optimget(options,'maxiter');
     */
    mlfAssign(&maxIter, mlfOptimget(options, mxCreateString("maxiter"), NULL));
    /*
     * % In case the defaults were gathered from calling: optimset('fminsearch'):
     * %if ischar(maxFunEvals)
     * %   maxFunEvals = eval(maxFunEvals);
     * %end
     * %if ischar(maxIter)
     * %   maxIter = eval(maxIter);
     * %end
     * 
     * iter = 0;
     */
    mlfAssign(&iter, mlfScalar(0.0));
    /*
     * numFunEvals = 0;
     */
    mlfAssign(&numFunEvals, mlfScalar(0.0));
    /*
     * numGradEvals = 0;
     */
    mlfAssign(&numGradEvals, mlfScalar(0.0));
    /*
     * 
     * MATX=zeros(3,1);
     */
    mlfAssign(&MATX, mlfZeros(mlfScalar(3.0), mlfScalar(1.0), NULL));
    /*
     * MATL=[CostFunction'*CostFunction;0;0];
     */
    mlfAssign(
      &MATL,
      mlfVertcat(
        mlfHorzcat(
          mlfMtimes(mlfCtranspose(*CostFunction), *CostFunction), NULL),
        mlfDoubleMatrix(1, 1, __Array0_r, NULL),
        mlfDoubleMatrix(1, 1, __Array1_r, NULL),
        NULL));
    /*
     * FIRSTF=CostFunction'*CostFunction;
     */
    mlfAssign(&FIRSTF, mlfMtimes(mlfCtranspose(*CostFunction), *CostFunction));
    /*
     * [OLDX,OLDF]=lsinit(XOUT,CostFunction,verbosity,levMarq);
     */
    mlfAssign(
      &OLDX,
      mlfNlsq_lsinit(&OLDF, NULL, XOUT, *CostFunction, verbosity, levMarq));
    /*
     * PCNT = 0;
     */
    mlfAssign(&PCNT, mlfScalar(0.0));
    /*
     * EstSum=0.5;
     */
    mlfAssign(&EstSum, mlfScalar(0.5));
    /*
     * 
     * % system of equations or overdetermined
     * if nfun >= numberOfVariables
     */
    if (mlfTobool(mlfGe(nfun, numberOfVariables))) {
        /*
         * GradFactor = 0;  
         */
        mlfAssign(&GradFactor, mlfScalar(0.0));
    /*
     * else % underdetermined: singularity in JAC'*JAC or GRAD*GRAD' 
     */
    } else {
        /*
         * GradFactor = 1;
         */
        mlfAssign(&GradFactor, mlfScalar(1.0));
    /*
     * end
     */
    }
    /*
     * 
     * CHG = 1e-7*abs(XOUT)+1e-7*ones(numberOfVariables,1);
     */
    mlfAssign(
      &CHG,
      mlfPlus(
        mlfMtimes(mlfScalar(1e-7), mlfAbs(XOUT)),
        mlfMtimes(
          mlfScalar(1e-7), mlfOnes(numberOfVariables, mlfScalar(1.0), NULL))));
    /*
     * status=-1;
     */
    mlfAssign(&status, mlfScalar(-1.0));
    /*
     * 
     * while status~=1  & OPT_STOP == 0
     */
    for (;;) {
        mxArray * a_ = mclInitialize(mlfNe(status, mlfScalar(1.0)));
        if (mlfTobool(a_)
            && mlfTobool(mlfAnd(a_, mlfEq(OPT_STOP, mlfScalar(0.0))))) {
            mxDestroyArray(a_);
        } else {
            mxDestroyArray(a_);
            break;
        }
        /*
         * iter = iter + 1;
         */
        mlfAssign(&iter, mlfPlus(iter, mlfScalar(1.0)));
        /*
         * % Work Out Gradients
         * if ~(gradflag) | DerivativeCheck
         */
        {
            mxArray * a_ = mclInitialize(mlfNot(gradflag));
            if (mlfTobool(a_) || mlfTobool(mlfOr(a_, DerivativeCheck))) {
                mxDestroyArray(a_);
                /*
                 * JACFD = JAC;  % set to correct size
                 */
                mlfAssign(&JACFD, *JAC);
                /*
                 * OLDF=CostFunction;
                 */
                mlfAssign(&OLDF, *CostFunction);
                /*
                 * CHG = sign(CHG+eps).*min(max(abs(CHG),DiffMinChange),DiffMaxChange);
                 */
                mlfAssign(
                  &CHG,
                  mlfTimes(
                    mlfSign(mlfPlus(CHG, mlfEps())),
                    mlfMin(
                      NULL,
                      mlfMax(NULL, mlfAbs(CHG), DiffMinChange, NULL),
                      DiffMaxChange,
                      NULL)));
                /*
                 * for gcnt=1:numberOfVariables
                 */
                for (mclForStart(
                       &iterator_0, mlfScalar(1.0), numberOfVariables, NULL);
                     mclForNext(&iterator_0, &gcnt);
                     ) {
                    /*
                     * temp = XOUT(gcnt);
                     */
                    mlfAssign(&temp, mlfIndexRef(XOUT, "(?)", gcnt));
                    /*
                     * XOUT(gcnt) = temp +CHG(gcnt);
                     */
                    mlfIndexAssign(
                      &XOUT,
                      "(?)",
                      gcnt,
                      mlfPlus(temp, mlfIndexRef(CHG, "(?)", gcnt)));
                    /*
                     * x(:) = XOUT;
                     */
                    mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), XOUT);
                    /*
                     * CostFunction = feval(funfcn{3},x,varargin{:});  
                     */
                    mlfAssign(
                      CostFunction,
                      mlfFeval(
                        mclValueVarargout(),
                        mclFevalLookup(
                          mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                          1,
                          local_function_table_),
                        x,
                        mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                        NULL));
                    /*
                     * if ~isempty(YDATA)
                     */
                    if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                        /*
                         * CostFunction = CostFunction - YDATA;
                         */
                        mlfAssign(CostFunction, mlfMinus(*CostFunction, YDATA));
                    /*
                     * end
                     */
                    }
                    /*
                     * CostFunction = CostFunction(:);
                     */
                    mlfAssign(
                      CostFunction,
                      mlfIndexRef(*CostFunction, "(?)", mlfCreateColonIndex()));
                    /*
                     * OPT_STEP = 0; % We're in gradient finding mode
                     */
                    mlfAssign(&OPT_STEP, mlfScalar(0.0));
                    /*
                     * JACFD(:,gcnt)=(CostFunction-OLDF)/(CHG(gcnt));
                     */
                    mlfIndexAssign(
                      &JACFD,
                      "(?,?)",
                      mlfCreateColonIndex(),
                      gcnt,
                      mlfMrdivide(
                        mlfMinus(*CostFunction, OLDF),
                        mlfIndexRef(CHG, "(?)", gcnt)));
                    /*
                     * XOUT(gcnt) = temp;
                     */
                    mlfIndexAssign(&XOUT, "(?)", gcnt, temp);
                /*
                 * end
                 */
                }
                /*
                 * CostFunction = OLDF;
                 */
                mlfAssign(CostFunction, OLDF);
                /*
                 * numFunEvals=numFunEvals+numberOfVariables;
                 */
                mlfAssign(
                  &numFunEvals, mlfPlus(numFunEvals, numberOfVariables));
                /*
                 * % Gradient check
                 * if DerivativeCheck == 1 & gradflag
                 */
                {
                    mxArray * a_ = mclInitialize(
                                     mlfEq(DerivativeCheck, mlfScalar(1.0)));
                    if (mlfTobool(a_) && mlfTobool(mlfAnd(a_, gradflag))) {
                        mxDestroyArray(a_);
                        /*
                         * 
                         * if isa(funfcn{3},'inline') 
                         */
                        if (mlfTobool(
                              mlfFeval(
                                mclValueVarargout(),
                                mlxIsa,
                                mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                                mxCreateString("inline"),
                                NULL))) {
                        /*
                         * % if using inlines, the gradient is in funfcn{4}
                         * %            graderr(JACFD, JAC, formula(funfcn{4})); %
                         * else 
                         */
                        } else {
                            /*
                             * % otherwise fun/grad in funfcn{3}
                             * graderr(JACFD, JAC,  funfcn{3});
                             */
                            mlfFeval(
                              mclAnsVarargout(),
                              mlxGraderr,
                              JACFD,
                              *JAC,
                              mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                              NULL);
                        /*
                         * end
                         */
                        }
                        /*
                         * DerivativeCheck = 0;
                         */
                        mlfAssign(&DerivativeCheck, mlfScalar(0.0));
                    /*
                     * else
                     */
                    } else {
                        mxDestroyArray(a_);
                        /*
                         * JAC = JACFD;
                         */
                        mlfAssign(JAC, JACFD);
                    }
                /*
                 * end
                 */
                }
            /*
             * else
             */
            } else {
                mxDestroyArray(a_);
                /*
                 * x(:) = XOUT;
                 */
                mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), XOUT);
            }
        /*
         * end
         */
        }
        /*
         * 
         * % Try to set difference to 1e-8 for next iteration
         * if nfun==1  % JAC is a column vector or scalar, don't sum over rows
         */
        if (mlfTobool(mlfEq(nfun, mlfScalar(1.0)))) {
            /*
             * sumabsJAC = abs(JAC);
             */
            mlfAssign(&sumabsJAC, mlfAbs(*JAC));
        /*
         * else  % JAC is a row vector or matrix
         */
        } else {
            /*
             * sumabsJAC = sum(abs(JAC)')';  % Sum over the rows of JAC
             */
            mlfAssign(
              &sumabsJAC,
              mlfCtranspose(mlfSum(mlfCtranspose(mlfAbs(*JAC)), NULL)));
        /*
         * end
         */
        }
        /*
         * nonZeroSum = (sumabsJAC~=0);
         */
        mlfAssign(&nonZeroSum, mlfNe(sumabsJAC, mlfScalar(0.0)));
        /*
         * CHG(~nonZeroSum) = Inf;  % to avoid divide by zero error
         */
        mlfIndexAssign(&CHG, "(?)", mlfNot(nonZeroSum), mlfInf());
        /*
         * CHG(nonZeroSum) = nfun*1e-8./sumabsJAC(nonZeroSum);
         */
        mlfIndexAssign(
          &CHG,
          "(?)",
          nonZeroSum,
          mlfRdivide(
            mlfMtimes(nfun, mlfScalar(1e-8)),
            mlfIndexRef(sumabsJAC, "(?)", nonZeroSum)));
        /*
         * 
         * OPT_STEP = 2; % Entering line search    
         */
        mlfAssign(&OPT_STEP, mlfScalar(2.0));
        /*
         * 
         * GradF = 2*(CostFunction'*JAC)'; %2*GRAD*CostFunction;
         */
        mlfAssign(
          &GradF,
          mlfMtimes(
            mlfScalar(2.0),
            mlfCtranspose(mlfMtimes(mlfCtranspose(*CostFunction), *JAC))));
        /*
         * NewF = CostFunction'*CostFunction;
         */
        mlfAssign(
          &NewF, mlfMtimes(mlfCtranspose(*CostFunction), *CostFunction));
        /*
         * %---------------Initialization of Search Direction------------------
         * if status==-1
         */
        if (mlfTobool(mlfEq(status, mlfScalar(-1.0)))) {
            /*
             * if cond(JAC)>1e8 
             */
            if (mlfTobool(mlfGt(mlfCond(*JAC, NULL), mlfScalar(1e8)))) {
                /*
                 * %         SD=-(GRAD*GRAD'+(norm(GRAD)+1)*(eye(numberOfVariables,numberOfVariables)))\(GRAD*CostFunction);
                 * SD=-(JAC'*JAC+(norm(JAC)+1)*(eye(numberOfVariables,numberOfVariables)))\(CostFunction'*JAC)';
                 */
                mlfAssign(
                  &SD,
                  mlfMldivide(
                    mlfUminus(
                      mlfPlus(
                        mlfMtimes(mlfCtranspose(*JAC), *JAC),
                        mlfMtimes(
                          mlfPlus(mlfNorm(*JAC, NULL), mlfScalar(1.0)),
                          mlfEye(numberOfVariables, numberOfVariables)))),
                    mlfCtranspose(
                      mlfMtimes(mlfCtranspose(*CostFunction), *JAC))));
                /*
                 * if levMarq 
                 */
                if (mlfTobool(levMarq)) {
                    /*
                     * GradFactor=norm(JAC)+1; 
                     */
                    mlfAssign(
                      &GradFactor,
                      mlfPlus(mlfNorm(*JAC, NULL), mlfScalar(1.0)));
                /*
                 * end
                 */
                }
                /*
                 * how='COND';
                 */
                mlfAssign(&how, mxCreateString("COND"));
            /*
             * else
             */
            } else {
                /*
                 * % SD=JAC\(JAC*X-F)-X;
                 * SD=-(JAC'*JAC+GradFactor*(eye(numberOfVariables,numberOfVariables)))\(CostFunction'*JAC)';
                 */
                mlfAssign(
                  &SD,
                  mlfMldivide(
                    mlfUminus(
                      mlfPlus(
                        mlfMtimes(mlfCtranspose(*JAC), *JAC),
                        mlfMtimes(
                          GradFactor,
                          mlfEye(numberOfVariables, numberOfVariables)))),
                    mlfCtranspose(
                      mlfMtimes(mlfCtranspose(*CostFunction), *JAC))));
            /*
             * end
             */
            }
            /*
             * FIRSTF=NewF;
             */
            mlfAssign(&FIRSTF, NewF);
            /*
             * OLDJ = JAC;
             */
            mlfAssign(&OLDJ, *JAC);
            /*
             * GDOLD=GradF'*SD;
             */
            mlfAssign(&GDOLD, mlfMtimes(mlfCtranspose(GradF), SD));
            /*
             * % currstepsize controls the initial starting step-size.
             * % If currstepsize has been set externally then it will
             * % be non-zero, otherwise set to 1.
             * if currstepsize == 0, 
             */
            if (mlfTobool(mlfEq(currstepsize, mlfScalar(0.0)))) {
                /*
                 * currstepsize=1; 
                 */
                mlfAssign(&currstepsize, mlfScalar(1.0));
            /*
             * end
             */
            }
            /*
             * if verbosity>1
             */
            if (mlfTobool(mlfGt(verbosity, mlfScalar(1.0)))) {
                /*
                 * disp(sprintf(formatstr,iter,numFunEvals,NewF,currstepsize,GDOLD));
                 */
                mlfDisp(
                  mlfSprintf(
                    NULL,
                    formatstr,
                    iter,
                    numFunEvals,
                    NewF,
                    currstepsize,
                    GDOLD,
                    NULL));
            /*
             * end
             */
            }
            /*
             * XOUT=XOUT+currstepsize*SD;
             */
            mlfAssign(&XOUT, mlfPlus(XOUT, mlfMtimes(currstepsize, SD)));
            /*
             * if levMarq
             */
            if (mlfTobool(levMarq)) {
                /*
                 * newf=JAC*SD+CostFunction;
                 */
                mlfAssign(&newf, mlfPlus(mlfMtimes(*JAC, SD), *CostFunction));
                /*
                 * GradFactor=newf'*newf;
                 */
                mlfAssign(&GradFactor, mlfMtimes(mlfCtranspose(newf), newf));
                /*
                 * SD=-(JAC'*JAC+GradFactor*(eye(numberOfVariables,numberOfVariables)))\(CostFunction'*JAC)'; 
                 */
                mlfAssign(
                  &SD,
                  mlfMldivide(
                    mlfUminus(
                      mlfPlus(
                        mlfMtimes(mlfCtranspose(*JAC), *JAC),
                        mlfMtimes(
                          GradFactor,
                          mlfEye(numberOfVariables, numberOfVariables)))),
                    mlfCtranspose(
                      mlfMtimes(mlfCtranspose(*CostFunction), *JAC))));
            /*
             * end
             */
            }
            /*
             * newf=JAC*SD+CostFunction;
             */
            mlfAssign(&newf, mlfPlus(mlfMtimes(*JAC, SD), *CostFunction));
            /*
             * XOUT=XOUT+currstepsize*SD;
             */
            mlfAssign(&XOUT, mlfPlus(XOUT, mlfMtimes(currstepsize, SD)));
            /*
             * EstSum=newf'*newf;
             */
            mlfAssign(&EstSum, mlfMtimes(mlfCtranspose(newf), newf));
            /*
             * status=0;
             */
            mlfAssign(&status, mlfScalar(0.0));
            /*
             * if lineSearchType==0; 
             */
            if (mlfTobool(mlfEq(lineSearchType, mlfScalar(0.0)))) {
                /*
                 * PCNT=1; 
                 */
                mlfAssign(&PCNT, mlfScalar(1.0));
            /*
             * end
             */
            }
        /*
         * 
         * else
         */
        } else {
            /*
             * %-------------Direction Update------------------
             * gdnew=GradF'*SD;
             */
            mlfAssign(&gdnew, mlfMtimes(mlfCtranspose(GradF), SD));
            /*
             * if verbosity> 1 
             */
            if (mlfTobool(mlfGt(verbosity, mlfScalar(1.0)))) {
                /*
                 * num=sprintf(formatstr,iter,numFunEvals,NewF,currstepsize,gdnew);
                 */
                mlfAssign(
                  &num,
                  mlfSprintf(
                    NULL,
                    formatstr,
                    iter,
                    numFunEvals,
                    NewF,
                    currstepsize,
                    gdnew,
                    NULL));
            /*
             * end
             */
            }
            /*
             * if gdnew>0 & NewF>FIRSTF
             */
            {
                mxArray * a_ = mclInitialize(mlfGt(gdnew, mlfScalar(0.0)));
                if (mlfTobool(a_)
                    && mlfTobool(mlfAnd(a_, mlfGt(NewF, FIRSTF)))) {
                    mxDestroyArray(a_);
                    /*
                     * % Case 1: New function is bigger than last and gradient w.r.t. SD -ve
                     * % ... interpolate. 
                     * how='inter';
                     */
                    mlfAssign(&how, mxCreateString("inter"));
                    /*
                     * [stepsize]=cubici1(NewF,FIRSTF,gdnew,GDOLD,currstepsize);
                     */
                    mlfAssign(
                      &stepsize,
                      mlfCubici1(NewF, FIRSTF, gdnew, GDOLD, currstepsize));
                    /*
                     * currstepsize=0.9*stepsize;
                     */
                    mlfAssign(
                      &currstepsize, mlfMtimes(mlfScalar(0.9), stepsize));
                /*
                 * elseif NewF<FIRSTF
                 */
                } else {
                    mxDestroyArray(a_);
                    if (mlfTobool(mlfLt(NewF, FIRSTF))) {
                        /*
                         * %  New function less than old fun. and OK for updating 
                         * %         .... update and calculate new direction. 
                         * [newstep,fbest] =cubici3(NewF,FIRSTF,gdnew,GDOLD,currstepsize);
                         */
                        mlfAssign(
                          &newstep,
                          mlfCubici3(
                            &fbest, NewF, FIRSTF, gdnew, GDOLD, currstepsize));
                        /*
                         * if fbest>NewF,
                         */
                        if (mlfTobool(mlfGt(fbest, NewF))) {
                            /*
                             * fbest=0.9*NewF; 
                             */
                            mlfAssign(&fbest, mlfMtimes(mlfScalar(0.9), NewF));
                        /*
                         * end 
                         */
                        }
                        /*
                         * if gdnew<0
                         */
                        if (mlfTobool(mlfLt(gdnew, mlfScalar(0.0)))) {
                            /*
                             * how='incstep';
                             */
                            mlfAssign(&how, mxCreateString("incstep"));
                            /*
                             * if newstep<currstepsize,  
                             */
                            if (mlfTobool(mlfLt(newstep, currstepsize))) {
                                /*
                                 * newstep=(2*currstepsize+1e-4); how=[how,'IF']; 
                                 */
                                mlfAssign(
                                  &newstep,
                                  mlfPlus(
                                    mlfMtimes(mlfScalar(2.0), currstepsize),
                                    mlfScalar(1e-4)));
                                mlfAssign(
                                  &how,
                                  mlfHorzcat(how, mxCreateString("IF"), NULL));
                            /*
                             * end
                             */
                            }
                            /*
                             * currstepsize=abs(newstep);
                             */
                            mlfAssign(&currstepsize, mlfAbs(newstep));
                        /*
                         * else 
                         */
                        } else {
                            /*
                             * if currstepsize>0.9
                             */
                            if (mlfTobool(
                                  mlfGt(currstepsize, mlfScalar(0.9)))) {
                                /*
                                 * how='int_step';
                                 */
                                mlfAssign(&how, mxCreateString("int_step"));
                                /*
                                 * currstepsize=min([1,abs(newstep)]);
                                 */
                                mlfAssign(
                                  &currstepsize,
                                  mlfMin(
                                    NULL,
                                    mlfHorzcat(
                                      mlfScalar(1.0), mlfAbs(newstep), NULL),
                                    NULL,
                                    NULL));
                            /*
                             * end
                             */
                            }
                        /*
                         * end
                         */
                        }
                        /*
                         * % SET DIRECTION.      
                         * % Gauss-Newton Method    
                         * temp=1;
                         */
                        mlfAssign(&temp, mlfScalar(1.0));
                        /*
                         * if ~levMarq
                         */
                        if (mlfTobool(mlfNot(levMarq))) {
                            /*
                             * if currstepsize>1e-8 & cond(JAC)<1e8
                             */
                            mxArray * a_ = mclInitialize(
                                             mlfGt(
                                               currstepsize, mlfScalar(1e-8)));
                            if (mlfTobool(a_)
                                && mlfTobool(
                                     mlfAnd(
                                       a_,
                                       mlfLt(
                                         mlfCond(*JAC, NULL),
                                         mlfScalar(1e8))))) {
                                mxDestroyArray(a_);
                                /*
                                 * SD=JAC\(JAC*XOUT-CostFunction)-XOUT;
                                 */
                                mlfAssign(
                                  &SD,
                                  mlfMinus(
                                    mlfMldivide(
                                      *JAC,
                                      mlfMinus(
                                        mlfMtimes(*JAC, XOUT), *CostFunction)),
                                    XOUT));
                                /*
                                 * if SD'*GradF>eps,
                                 */
                                if (mlfTobool(
                                      mlfGt(
                                        mlfMtimes(mlfCtranspose(SD), GradF),
                                        mlfEps()))) {
                                    /*
                                     * how='ERROR- GN not descent direction';
                                     */
                                    mlfAssign(
                                      &how,
                                      mxCreateString(
                                        "ERROR- GN not descent direction"));
                                /*
                                 * end
                                 */
                                }
                                /*
                                 * temp=0;
                                 */
                                mlfAssign(&temp, mlfScalar(0.0));
                            /*
                             * else
                             */
                            } else {
                                mxDestroyArray(a_);
                                /*
                                 * if verbosity > 0
                                 */
                                if (mlfTobool(
                                      mlfGt(verbosity, mlfScalar(0.0)))) {
                                    /*
                                     * disp('Conditioning of Gradient Poor - Switching To LM method')
                                     */
                                    mlfDisp(
                                      mxCreateString(
                                        "Conditioning of Gradient Poor"
                                        " - Switching To LM method"));
                                /*
                                 * end
                                 */
                                }
                                /*
                                 * how='CHG2LM';
                                 */
                                mlfAssign(&how, mxCreateString("CHG2LM"));
                                /*
                                 * levMarq=1;
                                 */
                                mlfAssign(&levMarq, mlfScalar(1.0));
                                /*
                                 * currstepsize=abs(currstepsize);               
                                 */
                                mlfAssign(&currstepsize, mlfAbs(currstepsize));
                            }
                        /*
                         * end
                         * end
                         */
                        }
                        /*
                         * 
                         * if (temp)      
                         */
                        if (mlfTobool(temp)) {
                            /*
                             * % Levenberg_marquardt Method N.B. EstSum is the estimated sum of squares.
                             * %                                 GradFactor is the value of lambda.
                             * % Estimated Residual:
                             * if EstSum>fbest
                             */
                            if (mlfTobool(mlfGt(EstSum, fbest))) {
                                /*
                                 * GradFactor=GradFactor/(1+currstepsize);
                                 */
                                mlfAssign(
                                  &GradFactor,
                                  mlfMrdivide(
                                    GradFactor,
                                    mlfPlus(mlfScalar(1.0), currstepsize)));
                            /*
                             * else
                             */
                            } else {
                                /*
                                 * GradFactor=GradFactor+(fbest-EstSum)/(currstepsize+eps);
                                 */
                                mlfAssign(
                                  &GradFactor,
                                  mlfPlus(
                                    GradFactor,
                                    mlfMrdivide(
                                      mlfMinus(fbest, EstSum),
                                      mlfPlus(currstepsize, mlfEps()))));
                            /*
                             * end
                             */
                            }
                            /*
                             * SD=-(JAC'*JAC+GradFactor*(eye(numberOfVariables,numberOfVariables)))\(CostFunction'*JAC)'; 
                             */
                            mlfAssign(
                              &SD,
                              mlfMldivide(
                                mlfUminus(
                                  mlfPlus(
                                    mlfMtimes(mlfCtranspose(*JAC), *JAC),
                                    mlfMtimes(
                                      GradFactor,
                                      mlfEye(
                                        numberOfVariables,
                                        numberOfVariables)))),
                                mlfCtranspose(
                                  mlfMtimes(
                                    mlfCtranspose(*CostFunction), *JAC))));
                            /*
                             * currstepsize=1; 
                             */
                            mlfAssign(&currstepsize, mlfScalar(1.0));
                            /*
                             * estf=JAC*SD+CostFunction;
                             */
                            mlfAssign(
                              &estf,
                              mlfPlus(mlfMtimes(*JAC, SD), *CostFunction));
                            /*
                             * EstSum=estf'*estf;
                             */
                            mlfAssign(
                              &EstSum, mlfMtimes(mlfCtranspose(estf), estf));
                            /*
                             * if verbosity> 1
                             */
                            if (mlfTobool(mlfGt(verbosity, mlfScalar(1.0)))) {
                                /*
                                 * num=[num,sprintf('%12.6g ',GradFactor)]; 
                                 */
                                mlfAssign(
                                  &num,
                                  mlfHorzcat(
                                    num,
                                    mlfSprintf(
                                      NULL,
                                      mxCreateString("%12.6g "),
                                      GradFactor,
                                      NULL),
                                    NULL));
                            /*
                             * end
                             */
                            }
                        /*
                         * end
                         */
                        }
                        /*
                         * gdnew=GradF'*SD;
                         */
                        mlfAssign(&gdnew, mlfMtimes(mlfCtranspose(GradF), SD));
                        /*
                         * 
                         * OLDX=XOUT;
                         */
                        mlfAssign(&OLDX, XOUT);
                        /*
                         * % Save Variables
                         * FIRSTF=NewF;
                         */
                        mlfAssign(&FIRSTF, NewF);
                        /*
                         * OLDG=GradF;
                         */
                        mlfAssign(&OLDG, GradF);
                        /*
                         * GDOLD=gdnew;    
                         */
                        mlfAssign(&GDOLD, gdnew);
                        /*
                         * 
                         * % If quadratic interpolation set PCNT
                         * if lineSearchType==0, 
                         */
                        if (mlfTobool(mlfEq(lineSearchType, mlfScalar(0.0)))) {
                            /*
                             * PCNT=1; MATX=zeros(3,1); MATL(1)=NewF; 
                             */
                            mlfAssign(&PCNT, mlfScalar(1.0));
                            mlfAssign(
                              &MATX,
                              mlfZeros(mlfScalar(3.0), mlfScalar(1.0), NULL));
                            mlfIndexAssign(&MATL, "(?)", mlfScalar(1.0), NewF);
                        /*
                         * end
                         */
                        }
                    /*
                     * else 
                     */
                    } else {
                        /*
                         * % Halve Step-length
                         * how='Red_Step';
                         */
                        mlfAssign(&how, mxCreateString("Red_Step"));
                        /*
                         * if NewF==FIRSTF,
                         */
                        if (mlfTobool(mlfEq(NewF, FIRSTF))) {
                            /*
                             * if verbosity>0
                             */
                            if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                                /*
                                 * disp('No improvement in search direction: Terminating')
                                 */
                                mlfDisp(
                                  mxCreateString(
                                    "No improvement in search "
                                    "direction: Terminating"));
                            /*
                             * end
                             */
                            }
                            /*
                             * status=1;
                             */
                            mlfAssign(&status, mlfScalar(1.0));
                            /*
                             * EXITFLAG = -1;
                             */
                            mlfAssign(EXITFLAG, mlfScalar(-1.0));
                        /*
                         * else
                         */
                        } else {
                            /*
                             * currstepsize=currstepsize/8;
                             */
                            mlfAssign(
                              &currstepsize,
                              mlfMrdivide(currstepsize, mlfScalar(8.0)));
                            /*
                             * if currstepsize<1e-8
                             */
                            if (mlfTobool(
                                  mlfLt(currstepsize, mlfScalar(1e-8)))) {
                                /*
                                 * currstepsize=-currstepsize;
                                 */
                                mlfAssign(
                                  &currstepsize, mlfUminus(currstepsize));
                            /*
                             * end
                             */
                            }
                        /*
                         * end
                         */
                        }
                    }
                }
            /*
             * end
             */
            }
            /*
             * XOUT=OLDX+currstepsize*SD;
             */
            mlfAssign(&XOUT, mlfPlus(OLDX, mlfMtimes(currstepsize, SD)));
            /*
             * if isinf(verbosity)
             */
            if (mlfTobool(mlfIsinf(verbosity))) {
                /*
                 * disp([num,'       ',how])
                 */
                mlfDisp(mlfHorzcat(num, mxCreateString("       "), how, NULL));
            /*
             * elseif verbosity>1
             */
            } else if (mlfTobool(mlfGt(verbosity, mlfScalar(1.0)))) {
                /*
                 * disp(num)
                 */
                mlfDisp(num);
            /*
             * end
             */
            }
        /*
         * 
         * end %----------End of Direction Update-------------------
         */
        }
        /*
         * if lineSearchType==0, 
         */
        if (mlfTobool(mlfEq(lineSearchType, mlfScalar(0.0)))) {
            /*
             * PCNT=1; MATX=zeros(3,1);  MATL(1)=NewF; 
             */
            mlfAssign(&PCNT, mlfScalar(1.0));
            mlfAssign(&MATX, mlfZeros(mlfScalar(3.0), mlfScalar(1.0), NULL));
            mlfIndexAssign(&MATL, "(?)", mlfScalar(1.0), NewF);
        /*
         * end
         */
        }
        /*
         * % Check Termination 
         * if max(abs(SD))< tolX 
         */
        if (mlfTobool(mlfLt(mlfMax(NULL, mlfAbs(SD), NULL, NULL), tolX))) {
            /*
             * if verbosity > 0
             */
            if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                /*
                 * disp('Optimization terminated successfully:') 
                 */
                mlfDisp(
                  mxCreateString("Optimization terminated successfully:"));
                /*
                 * disp(' Search direction less than tolX')     
                 */
                mlfDisp(mxCreateString(" Search direction less than tolX"));
            /*
             * end
             */
            }
            /*
             * status=1; EXITFLAG=1;
             */
            mlfAssign(&status, mlfScalar(1.0));
            mlfAssign(EXITFLAG, mlfScalar(1.0));
        /*
         * elseif (GradF'*SD) < tolFun & ...
         */
        } else {
            mxArray * a_ = mclInitialize(
                             mlfLt(
                               mlfMtimes(mlfCtranspose(GradF), SD), tolFun));
            if (mlfTobool(a_)
                && mlfTobool(
                     mlfAnd(
                       a_,
                       mlfLt(
                         mlfMax(NULL, mlfAbs(GradF), NULL, NULL),
                         mlfMtimes(
                           mlfScalar(10.0), mlfPlus(tolFun, tolX)))))) {
                mxDestroyArray(a_);
                /*
                 * max(abs(GradF)) < 10*(tolFun+tolX)
                 * if verbosity > 0
                 */
                if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                    /*
                     * disp('Optimization terminated successfully:') 
                     */
                    mlfDisp(
                      mxCreateString("Optimization terminated successfully:"));
                    /*
                     * disp(' Gradient in the search direction less than tolFun') 
                     */
                    mlfDisp(
                      mxCreateString(
                        " Gradient in the search direction less than tolFun"));
                    /*
                     * disp(' Gradient less than 10*(tolFun+tolX)')  
                     */
                    mlfDisp(
                      mxCreateString(" Gradient less than 10*(tolFun+tolX)"));
                /*
                 * end
                 */
                }
                /*
                 * status=1; EXITFLAG=1;
                 */
                mlfAssign(&status, mlfScalar(1.0));
                mlfAssign(EXITFLAG, mlfScalar(1.0));
            /*
             * 
             * elseif numFunEvals > maxFunEvals
             */
            } else {
                mxDestroyArray(a_);
                if (mlfTobool(mlfGt(numFunEvals, maxFunEvals))) {
                    /*
                     * if verbosity>0
                     */
                    if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                        /*
                         * disp('maximum number of function evaluations has been exceeded');
                         */
                        mlfDisp(
                          mxCreateString(
                            "maximum number of function eva"
                            "luations has been exceeded"));
                        /*
                         * disp('Increase OPTIONS.maxFunEvals')
                         */
                        mlfDisp(mxCreateString("Increase OPTIONS.maxFunEvals"));
                    /*
                     * end
                     */
                    }
                    /*
                     * status=1;
                     */
                    mlfAssign(&status, mlfScalar(1.0));
                    /*
                     * EXITFLAG = 0;
                     */
                    mlfAssign(EXITFLAG, mlfScalar(0.0));
                /*
                 * elseif iter > maxIter
                 */
                } else if (mlfTobool(mlfGt(iter, maxIter))) {
                    /*
                     * if verbosity>0
                     */
                    if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                        /*
                         * disp('maximum number of iterations has been exceeded');
                         */
                        mlfDisp(
                          mxCreateString(
                            "maximum number of iterations has been exceeded"));
                        /*
                         * disp('Increase OPTIONS.iterations')
                         */
                        mlfDisp(mxCreateString("Increase OPTIONS.iterations"));
                    /*
                     * end
                     */
                    }
                    /*
                     * status=1;
                     */
                    mlfAssign(&status, mlfScalar(1.0));
                    /*
                     * EXITFLAG = 0;
                     */
                    mlfAssign(EXITFLAG, mlfScalar(0.0));
                /*
                 * else
                 */
                } else {
                    /*
                     * % Line search using mixed polynomial interpolation and extrapolation.
                     * if PCNT~=0
                     */
                    if (mlfTobool(mlfNe(PCNT, mlfScalar(0.0)))) {
                        /*
                         * % initialize OX and OLDF 
                         * OX = XOUT; OLDF = CostFunction;
                         */
                        mlfAssign(&OX, XOUT);
                        mlfAssign(&OLDF, *CostFunction);
                        /*
                         * while PCNT > 0 & OPT_STOP == 0 & numFunEvals <= maxFunEvals
                         */
                        for (;;) {
                            mxArray * a_ = mclInitialize(
                                             mlfGt(PCNT, mlfScalar(0.0)));
                            if (mlfTobool(a_)) {
                                mlfAssign(
                                  &a_,
                                  mlfAnd(a_, mlfEq(OPT_STOP, mlfScalar(0.0))));
                            } else {
                                mlfAssign(&a_, mlfScalar(0));
                            }
                            if (mlfTobool(a_)
                                && mlfTobool(
                                     mlfAnd(
                                       a_, mlfLe(numFunEvals, maxFunEvals)))) {
                                mxDestroyArray(a_);
                            } else {
                                mxDestroyArray(a_);
                                break;
                            }
                            /*
                             * x(:) = XOUT; 
                             */
                            mlfIndexAssign(
                              &x, "(?)", mlfCreateColonIndex(), XOUT);
                            /*
                             * CostFunction = feval(funfcn{3},x,varargin{:});
                             */
                            mlfAssign(
                              CostFunction,
                              mlfFeval(
                                mclValueVarargout(),
                                mclFevalLookup(
                                  mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                                  1,
                                  local_function_table_),
                                x,
                                mlfIndexRef(
                                  varargin, "{?}", mlfCreateColonIndex()),
                                NULL));
                            /*
                             * if ~isempty(YDATA)
                             */
                            if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                                /*
                                 * CostFunction = CostFunction - YDATA;
                                 */
                                mlfAssign(
                                  CostFunction, mlfMinus(*CostFunction, YDATA));
                            /*
                             * end
                             */
                            }
                            /*
                             * CostFunction = CostFunction(:);
                             */
                            mlfAssign(
                              CostFunction,
                              mlfIndexRef(
                                *CostFunction, "(?)", mlfCreateColonIndex()));
                            /*
                             * numFunEvals=numFunEvals+1;
                             */
                            mlfAssign(
                              &numFunEvals,
                              mlfPlus(numFunEvals, mlfScalar(1.0)));
                            /*
                             * NewF = CostFunction'*CostFunction;
                             */
                            mlfAssign(
                              &NewF,
                              mlfMtimes(
                                mlfCtranspose(*CostFunction), *CostFunction));
                            /*
                             * % <= used in case when no improvement found.
                             * if NewF <= OLDF'*OLDF, 
                             */
                            if (mlfTobool(
                                  mlfLe(
                                    NewF,
                                    mlfMtimes(mlfCtranspose(OLDF), OLDF)))) {
                                /*
                                 * OX = XOUT; 
                                 */
                                mlfAssign(&OX, XOUT);
                                /*
                                 * OLDF=CostFunction; 
                                 */
                                mlfAssign(&OLDF, *CostFunction);
                            /*
                             * end
                             */
                            }
                            /*
                             * [PCNT,MATL,MATX,steplen,NewF,how]=searchq(PCNT,NewF,OLDX,MATL,MATX,SD,GDOLD,currstepsize,how);
                             */
                            mlfAssign(
                              &PCNT,
                              mlfSearchq(
                                &MATL,
                                &MATX,
                                &steplen,
                                &NewF,
                                &how,
                                PCNT,
                                NewF,
                                OLDX,
                                MATL,
                                MATX,
                                SD,
                                GDOLD,
                                currstepsize,
                                how));
                            /*
                             * currstepsize=steplen;
                             */
                            mlfAssign(&currstepsize, steplen);
                            /*
                             * XOUT=OLDX+steplen*SD;
                             */
                            mlfAssign(
                              &XOUT, mlfPlus(OLDX, mlfMtimes(steplen, SD)));
                            /*
                             * if NewF==FIRSTF,  
                             */
                            if (mlfTobool(mlfEq(NewF, FIRSTF))) {
                                /*
                                 * PCNT=0; 
                                 */
                                mlfAssign(&PCNT, mlfScalar(0.0));
                            /*
                             * end
                             */
                            }
                        /*
                         * end % end while
                         */
                        }
                        /*
                         * XOUT = OX;
                         */
                        mlfAssign(&XOUT, OX);
                        /*
                         * CostFunction=OLDF;
                         */
                        mlfAssign(CostFunction, OLDF);
                        /*
                         * if numFunEvals>maxFunEvals 
                         */
                        if (mlfTobool(mlfGt(numFunEvals, maxFunEvals))) {
                            /*
                             * if verbosity > 0
                             */
                            if (mlfTobool(mlfGt(verbosity, mlfScalar(0.0)))) {
                                /*
                                 * disp('Maximum number of function evaluations exceeded;')
                                 */
                                mlfDisp(
                                  mxCreateString(
                                    "Maximum number of function"
                                    " evaluations exceeded;"));
                                /*
                                 * disp('   increase maxFunEvals.')
                                 */
                                mlfDisp(
                                  mxCreateString("   increase maxFunEvals."));
                            /*
                             * end              
                             */
                            }
                            /*
                             * status=1; 
                             */
                            mlfAssign(&status, mlfScalar(1.0));
                            /*
                             * EXITFLAG = 0;
                             */
                            mlfAssign(EXITFLAG, mlfScalar(0.0));
                        /*
                         * end
                         */
                        }
                    /*
                     * end % if PCNT~=0
                     */
                    }
                }
            }
        /*
         * end % if max
         */
        }
        /*
         * OPT_STEP = 1; % Call the next iteration a major step for plotting etc.
         */
        mlfAssign(&OPT_STEP, mlfScalar(1.0));
        /*
         * 
         * x(:)=XOUT; 
         */
        mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), XOUT);
        /*
         * switch funfcn{1}
         */
        {
            mxArray * t_ = mclUnassigned();
            mlfAssign(&t_, mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)));
            /*
             * case 'fun'
             */
            if (mclSwitchCompare(t_, mxCreateString("fun"))) {
                /*
                 * CostFunction = feval(funfcn{3},x,varargin{:});
                 */
                mlfAssign(
                  CostFunction,
                  mlfFeval(
                    mclValueVarargout(),
                    mclFevalLookup(
                      mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                      1,
                      local_function_table_),
                    x,
                    mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                    NULL));
                /*
                 * if ~isempty(YDATA)
                 */
                if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                    /*
                     * CostFunction = CostFunction - YDATA;
                     */
                    mlfAssign(CostFunction, mlfMinus(*CostFunction, YDATA));
                /*
                 * end
                 */
                }
                /*
                 * CostFunction = CostFunction(:);
                 */
                mlfAssign(
                  CostFunction,
                  mlfIndexRef(*CostFunction, "(?)", mlfCreateColonIndex()));
                /*
                 * nfun=length(CostFunction);
                 */
                mlfAssign(&nfun, mlfLength(*CostFunction));
                /*
                 * JAC = zeros(nfun, numberOfVariables);
                 */
                mlfAssign(JAC, mlfZeros(nfun, numberOfVariables, NULL));
            /*
             * case 'fungrad'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fungrad"))) {
                /*
                 * [CostFunction,JAC] = feval(funfcn{3},x,varargin{:});
                 */
                mlfFeval(
                  mlfVarargout(CostFunction, JAC, NULL),
                  mclFevalLookup(
                    mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                    1,
                    local_function_table_),
                  x,
                  mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                  NULL);
                /*
                 * if ~isempty(YDATA)
                 */
                if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                    /*
                     * CostFunction = CostFunction - YDATA;
                     */
                    mlfAssign(CostFunction, mlfMinus(*CostFunction, YDATA));
                /*
                 * end
                 */
                }
                /*
                 * CostFunction = CostFunction(:);
                 */
                mlfAssign(
                  CostFunction,
                  mlfIndexRef(*CostFunction, "(?)", mlfCreateColonIndex()));
                /*
                 * numGradEvals=numGradEvals+1;
                 */
                mlfAssign(&numGradEvals, mlfPlus(numGradEvals, mlfScalar(1.0)));
            /*
             * case 'fun_then_grad'
             */
            } else if (mclSwitchCompare(t_, mxCreateString("fun_then_grad"))) {
                /*
                 * CostFunction = feval(funfcn{3},x,varargin{:}); 
                 */
                mlfAssign(
                  CostFunction,
                  mlfFeval(
                    mclValueVarargout(),
                    mclFevalLookup(
                      mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                      1,
                      local_function_table_),
                    x,
                    mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                    NULL));
                /*
                 * if ~isempty(YDATA)
                 */
                if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                    /*
                     * CostFunction = CostFunction - YDATA;
                     */
                    mlfAssign(CostFunction, mlfMinus(*CostFunction, YDATA));
                /*
                 * end
                 */
                }
                /*
                 * CostFunction = CostFunction(:);
                 */
                mlfAssign(
                  CostFunction,
                  mlfIndexRef(*CostFunction, "(?)", mlfCreateColonIndex()));
                /*
                 * JAC = feval(funfcn{4},x,varargin{:});
                 */
                mlfAssign(
                  JAC,
                  mlfFeval(
                    mclValueVarargout(),
                    mclFevalLookup(
                      mlfIndexRef(funfcn, "{?}", mlfScalar(4.0)),
                      1,
                      local_function_table_),
                    x,
                    mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                    NULL));
                /*
                 * numGradEvals=numGradEvals+1;
                 */
                mlfAssign(&numGradEvals, mlfPlus(numGradEvals, mlfScalar(1.0)));
            /*
             * otherwise
             */
            } else {
                /*
                 * error('Undefined calltype in LSQNONLIN');
                 */
                mlfError(mxCreateString("Undefined calltype in LSQNONLIN"));
            /*
             * end
             */
            }
            mxDestroyArray(t_);
        }
        /*
         * numFunEvals=numFunEvals+1;
         */
        mlfAssign(&numFunEvals, mlfPlus(numFunEvals, mlfScalar(1.0)));
    /*
     * 
     * end  % while
     */
    }
    /*
     * 
     * 
     * XOUT=OLDX;
     */
    mlfAssign(&XOUT, OLDX);
    /*
     * x(:)=XOUT;
     */
    mlfIndexAssign(&x, "(?)", mlfCreateColonIndex(), XOUT);
    /*
     * 
     * OUTPUT.iterations = iter;
     */
    mlfIndexAssign(OUTPUT, ".iterations", iter);
    /*
     * OUTPUT.funcCount = numFunEvals;
     */
    mlfIndexAssign(OUTPUT, ".funcCount", numFunEvals);
    /*
     * OUTPUT.stepsize=currstepsize;
     */
    mlfIndexAssign(OUTPUT, ".stepsize", currstepsize);
    /*
     * OUTPUT.cgiterations = [];
     */
    mlfIndexAssign(OUTPUT, ".cgiterations", mclCreateEmptyArray());
    /*
     * OUTPUT.firstorderopt = [];
     */
    mlfIndexAssign(OUTPUT, ".firstorderopt", mclCreateEmptyArray());
    /*
     * 
     * if levMarq
     */
    if (mlfTobool(levMarq)) {
        /*
         * OUTPUT.algorithm='medium-scale: Levenberg-Marquardt, line-search';
         */
        mlfIndexAssign(
          OUTPUT,
          ".algorithm",
          mxCreateString("medium-scale: Levenberg-Marquardt, line-search"));
    /*
     * else
     */
    } else {
        /*
         * OUTPUT.algorithm='medium-scale: Gauss-Newton, line-search';
         */
        mlfIndexAssign(
          OUTPUT,
          ".algorithm",
          mxCreateString("medium-scale: Gauss-Newton, line-search"));
    /*
     * end
     */
    }
    mclValidateOutputs(
      "optim/private/nlsq",
      5,
      nargout_,
      &x,
      CostFunction,
      JAC,
      EXITFLAG,
      OUTPUT);
    mxDestroyArray(CHG);
    mxDestroyArray(DerivativeCheck);
    mxDestroyArray(DiffMaxChange);
    mxDestroyArray(DiffMinChange);
    mxDestroyArray(EstSum);
    mxDestroyArray(FIRSTF);
    mxDestroyArray(GDOLD);
    mxDestroyArray(GradF);
    mxDestroyArray(GradFactor);
    mxDestroyArray(JACFD);
    mxDestroyArray(JACOB);
    mxDestroyArray(MATL);
    mxDestroyArray(MATX);
    mxDestroyArray(NewF);
    mxDestroyArray(OLDF);
    mxDestroyArray(OLDG);
    mxDestroyArray(OLDJ);
    mxDestroyArray(OLDX);
    mxDestroyArray(OX);
    mxDestroyArray(PCNT);
    mxDestroyArray(SD);
    mxDestroyArray(XOUT);
    mxDestroyArray(currstepsize);
    mxDestroyArray(estf);
    mxDestroyArray(fbest);
    mxDestroyArray(formatstr);
    mxDestroyArray(gcnt);
    mxDestroyArray(gdnew);
    mxDestroyArray(gradflag);
    mxDestroyArray(how);
    mxDestroyArray(iter);
    mxDestroyArray(levMarq);
    mxDestroyArray(lineSearchType);
    mxDestroyArray(maxFunEvals);
    mxDestroyArray(maxIter);
    mxDestroyArray(newf);
    mxDestroyArray(newstep);
    mxDestroyArray(nfun);
    mxDestroyArray(nonZeroSum);
    mxDestroyArray(num);
    mxDestroyArray(numFunEvals);
    mxDestroyArray(numGradEvals);
    mxDestroyArray(numberOfVariables);
    mxDestroyArray(status);
    mxDestroyArray(steplen);
    mxDestroyArray(stepsize);
    mxDestroyArray(sumabsJAC);
    mxDestroyArray(temp);
    mxDestroyArray(tolFun);
    mxDestroyArray(tolX);
    /*
     * 
     * %--end of leastsq--
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * function [xold,fold,how]=lsinit(xnew,fnew,verbosity,levMarq)
     * %LSINT  Function to initialize NLSQ routine.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.13 $  $Date: 1998/07/30 16:31:50 $
     * %   Andy Grace 7-9-90.
     * xold=xnew;
     * fold=fnew;
     * 
     * 
     * 
     * if verbosity>1
     * 
     * if ~levMarq
     * if isinf(verbosity)
     * header = sprintf(['\n                                                     Directional \n',...
     * ' Iteration  Func-count    Residual     Step-size      derivative   Line-search']);
     * else
     * header = sprintf(['\n                                                     Directional \n',...
     * ' Iteration  Func-count    Residual     Step-size      derivative ']);
     * end
     * else
     * if isinf(verbosity)
     * header = sprintf(['\n                                                     Directional \n',...
     * ' Iteration  Func-count    Residual     Step-size      derivative   Lambda       Line-search']);
     * else
     * header = sprintf(['\n                                                     Directional \n',...
     * ' Iteration  Func-count    Residual     Step-size      derivative    Lambda']);
     * end
     * end
     * disp(header)
     * end
     */
    return x;
}

/*
 * The function "mlfOptim_private_nlsq" contains the normal interface for the
 * "optim/private/nlsq" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 1-413). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_nlsq(mxArray * * CostFunction,
                                mxArray * * JAC,
                                mxArray * * EXITFLAG,
                                mxArray * * OUTPUT,
                                mxArray * funfcn,
                                mxArray * x_,
                                mxArray * verbosity,
                                mxArray * options,
                                mxArray * CostFunction_,
                                mxArray * JAC_,
                                mxArray * YDATA,
                                mxArray * caller,
                                ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 1;
    mxArray * x = mclGetUninitializedArray();
    mxArray * CostFunction__ = mclGetUninitializedArray();
    mxArray * JAC__ = mclGetUninitializedArray();
    mxArray * EXITFLAG__ = mclGetUninitializedArray();
    mxArray * OUTPUT__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, caller, 0);
    mlfEnterNewContext(
      4,
      -9,
      CostFunction,
      JAC,
      EXITFLAG,
      OUTPUT,
      funfcn,
      x_,
      verbosity,
      options,
      CostFunction_,
      JAC_,
      YDATA,
      caller,
      varargin);
    if (CostFunction != NULL) {
        ++nargout;
    }
    if (JAC != NULL) {
        ++nargout;
    }
    if (EXITFLAG != NULL) {
        ++nargout;
    }
    if (OUTPUT != NULL) {
        ++nargout;
    }
    x
      = Moptim_private_nlsq(
          &CostFunction__,
          &JAC__,
          &EXITFLAG__,
          &OUTPUT__,
          nargout,
          funfcn,
          x_,
          verbosity,
          options,
          CostFunction_,
          JAC_,
          YDATA,
          caller,
          varargin);
    mlfRestorePreviousContext(
      4,
      8,
      CostFunction,
      JAC,
      EXITFLAG,
      OUTPUT,
      funfcn,
      x_,
      verbosity,
      options,
      CostFunction_,
      JAC_,
      YDATA,
      caller);
    mxDestroyArray(varargin);
    if (CostFunction != NULL) {
        mclCopyOutputArg(CostFunction, CostFunction__);
    } else {
        mxDestroyArray(CostFunction__);
    }
    if (JAC != NULL) {
        mclCopyOutputArg(JAC, JAC__);
    } else {
        mxDestroyArray(JAC__);
    }
    if (EXITFLAG != NULL) {
        mclCopyOutputArg(EXITFLAG, EXITFLAG__);
    } else {
        mxDestroyArray(EXITFLAG__);
    }
    if (OUTPUT != NULL) {
        mclCopyOutputArg(OUTPUT, OUTPUT__);
    } else {
        mxDestroyArray(OUTPUT__);
    }
    return mlfReturnValue(x);
}

/*
 * The function "mlxOptim_private_nlsq" contains the feval interface for the
 * "optim/private/nlsq" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 1-413). The feval
 * function calls the implementation version of optim/private/nlsq through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxOptim_private_nlsq(int nlhs,
                           mxArray * plhs[],
                           int nrhs,
                           mxArray * prhs[]) {
    mxArray * mprhs[9];
    mxArray * mplhs[5];
    int i;
    if (nlhs > 5) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/nlsq Line: 1 Colu"
            "mn: 0 The function \"optim/private/nlsq\" was called "
            "with more than the declared number of outputs (5)"));
    }
    for (i = 0; i < 5; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 8 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 8; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    mprhs[8] = NULL;
    mlfAssign(&mprhs[8], mclCreateVararginCell(nrhs - 8, prhs + 8));
    mplhs[0]
      = Moptim_private_nlsq(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7],
          mprhs[8]);
    mlfRestorePreviousContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 5 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 5; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[8]);
}

/*
 * The function "Mnlsq_lsinit" is the implementation version of the
 * "nlsq/lsinit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 413-445). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [xold,fold,how]=lsinit(xnew,fnew,verbosity,levMarq)
 */
static mxArray * Mnlsq_lsinit(mxArray * * fold,
                              mxArray * * how,
                              int nargout_,
                              mxArray * xnew,
                              mxArray * fnew,
                              mxArray * verbosity,
                              mxArray * levMarq) {
    mxArray * xold = mclGetUninitializedArray();
    mxArray * header = mclGetUninitializedArray();
    mclValidateInputs("nlsq/lsinit", 4, &xnew, &fnew, &verbosity, &levMarq);
    /*
     * %LSINT  Function to initialize NLSQ routine.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.13 $  $Date: 1998/07/30 16:31:50 $
     * %   Andy Grace 7-9-90.
     * xold=xnew;
     */
    mlfAssign(&xold, xnew);
    /*
     * fold=fnew;
     */
    mlfAssign(fold, fnew);
    /*
     * 
     * 
     * 
     * if verbosity>1
     */
    if (mlfTobool(mlfGt(verbosity, mlfScalar(1.0)))) {
        /*
         * 
         * if ~levMarq
         */
        if (mlfTobool(mlfNot(levMarq))) {
            /*
             * if isinf(verbosity)
             */
            if (mlfTobool(mlfIsinf(verbosity))) {
                /*
                 * header = sprintf(['\n                                                     Directional \n',...
                 */
                mlfAssign(
                  &header,
                  mlfSprintf(
                    NULL,
                    mlfHorzcat(
                      mxCreateString(
                        "\\n                                  "
                        "                   Directional \\n"),
                      mxCreateString(
                        " Iteration  Func-count    Residual     S"
                        "tep-size      derivative   Line-search"),
                      NULL),
                    NULL));
            /*
             * ' Iteration  Func-count    Residual     Step-size      derivative   Line-search']);
             * else
             */
            } else {
                /*
                 * header = sprintf(['\n                                                     Directional \n',...
                 */
                mlfAssign(
                  &header,
                  mlfSprintf(
                    NULL,
                    mlfHorzcat(
                      mxCreateString(
                        "\\n                                  "
                        "                   Directional \\n"),
                      mxCreateString(
                        " Iteration  Func-count    Residual"
                        "     Step-size      derivative "),
                      NULL),
                    NULL));
            /*
             * ' Iteration  Func-count    Residual     Step-size      derivative ']);
             * end
             */
            }
        /*
         * else
         */
        } else {
            /*
             * if isinf(verbosity)
             */
            if (mlfTobool(mlfIsinf(verbosity))) {
                /*
                 * header = sprintf(['\n                                                     Directional \n',...
                 */
                mlfAssign(
                  &header,
                  mlfSprintf(
                    NULL,
                    mlfHorzcat(
                      mxCreateString(
                        "\\n                                  "
                        "                   Directional \\n"),
                      mxCreateString(
                        " Iteration  Func-count    Residual     Step-siz"
                        "e      derivative   Lambda       Line-search"),
                      NULL),
                    NULL));
            /*
             * ' Iteration  Func-count    Residual     Step-size      derivative   Lambda       Line-search']);
             * else
             */
            } else {
                /*
                 * header = sprintf(['\n                                                     Directional \n',...
                 */
                mlfAssign(
                  &header,
                  mlfSprintf(
                    NULL,
                    mlfHorzcat(
                      mxCreateString(
                        "\\n                                  "
                        "                   Directional \\n"),
                      mxCreateString(
                        " Iteration  Func-count    Residual    "
                        " Step-size      derivative    Lambda"),
                      NULL),
                    NULL));
            /*
             * ' Iteration  Func-count    Residual     Step-size      derivative    Lambda']);
             * end
             */
            }
        /*
         * end
         */
        }
        /*
         * disp(header)
         */
        mlfDisp(header);
    /*
     * end
     */
    }
    mclValidateOutputs("nlsq/lsinit", 3, nargout_, &xold, fold, how);
    mxDestroyArray(header);
    return xold;
}

/*
 * The function "mlfNlsq_lsinit" contains the normal interface for the
 * "nlsq/lsinit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 413-445). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static mxArray * mlfNlsq_lsinit(mxArray * * fold,
                                mxArray * * how,
                                mxArray * xnew,
                                mxArray * fnew,
                                mxArray * verbosity,
                                mxArray * levMarq) {
    int nargout = 1;
    mxArray * xold = mclGetUninitializedArray();
    mxArray * fold__ = mclGetUninitializedArray();
    mxArray * how__ = mclGetUninitializedArray();
    mlfEnterNewContext(2, 4, fold, how, xnew, fnew, verbosity, levMarq);
    if (fold != NULL) {
        ++nargout;
    }
    if (how != NULL) {
        ++nargout;
    }
    xold
      = Mnlsq_lsinit(&fold__, &how__, nargout, xnew, fnew, verbosity, levMarq);
    mlfRestorePreviousContext(2, 4, fold, how, xnew, fnew, verbosity, levMarq);
    if (fold != NULL) {
        mclCopyOutputArg(fold, fold__);
    } else {
        mxDestroyArray(fold__);
    }
    if (how != NULL) {
        mclCopyOutputArg(how, how__);
    } else {
        mxDestroyArray(how__);
    }
    return mlfReturnValue(xold);
}

/*
 * The function "mlxNlsq_lsinit" contains the feval interface for the
 * "nlsq/lsinit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\nlsq.m" (lines 413-445). The feval
 * function calls the implementation version of nlsq/lsinit through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
static void mlxNlsq_lsinit(int nlhs,
                           mxArray * plhs[],
                           int nrhs,
                           mxArray * prhs[]) {
    mxArray * mprhs[4];
    mxArray * mplhs[3];
    int i;
    if (nlhs > 3) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: nlsq/lsinit Line: 413 Colum"
            "n: 0 The function \"nlsq/lsinit\" was called with"
            " more than the declared number of outputs (3)"));
    }
    if (nrhs > 4) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: nlsq/lsinit Line: 413 Colum"
            "n: 0 The function \"nlsq/lsinit\" was called with"
            " more than the declared number of inputs (4)"));
    }
    for (i = 0; i < 3; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 4 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 4; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mplhs[0]
      = Mnlsq_lsinit(
          &mplhs[1], &mplhs[2], nlhs, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    mlfRestorePreviousContext(0, 4, mprhs[0], mprhs[1], mprhs[2], mprhs[3]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 3 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 3; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}
