/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_snls.h"
#include "color.h"
#include "optim_private_definev.h"
#include "optim_private_display1.h"
#include "optim_private_perturb.h"
#include "sfdnls.h"
#include "optim_private_startx.h"
#include "optim_private_trdog.h"
#include "optim_private_xplot.h"

/*
 * The function "Moptim_private_snls" is the implementation version of the
 * "optim/private/snls" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\snls.m" (lines 1-424). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function[xcurr,fvec,LAMBDA,JACOB,EXITFLAG,OUTPUT]=snls(funfcn,xstart,l,u,verb,options,fval,JACval,YDATA,caller,Jstr,computeLambda,varargin)
 */
static mxArray * Moptim_private_snls(mxArray * * fvec,
                                     mxArray * * LAMBDA,
                                     mxArray * * JACOB,
                                     mxArray * * EXITFLAG,
                                     mxArray * * OUTPUT,
                                     int nargout_,
                                     mxArray * funfcn,
                                     mxArray * xstart,
                                     mxArray * l,
                                     mxArray * u,
                                     mxArray * verb,
                                     mxArray * options,
                                     mxArray * fval,
                                     mxArray * JACval,
                                     mxArray * YDATA,
                                     mxArray * caller,
                                     mxArray * Jstr,
                                     mxArray * computeLambda,
                                     mxArray * varargin) {
    mxArray * xcurr = mclGetUninitializedArray();
    mxArray * A = mclGetUninitializedArray();
    mxArray * D = mclGetUninitializedArray();
    mxArray * DS = mclGetUninitializedArray();
    mxArray * Z = mclGetUninitializedArray();
    mxArray * active_tol = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * arg = mclGetUninitializedArray();
    mxArray * arg2 = mclGetUninitializedArray();
    mxArray * argl = mclGetUninitializedArray();
    mxArray * argu = mclGetUninitializedArray();
    mxArray * aug = mclGetUninitializedArray();
    mxArray * bndfeas = mclGetUninitializedArray();
    mxArray * currOutput = mclGetUninitializedArray();
    mxArray * dd = mclGetUninitializedArray();
    mxArray * degen = mclGetUninitializedArray();
    mxArray * del = mclGetUninitializedArray();
    mxArray * delbnd = mclGetUninitializedArray();
    mxArray * delta = mclGetUninitializedArray();
    mxArray * diff = mclGetUninitializedArray();
    mxArray * dnewt = mclGetUninitializedArray();
    mxArray * dv = mclGetUninitializedArray();
    mxArray * errmsg = mclGetUninitializedArray();
    mxArray * ex = mclGetUninitializedArray();
    mxArray * fdata = mclGetUninitializedArray();
    mxArray * figtr = mclGetUninitializedArray();
    mxArray * findiffevals = mclGetUninitializedArray();
    mxArray * formatstr = mclGetUninitializedArray();
    mxArray * g = mclGetUninitializedArray();
    mxArray * gopt = mclGetUninitializedArray();
    mxArray * grad = mclGetUninitializedArray();
    mxArray * gradflag = mclGetUninitializedArray();
    mxArray * group = mclGetUninitializedArray();
    mxArray * header = mclGetUninitializedArray();
    mxArray * it = mclGetUninitializedArray();
    mxArray * itb = mclGetUninitializedArray();
    mxArray * kmax = mclGetUninitializedArray();
    mxArray * lsotframe = mclGetUninitializedArray();
    mxArray * maxfunevals = mclGetUninitializedArray();
    mxArray * mm = mclGetUninitializedArray();
    mxArray * mtxmpy = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * nbnds = mclGetUninitializedArray();
    mxArray * newA = mclGetUninitializedArray();
    mxArray * newfvec = mclGetUninitializedArray();
    mxArray * newgrad = mclGetUninitializedArray();
    mxArray * newval = mclGetUninitializedArray();
    mxArray * newx = mclGetUninitializedArray();
    mxArray * npcg = mclGetUninitializedArray();
    mxArray * nrmsx = mclGetUninitializedArray();
    mxArray * numFunEvals = mclGetUninitializedArray();
    mxArray * numGradEvals = mclGetUninitializedArray();
    mxArray * numberOfVariables = mclGetUninitializedArray();
    mxArray * oposdef = mclGetUninitializedArray();
    mxArray * optnrm = mclGetUninitializedArray();
    mxArray * oval = mclGetUninitializedArray();
    mxArray * p = mclGetUninitializedArray();
    mxArray * pcflags = mclGetUninitializedArray();
    mxArray * pcgit = mclGetUninitializedArray();
    mxArray * pcgtol = mclGetUninitializedArray();
    mxArray * pcmtx = mclGetUninitializedArray();
    mxArray * pert = mclGetUninitializedArray();
    mxArray * posdef = mclGetUninitializedArray();
    mxArray * pp = mclGetUninitializedArray();
    mxArray * prev_diff = mclGetUninitializedArray();
    mxArray * qp = mclGetUninitializedArray();
    mxArray * r = mclGetUninitializedArray();
    mxArray * ratio = mclGetUninitializedArray();
    mxArray * showstat = mclGetUninitializedArray();
    mxArray * snod = mclGetUninitializedArray();
    mxArray * sx = mclGetUninitializedArray();
    mxArray * theta = mclGetUninitializedArray();
    mxArray * tol = mclGetUninitializedArray();
    mxArray * tol1 = mclGetUninitializedArray();
    mxArray * tol2 = mclGetUninitializedArray();
    mxArray * totls = mclGetUninitializedArray();
    mxArray * typx = mclGetUninitializedArray();
    mxArray * v = mclGetUninitializedArray();
    mxArray * val = mclGetUninitializedArray();
    mxArray * vdeg = mclGetUninitializedArray();
    mxArray * vflops = mclGetUninitializedArray();
    mxArray * voptnrm = mclGetUninitializedArray();
    mxArray * vpcg = mclGetUninitializedArray();
    mxArray * vpos = mclGetUninitializedArray();
    mxArray * vval = mclGetUninitializedArray();
    mxArray * warnstr = mclGetUninitializedArray();
    mxArray * x = mclGetUninitializedArray();
    mxArray * xold = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/snls",
      12,
      &funfcn,
      &xstart,
      &l,
      &u,
      &verb,
      &options,
      &fval,
      &JACval,
      &YDATA,
      &caller,
      &Jstr,
      &computeLambda);
    mclCopyArray(&xstart);
    mclCopyArray(&l);
    mclCopyArray(&u);
    /*
     * %SNLS  Sparse nonlinear least squares solver.
     * %   
     * %   Locate a local solution
     * %   to the box-constrained nonlinear least-squares problem:
     * %
     * %              min { ||F(x)||^2 :  l <= x <= u}.
     * %
     * %   where F:R^n -> R^m, m > n, and || || is the 2-norm.
     * %
     * % x=SNLS(fname,xstart) solves the unconstrained nonlinear least
     * % squares problem. The vector function is 'fname' and the
     * % starting point is xstart. 
     * %
     * % x=SNLS(fname,xstart,options) solves the unconstrained or
     * % box constrained nonlinear least squares problem. Bounds and
     * % parameter settings are handled through the named parameter list
     * % options.
     * %
     * % x=SNLS(fname,xstart,options,Jstr) indicates the structure
     * % of the sparse Jacobian matrix -- sparse finite differencing
     * % is used to compute the Jacobian when Jstr is not empty.
     * %
     * % x=SNLS(fname,xstart,options,Jstr,fdata) supplies a matrix
     * % fdata to the objective function fdata.o%
     * %
     * % [x,fvec] =SNLS(fname,xstart, ...)  returns the final value of the
     * % vector function F.
     * %
     * % [x,fvec,gopt] = SNLS(fname,xstart, ...) returns the first-order
     * % optimality vector.
     * %
     * % [x,fvec,gopt,it] = SNLS(fname,xstart, ...) returns the number of
     * % major iterations used.
     * %
     * % [x,fvec,gopt,it,npcg] =  SNLS(fname,xstart, ...) returns the
     * % total number of CG iterations used.
     * %
     * % [x,fvec,gopt,it,npcg,ex] = SNLS(fname,xstart, ...) returns the 
     * % termination code.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.16 $  $Date: 1998/09/11 19:29:49 $
     * 
     * %   Extract input parameters etc.
     * l=l(:); u = u(:);
     */
    mlfAssign(&l, mlfIndexRef(l, "(?)", mlfCreateColonIndex()));
    mlfAssign(&u, mlfIndexRef(u, "(?)", mlfCreateColonIndex()));
    /*
     * xcurr=xstart;  % save shape of xstart for user function
     */
    mlfAssign(&xcurr, xstart);
    /*
     * xstart = xstart(:);  % make it a vector
     */
    mlfAssign(&xstart, mlfIndexRef(xstart, "(?)", mlfCreateColonIndex()));
    /*
     * 
     * %   Initialize
     * dnewt = []; fdata = [];
     */
    mlfAssign(&dnewt, mclCreateEmptyArray());
    mlfAssign(&fdata, mclCreateEmptyArray());
    /*
     * A = []; 
     */
    mlfAssign(&A, mclCreateEmptyArray());
    /*
     * fvec = []; 
     */
    mlfAssign(fvec, mclCreateEmptyArray());
    /*
     * gopt = [];
     */
    mlfAssign(&gopt, mclCreateEmptyArray());
    /*
     * n = length(xstart); 
     */
    mlfAssign(&n, mlfLength(xstart));
    /*
     * it= 1;  
     */
    mlfAssign(&it, mlfScalar(1.0));
    /*
     * numFunEvals = 1;  % done in calling function lsqnonlin
     */
    mlfAssign(&numFunEvals, mlfScalar(1.0));
    /*
     * numGradEvals = 1; % done in calling function
     */
    mlfAssign(&numGradEvals, mlfScalar(1.0));
    /*
     * totls = 0;
     */
    mlfAssign(&totls, mlfScalar(0.0));
    /*
     * header = sprintf(['\n                                         Norm of      First-order \n',...
     */
    mlfAssign(
      &header,
      mlfSprintf(
        NULL,
        mlfHorzcat(
          mxCreateString(
            "\\n                                  "
            "       Norm of      First-order \\n"),
          mxCreateString(
            " Iteration  Func-count     f(x)          s"
            "tep          optimality   CG-iterations"),
          NULL),
        NULL));
    /*
     * ' Iteration  Func-count     f(x)          step          optimality   CG-iterations']);
     * formatstr = ' %5.0f      %5.0f   %13.6g  %13.6g   %12.3g      %7.0f';
     */
    mlfAssign(
      &formatstr,
      mxCreateString(" %5.0f      %5.0f   %13.6g  %13.6g   %12.3g      %7.0f"));
    /*
     * 
     * if n == 0, 
     */
    if (mlfTobool(mlfEq(n, mlfScalar(0.0)))) {
        /*
         * error('n must be positive'), 
         */
        mlfError(mxCreateString("n must be positive"));
    /*
     * end
     */
    }
    /*
     * 
     * if isempty(l), 
     */
    if (mlfTobool(mlfIsempty(l))) {
        /*
         * l = -inf*ones(n,1); 
         */
        mlfAssign(
          &l, mlfMtimes(mlfUminus(mlfInf()), mlfOnes(n, mlfScalar(1.0), NULL)));
    /*
     * end
     */
    }
    /*
     * if isempty(u), 
     */
    if (mlfTobool(mlfIsempty(u))) {
        /*
         * u = inf*ones(n,1); 
         */
        mlfAssign(&u, mlfMtimes(mlfInf(), mlfOnes(n, mlfScalar(1.0), NULL)));
    /*
     * end
     */
    }
    /*
     * arg = (u >= 1e10); 
     */
    mlfAssign(&arg, mlfGe(u, mlfScalar(1e10)));
    /*
     * arg2 = (l <= -1e10);
     */
    mlfAssign(&arg2, mlfLe(l, mlfScalar(-1e10)));
    /*
     * u(arg) = inf;
     */
    mlfIndexAssign(&u, "(?)", arg, mlfInf());
    /*
     * l(arg2) = -inf;
     */
    mlfIndexAssign(&l, "(?)", arg2, mlfUminus(mlfInf()));
    /*
     * if any(u == l) 
     */
    if (mlfTobool(mlfAny(mlfEq(u, l), NULL))) {
        /*
         * errmsg=sprintf('%s',...
         */
        mlfAssign(
          &errmsg,
          mlfSprintf(
            NULL,
            mxCreateString("%s"),
            mxCreateString("Equal upper and lower bounds not permitted."),
            NULL));
        /*
         * 'Equal upper and lower bounds not permitted.');
         * error(errmsg)
         */
        mlfError(errmsg);
    /*
     * elseif min(u-l) <= 0
     */
    } else if (mlfTobool(
                 mlfLe(
                   mlfMin(NULL, mlfMinus(u, l), NULL, NULL), mlfScalar(0.0)))) {
        /*
         * error('Inconsistent bounds.')
         */
        mlfError(mxCreateString("Inconsistent bounds."));
    /*
     * end
     */
    }
    /*
     * if min(min(u-xstart),min(xstart-l)) < 0
     */
    if (mlfTobool(
          mlfLt(
            mlfMin(
              NULL,
              mlfMin(NULL, mlfMinus(u, xstart), NULL, NULL),
              mlfMin(NULL, mlfMinus(xstart, l), NULL, NULL),
              NULL),
            mlfScalar(0.0)))) {
        /*
         * xstart = startx(u,l);    
         */
        mlfAssign(&xstart, mlfOptim_private_startx(u, l));
    /*
     * end
     */
    }
    /*
     * 
     * %
     * % get options out
     * active_tol = optimget(options,'ActiveConstrTol',sqrt(eps));
     */
    mlfAssign(
      &active_tol,
      mlfOptimget(
        options, mxCreateString("ActiveConstrTol"), mlfSqrt(mlfEps())));
    /*
     * gradflag =  strcmp(optimget(options,'Jacobian'),'on');
     */
    mlfAssign(
      &gradflag,
      mlfStrcmp(
        mlfOptimget(options, mxCreateString("Jacobian"), NULL),
        mxCreateString("on")));
    /*
     * typx = optimget(options,'typicalx') ;
     */
    mlfAssign(&typx, mlfOptimget(options, mxCreateString("typicalx"), NULL));
    /*
     * % In case the defaults were gathered from calling: optimset('quadprog'):
     * numberOfVariables = n;
     */
    mlfAssign(&numberOfVariables, n);
    /*
     * %if ischar(typx)
     * %   typx = eval(typx);
     * %end
     * 
     * % This will be user-settable in the future:
     * mtxmpy = optimget(options,'JacobMult','atamult') ;
     */
    mlfAssign(
      &mtxmpy,
      mlfOptimget(
        options, mxCreateString("JacobMult"), mxCreateString("atamult")));
    /*
     * pcmtx = optimget(options,'Preconditioner','aprecon') ;
     */
    mlfAssign(
      &pcmtx,
      mlfOptimget(
        options, mxCreateString("Preconditioner"), mxCreateString("aprecon")));
    /*
     * showstat = optimget(options,'showstatus','off');
     */
    mlfAssign(
      &showstat,
      mlfOptimget(
        options, mxCreateString("showstatus"), mxCreateString("off")));
    /*
     * switch showstat
     * case 'iter'
     */
    if (mclSwitchCompare(showstat, mxCreateString("iter"))) {
        /*
         * showstat = 2;
         */
        mlfAssign(&showstat, mlfScalar(2.0));
    /*
     * case {'none','off'}
     */
    } else if (mclSwitchCompare(
                 showstat,
                 mlfCellhcat(
                   mxCreateString("none"), mxCreateString("off"), NULL))) {
        /*
         * showstat = 0;
         */
        mlfAssign(&showstat, mlfScalar(0.0));
    /*
     * case 'final'
     */
    } else if (mclSwitchCompare(showstat, mxCreateString("final"))) {
        /*
         * showstat = 1;
         */
        mlfAssign(&showstat, mlfScalar(1.0));
    /*
     * case 'iterplusbounds'  % if no finite bounds, this is the same as 'iter'
     */
    } else if (mclSwitchCompare(showstat, mxCreateString("iterplusbounds"))) {
        /*
         * showstat = 3;
         */
        mlfAssign(&showstat, mlfScalar(3.0));
    /*
     * otherwise
     */
    } else {
        /*
         * showstat = 1;
         */
        mlfAssign(&showstat, mlfScalar(1.0));
    /*
     * end
     */
    }
    /*
     * 
     * pcflags = optimget(options,'PrecondBandWidth') ;
     */
    mlfAssign(
      &pcflags, mlfOptimget(options, mxCreateString("PrecondBandWidth"), NULL));
    /*
     * tol2 = optimget(options,'tolx') ;
     */
    mlfAssign(&tol2, mlfOptimget(options, mxCreateString("tolx"), NULL));
    /*
     * tol1 = optimget(options,'tolfun') ;
     */
    mlfAssign(&tol1, mlfOptimget(options, mxCreateString("tolfun"), NULL));
    /*
     * tol = tol1;
     */
    mlfAssign(&tol, tol1);
    /*
     * itb = optimget(options,'maxiter') ;
     */
    mlfAssign(&itb, mlfOptimget(options, mxCreateString("maxiter"), NULL));
    /*
     * maxfunevals = optimget(options,'maxFunEvals') ;
     */
    mlfAssign(
      &maxfunevals, mlfOptimget(options, mxCreateString("maxFunEvals"), NULL));
    /*
     * pcgtol = optimget(options,'TolPCG', 0.1) ;  % pcgtol = .1;
     */
    mlfAssign(
      &pcgtol, mlfOptimget(options, mxCreateString("TolPCG"), mlfScalar(0.1)));
    /*
     * kmax = optimget(options,'MaxPCGIter', max(1,floor(n/2))) ;
     */
    mlfAssign(
      &kmax,
      mlfOptimget(
        options,
        mxCreateString("MaxPCGIter"),
        mlfMax(
          NULL,
          mlfScalar(1.0),
          mlfFloor(mlfMrdivide(n, mlfScalar(2.0))),
          NULL)));
    /*
     * %if ischar(kmax)
     * %  kmax = eval(kmax);
     * %end
     * %if ischar(maxfunevals)
     * %   maxfunevals = eval(maxfunevals);
     * %end
     * 
     * ex = 0; posdef = 1; npcg = 0; pcgit = 0;
     */
    mlfAssign(&ex, mlfScalar(0.0));
    mlfAssign(&posdef, mlfScalar(1.0));
    mlfAssign(&npcg, mlfScalar(0.0));
    mlfAssign(&pcgit, mlfScalar(0.0));
    /*
     * if strcmp(optimget(options,'DerivativeCheck'),'on')
     */
    if (mlfTobool(
          mlfStrcmp(
            mlfOptimget(options, mxCreateString("DerivativeCheck"), NULL),
            mxCreateString("on")))) {
        /*
         * warnstr = sprintf('%s\n%s\n', ...
         */
        mlfAssign(
          &warnstr,
          mlfSprintf(
            NULL,
            mxCreateString("%s\\n%s\\n"),
            mxCreateString(
              "Trust region algorithm does not curren"
              "tly check user-supplied derivatives,"),
            mxCreateString("  ignoring OPTIONS.DerivativeCheck"),
            NULL));
        /*
         * 'Trust region algorithm does not currently check user-supplied derivatives,', ...
         * '  ignoring OPTIONS.DerivativeCheck');
         * warning(warnstr);
         */
        mclAssignAns(&ans, mlfWarning(NULL, warnstr));
    /*
     * end
     */
    }
    /*
     * 
     * %tol1 = tol; tol2 = sqrt(tol1)/10;
     * vpcg(1,1) = 0; vpos(1,1) = 1;
     */
    mlfIndexAssign(
      &vpcg, "(?,?)", mlfScalar(1.0), mlfScalar(1.0), mlfScalar(0.0));
    mlfIndexAssign(
      &vpos, "(?,?)", mlfScalar(1.0), mlfScalar(1.0), mlfScalar(1.0));
    /*
     * delta = 10;nrmsx = 1; ratio = 0; 
     */
    mlfAssign(&delta, mlfScalar(10.0));
    mlfAssign(&nrmsx, mlfScalar(1.0));
    mlfAssign(&ratio, mlfScalar(0.0));
    /*
     * degen = inf; DS = speye(n);
     */
    mlfAssign(&degen, mlfInf());
    mlfAssign(&DS, mlfSpeye(n, NULL));
    /*
     * v = zeros(n,1); dv = ones(n,1); del = 10*eps;
     */
    mlfAssign(&v, mlfZeros(n, mlfScalar(1.0), NULL));
    mlfAssign(&dv, mlfOnes(n, mlfScalar(1.0), NULL));
    mlfAssign(&del, mlfMtimes(mlfScalar(10.0), mlfEps()));
    /*
     * x = xstart; oval = inf;
     */
    mlfAssign(&x, xstart);
    mlfAssign(&oval, mlfInf());
    /*
     * g = zeros(n,1); nbnds = 1; Z = [];
     */
    mlfAssign(&g, mlfZeros(n, mlfScalar(1.0), NULL));
    mlfAssign(&nbnds, mlfScalar(1.0));
    mlfAssign(&Z, mclCreateEmptyArray());
    /*
     * if isinf(u) & isinf(l)
     */
    {
        mxArray * a_ = mclInitialize(mlfIsinf(u));
        if (mlfTobool(a_) && mlfTobool(mlfAnd(a_, mlfIsinf(l)))) {
            mxDestroyArray(a_);
            /*
             * nbnds = 0; degen = -1;
             */
            mlfAssign(&nbnds, mlfScalar(0.0));
            mlfAssign(&degen, mlfScalar(-1.0));
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    /*
     * 
     * xcurr(:) = xstart;
     */
    mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), xstart);
    /*
     * %   Evaluate F and J
     * if ~gradflag % use sparse finite differencing
     */
    if (mlfTobool(mlfNot(gradflag))) {
        /*
         * fvec = fval;
         */
        mlfAssign(fvec, fval);
        /*
         * % Determine coloring/grouping for sparse finite-differencing
         * p = colmmd(Jstr)'; 
         */
        mlfAssign(&p, mlfCtranspose(mlfColmmd(Jstr)));
        /*
         * p = (n+1)*ones(n,1)-p; 
         */
        mlfAssign(
          &p,
          mlfMinus(
            mlfMtimes(
              mlfPlus(n, mlfScalar(1.0)), mlfOnes(n, mlfScalar(1.0), NULL)),
            p));
        /*
         * group = color(Jstr,p);
         */
        mlfAssign(&group, mlfColor(Jstr, p));
        /*
         * xcurr(:) = x;  % reshape x for user function
         */
        mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), x);
        /*
         * % pass in funfcn{3} since we know no gradient: not funfcn{4}
         * [A,findiffevals] = sfdnls(xcurr,fvec,Jstr,group,[],funfcn{3},YDATA,varargin{:});
         */
        mlfFeval(
          mlfVarargout(&A, &findiffevals, NULL),
          mlxSfdnls,
          xcurr,
          *fvec,
          Jstr,
          group,
          mclCreateEmptyArray(),
          mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
          YDATA,
          mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
          NULL);
    /*
     * else % user-supplied computation of J or dnewt 
     */
    } else {
        /*
         * %[fvec,A] = feval(fname,x,fdata);
         * fvec = fval;
         */
        mlfAssign(fvec, fval);
        /*
         * A = JACval;
         */
        mlfAssign(&A, JACval);
        /*
         * findiffevals = 0;
         */
        mlfAssign(&findiffevals, mlfScalar(0.0));
    /*
     * end
     */
    }
    /*
     * numFunEvals = numFunEvals + 1 + findiffevals;
     */
    mlfAssign(
      &numFunEvals,
      mlfPlus(mlfPlus(numFunEvals, mlfScalar(1.0)), findiffevals));
    /*
     * 
     * 
     * delbnd = max(100*norm(xstart),1);
     */
    mlfAssign(
      &delbnd,
      mlfMax(
        NULL,
        mlfMtimes(mlfScalar(100.0), mlfNorm(xstart, NULL)),
        mlfScalar(1.0),
        NULL));
    /*
     * 
     * [mm,pp] = size(fvec);
     */
    mlfSize(mlfVarargout(&mm, &pp, NULL), *fvec, NULL);
    /*
     * if mm < n, 
     */
    if (mlfTobool(mlfLt(mm, n))) {
        /*
         * error('The number of equations must not be less than n'); end
         */
        mlfError(
          mxCreateString("The number of equations must not be less than n"));
    }
    /*
     * 
     * %   Extract the Newton direction?
     * if pp == 2, 
     */
    if (mlfTobool(mlfEq(pp, mlfScalar(2.0)))) {
        /*
         * dnewt = fvec(1:n,2); 
         */
        mlfAssign(
          &dnewt,
          mlfIndexRef(
            *fvec, "(?,?)", mlfColon(mlfScalar(1.0), n, NULL), mlfScalar(2.0)));
    /*
     * end
     */
    }
    /*
     * 
     * %   Determine gradient of the nonlinear least squares function
     * g = feval(mtxmpy,fvec(:,1),A,[],-1);
     */
    mlfAssign(
      &g,
      mlfFeval(
        mclValueVarargout(),
        mclFevalLookup(mtxmpy, 0, NULL),
        mlfIndexRef(*fvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0)),
        A,
        mclCreateEmptyArray(),
        mlfScalar(-1.0),
        NULL));
    /*
     * 
     * %   Evaluate F (initial point)
     * val = fvec(:,1)'*fvec(:,1); vval(it,1) = val;
     */
    mlfAssign(
      &val,
      mlfMtimes(
        mlfCtranspose(
          mlfIndexRef(*fvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0))),
        mlfIndexRef(*fvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0))));
    mlfIndexAssign(&vval, "(?,?)", it, mlfScalar(1.0), val);
    /*
     * 
     * %   Display
     * if showstat > 1 
     */
    if (mlfTobool(mlfGt(showstat, mlfScalar(1.0)))) {
        /*
         * figtr=display1('init',itb,tol,verb,nbnds,x,g,l,u);
         */
        mlfAssign(
          &figtr,
          mlfOptim_private_display1(
            mclValueVarargout(),
            mxCreateString("init"),
            itb,
            tol,
            verb,
            nbnds,
            x,
            g,
            l,
            u,
            NULL));
    /*
     * end
     */
    }
    /*
     * if verb > 1
     */
    if (mlfTobool(mlfGt(verb, mlfScalar(1.0)))) {
        /*
         * disp(header)
         */
        mlfDisp(header);
    /*
     * end
     */
    }
    /*
     * 
     * %   Main loop: Generate feas. seq. x(it) s.t. ||F(x(it)|| is decreasing.
     * while ~ex 
     */
    while (mlfTobool(mlfNot(ex))) {
        /*
         * if any(~isfinite(fvec)) 
         */
        if (mlfTobool(mlfAny(mlfNot(mlfIsfinite(*fvec)), NULL))) {
            /*
             * errmsg= sprintf('%s%s%s',caller,' cannot continue: ',...
             */
            mlfAssign(
              &errmsg,
              mlfSprintf(
                NULL,
                mxCreateString("%s%s%s"),
                caller,
                mxCreateString(" cannot continue: "),
                mxCreateString("user function is returning Inf or NaN values."),
                NULL));
            /*
             * 'user function is returning Inf or NaN values.');
             * error(errmsg)
             */
            mlfError(errmsg);
        /*
         * end
         */
        }
        /*
         * 
         * %  Stop (Interactive)?
         * figtr=findobj('type','figure','Name','Progress Information');
         */
        mlfAssign(
          &figtr,
          mlfFindobj(
            mxCreateString("type"),
            mxCreateString("figure"),
            mxCreateString("Name"),
            mxCreateString("Progress Information"),
            NULL));
        /*
         * if ~isempty(figtr)
         */
        if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
            /*
             * lsotframe = findobj(figtr,'type','uicontrol',...
             */
            mlfAssign(
              &lsotframe,
              mlfFindobj(
                figtr,
                mxCreateString("type"),
                mxCreateString("uicontrol"),
                mxCreateString("Userdata"),
                mxCreateString("LSOT frame"),
                NULL));
            /*
             * 'Userdata','LSOT frame') ;
             * if get(lsotframe,'Value'), 
             */
            if (mlfTobool(mlfGet(lsotframe, mxCreateString("Value"), NULL))) {
                /*
                 * ex = 10 % New exiting condition 
                 */
                mlfAssign(&ex, mlfScalar(10.0));
                mclPrintArray(ex, "ex");
                /*
                 * EXITFLAG = -1;
                 */
                mlfAssign(EXITFLAG, mlfScalar(-1.0));
                /*
                 * if verb > 0
                 */
                if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                    /*
                     * display('Exiting per request.')
                     */
                    mlfDisp(mxCreateString("Exiting per request."));
                /*
                 * end       
                 */
                }
            /*
             * end 
             */
            }
        /*
         * end 
         */
        }
        /*
         * 
         * % Update 
         * [v,dv] = definev(g,x,l,u); 
         */
        mlfAssign(&v, mlfOptim_private_definev(&dv, g, x, l, u));
        /*
         * gopt = v.*g;
         */
        mlfAssign(&gopt, mlfTimes(v, g));
        /*
         * optnrm = norm(gopt,inf);
         */
        mlfAssign(&optnrm, mlfNorm(gopt, mlfInf()));
        /*
         * voptnrm(it,1) = optnrm; 
         */
        mlfIndexAssign(&voptnrm, "(?,?)", it, mlfScalar(1.0), optnrm);
        /*
         * r = abs(min(u-x,x-l));
         */
        mlfAssign(
          &r, mlfAbs(mlfMin(NULL, mlfMinus(u, x), mlfMinus(x, l), NULL)));
        /*
         * degen = min(r + abs(g));
         */
        mlfAssign(&degen, mlfMin(NULL, mlfPlus(r, mlfAbs(g)), NULL, NULL));
        /*
         * vdeg(it,1) = min(degen,1);
         */
        mlfIndexAssign(
          &vdeg,
          "(?,?)",
          it,
          mlfScalar(1.0),
          mlfMin(NULL, degen, mlfScalar(1.0), NULL));
        /*
         * if ~nbnds 
         */
        if (mlfTobool(mlfNot(nbnds))) {
            /*
             * degen = -1; 
             */
            mlfAssign(&degen, mlfScalar(-1.0));
        /*
         * end
         */
        }
        /*
         * bndfeas = min(min(x-l,u-x));
         */
        mlfAssign(
          &bndfeas,
          mlfMin(
            NULL,
            mlfMin(NULL, mlfMinus(x, l), mlfMinus(u, x), NULL),
            NULL,
            NULL));
        /*
         * % Display
         * if showstat > 1
         */
        if (mlfTobool(mlfGt(showstat, mlfScalar(1.0)))) {
            /*
             * display1('progress',it,optnrm,val,pcgit,...
             */
            mclAssignAns(
              &ans,
              mlfOptim_private_display1(
                mclAnsVarargout(),
                mxCreateString("progress"),
                it,
                optnrm,
                val,
                pcgit,
                npcg,
                degen,
                bndfeas,
                showstat,
                nbnds,
                x,
                g,
                l,
                u,
                figtr,
                NULL));
        /*
         * npcg,degen,bndfeas,showstat,nbnds,x,g,l,u,figtr);
         * end
         */
        }
        /*
         * if verb > 1
         */
        if (mlfTobool(mlfGt(verb, mlfScalar(1.0)))) {
            /*
             * currOutput = sprintf(formatstr,it,numFunEvals,val,nrmsx,optnrm,pcgit);
             */
            mlfAssign(
              &currOutput,
              mlfSprintf(
                NULL,
                formatstr,
                it,
                numFunEvals,
                val,
                nrmsx,
                optnrm,
                pcgit,
                NULL));
            /*
             * disp(currOutput);
             */
            mlfDisp(currOutput);
        /*
         * end
         */
        }
        /*
         * 
         * %     Test for convergence
         * diff = abs(oval-val); 
         */
        mlfAssign(&diff, mlfAbs(mlfMinus(oval, val)));
        /*
         * prev_diff = diff; 
         */
        mlfAssign(&prev_diff, diff);
        /*
         * oval = val; 
         */
        mlfAssign(&oval, val);
        /*
         * vflops(it,1) = flops; 
         */
        mlfIndexAssign(&vflops, "(?,?)", it, mlfScalar(1.0), mlfFlops(NULL));
        /*
         * if (nrmsx < .9*delta)&(ratio > .25)&(diff < tol1*(1+abs(oval)))
         */
        {
            mxArray * a_ = mclInitialize(
                             mlfLt(nrmsx, mlfMtimes(mlfScalar(.9), delta)));
            if (mlfTobool(a_)) {
                mlfAssign(&a_, mlfAnd(a_, mlfGt(ratio, mlfScalar(.25))));
            } else {
                mlfAssign(&a_, mlfScalar(0));
            }
            if (mlfTobool(a_)
                && mlfTobool(
                     mlfAnd(
                       a_,
                       mlfLt(
                         diff,
                         mlfMtimes(
                           tol1, mlfPlus(mlfScalar(1.0), mlfAbs(oval))))))) {
                mxDestroyArray(a_);
                /*
                 * ex = 1;
                 */
                mlfAssign(&ex, mlfScalar(1.0));
                /*
                 * if verb > 0
                 */
                if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                    /*
                     * disp('Optimization terminated successfully:')
                     */
                    mlfDisp(
                      mxCreateString("Optimization terminated successfully:"));
                    /*
                     * disp(' Relative function value changing by less than OPTIONS.TolFun');
                     */
                    mlfDisp(
                      mxCreateString(
                        " Relative function value changin"
                        "g by less than OPTIONS.TolFun"));
                /*
                 * end
                 */
                }
                /*
                 * EXITFLAG = 1;
                 */
                mlfAssign(EXITFLAG, mlfScalar(1.0));
            /*
             * elseif (it > 1) & (nrmsx < tol2), 
             */
            } else {
                mxDestroyArray(a_);
                {
                    mxArray * a_ = mclInitialize(mlfGt(it, mlfScalar(1.0)));
                    if (mlfTobool(a_)
                        && mlfTobool(mlfAnd(a_, mlfLt(nrmsx, tol2)))) {
                        mxDestroyArray(a_);
                        /*
                         * ex = 2;   EXITFLAG = 1;
                         */
                        mlfAssign(&ex, mlfScalar(2.0));
                        mlfAssign(EXITFLAG, mlfScalar(1.0));
                        /*
                         * if verb > 0
                         */
                        if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                            /*
                             * disp('Optimization terminated successfully:')
                             */
                            mlfDisp(
                              mxCreateString(
                                "Optimization terminated successfully:"));
                            /*
                             * disp(' Norm of the current step is less than OPTIONS.TolX');
                             */
                            mlfDisp(
                              mxCreateString(
                                " Norm of the current step i"
                                "s less than OPTIONS.TolX"));
                        /*
                         * end
                         */
                        }
                    /*
                     * 
                     * elseif ((optnrm < tol1) & (posdef ==1) ),  
                     */
                    } else {
                        mxDestroyArray(a_);
                        {
                            mxArray * a_ = mclInitialize(mlfLt(optnrm, tol1));
                            if (mlfTobool(a_)
                                && mlfTobool(
                                     mlfAnd(
                                       a_, mlfEq(posdef, mlfScalar(1.0))))) {
                                mxDestroyArray(a_);
                                /*
                                 * ex = 3;   EXITFLAG = 1;
                                 */
                                mlfAssign(&ex, mlfScalar(3.0));
                                mlfAssign(EXITFLAG, mlfScalar(1.0));
                                /*
                                 * if verb > 0
                                 */
                                if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                                    /*
                                     * disp('Optimization terminated successfully:')
                                     */
                                    mlfDisp(
                                      mxCreateString(
                                        "Optimization termina"
                                        "ted successfully:"));
                                    /*
                                     * disp(' First-order optimality less than OPTIONS.TolFun, and no zero curvature detected');
                                     */
                                    mlfDisp(
                                      mxCreateString(
                                        " First-order optimality less"
                                        " than OPTIONS.TolFun, and no"
                                        " zero curvature detected"));
                                /*
                                 * end
                                 */
                                }
                            /*
                             * 
                             * elseif it > itb, 
                             */
                            } else {
                                mxDestroyArray(a_);
                                if (mlfTobool(mlfGt(it, itb))) {
                                    /*
                                     * ex = 4;    EXITFLAG = 0;
                                     */
                                    mlfAssign(&ex, mlfScalar(4.0));
                                    mlfAssign(EXITFLAG, mlfScalar(0.0));
                                    /*
                                     * if verb > 0
                                     */
                                    if (mlfTobool(
                                          mlfGt(verb, mlfScalar(0.0)))) {
                                        /*
                                         * disp('Maximum number of iterations exceeded;')
                                         */
                                        mlfDisp(
                                          mxCreateString(
                                            "Maximum number of ite"
                                            "rations exceeded;"));
                                        /*
                                         * disp('   increase options.MaxIter')
                                         */
                                        mlfDisp(
                                          mxCreateString(
                                            "   increase options.MaxIter"));
                                    /*
                                     * end       
                                     */
                                    }
                                }
                            }
                        }
                    }
                }
            }
        /*
         * end
         */
        }
        /*
         * 
         * %     Continue if ex = 0 (i.e., not done yet)
         * if ~ex 
         */
        if (mlfTobool(mlfNot(ex))) {
            /*
             * %       Determine the trust region correction
             * dd = abs(v); D = sparse(1:n,1:n,full(sqrt(dd))); grad = D*g;
             */
            mlfAssign(&dd, mlfAbs(v));
            mlfAssign(
              &D,
              mlfSparse(
                mlfColon(mlfScalar(1.0), n, NULL),
                mlfColon(mlfScalar(1.0), n, NULL),
                mlfFull(mlfSqrt(dd)),
                NULL,
                NULL,
                NULL));
            mlfAssign(&grad, mlfMtimes(D, g));
            /*
             * vpos(it,1) = posdef; sx = zeros(n,1); theta = max(.95,1-optnrm);  
             */
            mlfIndexAssign(&vpos, "(?,?)", it, mlfScalar(1.0), posdef);
            mlfAssign(&sx, mlfZeros(n, mlfScalar(1.0), NULL));
            mlfAssign(
              &theta,
              mlfMax(
                NULL, mlfScalar(.95), mlfMinus(mlfScalar(1.0), optnrm), NULL));
            /*
             * oposdef = posdef;
             */
            mlfAssign(&oposdef, posdef);
            /*
             * [sx,snod,qp,posdef,pcgit,Z] = trdog(x,g,A,fdata,D,delta,dv,...
             */
            mlfAssign(
              &sx,
              mlfOptim_private_trdog(
                &snod,
                &qp,
                &posdef,
                &pcgit,
                &Z,
                x,
                g,
                A,
                fdata,
                D,
                delta,
                dv,
                mtxmpy,
                pcmtx,
                pcflags,
                pcgtol,
                kmax,
                theta,
                l,
                u,
                Z,
                dnewt,
                mxCreateString("jacobprecon")));
            /*
             * mtxmpy,pcmtx,pcflags,pcgtol,kmax,theta,l,u,Z,dnewt,'jacobprecon');
             * 
             * if isempty(posdef), 
             */
            if (mlfTobool(mlfIsempty(posdef))) {
                /*
                 * posdef = oposdef; 
                 */
                mlfAssign(&posdef, oposdef);
            /*
             * end
             */
            }
            /*
             * nrmsx=norm(snod); 
             */
            mlfAssign(&nrmsx, mlfNorm(snod, NULL));
            /*
             * npcg=npcg+pcgit; 
             */
            mlfAssign(&npcg, mlfPlus(npcg, pcgit));
            /*
             * newx=x+sx;  
             */
            mlfAssign(&newx, mlfPlus(x, sx));
            /*
             * vpcg(it+1,1)=pcgit;
             */
            mlfIndexAssign(
              &vpcg,
              "(?,?)",
              mlfPlus(it, mlfScalar(1.0)),
              mlfScalar(1.0),
              pcgit);
            /*
             * 
             * %       Perturb?
             * [pert,newx] = perturb(newx,l,u);
             */
            mlfAssign(
              &pert,
              mlfOptim_private_perturb(
                &newx, NULL, newx, l, u, NULL, NULL, NULL));
            /*
             * vpos(it+1,1) = posdef;
             */
            mlfIndexAssign(
              &vpos,
              "(?,?)",
              mlfPlus(it, mlfScalar(1.0)),
              mlfScalar(1.0),
              posdef);
            /*
             * 
             * xcurr(:) = newx; % reshape newx for user function
             */
            mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), newx);
            /*
             * %       Evaluate F and J
             * if ~gradflag %use sparse finite-differencing
             */
            if (mlfTobool(mlfNot(gradflag))) {
                /*
                 * %newfvec = feval(fname,newx,fdata);
                 * switch funfcn{1}
                 */
                mxArray * t_ = mclUnassigned();
                mlfAssign(&t_, mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)));
                /*
                 * case 'fun'
                 */
                if (mclSwitchCompare(t_, mxCreateString("fun"))) {
                    /*
                     * newfvec = feval(funfcn{3},xcurr,varargin{:});
                     */
                    mlfAssign(
                      &newfvec,
                      mlfFeval(
                        mclValueVarargout(),
                        mclFevalLookup(
                          mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)), 0, NULL),
                        xcurr,
                        mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                        NULL));
                    /*
                     * if ~isempty(YDATA)
                     */
                    if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                        /*
                         * newfvec = newfvec - YDATA;
                         */
                        mlfAssign(&newfvec, mlfMinus(newfvec, YDATA));
                    /*
                     * end
                     */
                    }
                    /*
                     * newfvec = newfvec(:);
                     */
                    mlfAssign(
                      &newfvec,
                      mlfIndexRef(newfvec, "(?)", mlfCreateColonIndex()));
                /*
                 * otherwise
                 */
                } else {
                    /*
                     * error(['Undefined calltype in ',caller]);
                     */
                    mlfError(
                      mlfHorzcat(
                        mxCreateString("Undefined calltype in "),
                        caller,
                        NULL));
                /*
                 * end
                 */
                }
                mxDestroyArray(t_);
                /*
                 * % pass in funfcn{3} since we know no gradient
                 * [newA, findiffevals] = sfdnls(xcurr,newfvec,Jstr,group,[],funfcn{3},YDATA,varargin{:});
                 */
                mlfFeval(
                  mlfVarargout(&newA, &findiffevals, NULL),
                  mlxSfdnls,
                  xcurr,
                  newfvec,
                  Jstr,
                  group,
                  mclCreateEmptyArray(),
                  mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                  YDATA,
                  mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                  NULL);
            /*
             * else % use user-supplied detrmination of J or dnewt
             */
            } else {
                /*
                 * findiffevals = 0; % no finite differencing
                 */
                mlfAssign(&findiffevals, mlfScalar(0.0));
                /*
                 * %[newfvec,newA] = feval(fname,newx,fdata);
                 * switch funfcn{1}
                 */
                {
                    mxArray * t_ = mclUnassigned();
                    mlfAssign(&t_, mlfIndexRef(funfcn, "{?}", mlfScalar(1.0)));
                    /*
                     * case 'fungrad'
                     */
                    if (mclSwitchCompare(t_, mxCreateString("fungrad"))) {
                        /*
                         * [newfvec,newA] = feval(funfcn{3},xcurr,varargin{:});
                         */
                        mlfFeval(
                          mlfVarargout(&newfvec, &newA, NULL),
                          mclFevalLookup(
                            mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                            0,
                            NULL),
                          xcurr,
                          mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                          NULL);
                        /*
                         * numGradEvals=numGradEvals+1;
                         */
                        mlfAssign(
                          &numGradEvals, mlfPlus(numGradEvals, mlfScalar(1.0)));
                        /*
                         * if ~isempty(YDATA)
                         */
                        if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                            /*
                             * newfvec = newfvec - YDATA;
                             */
                            mlfAssign(&newfvec, mlfMinus(newfvec, YDATA));
                        /*
                         * end
                         */
                        }
                        /*
                         * newfvec = newfvec(:);
                         */
                        mlfAssign(
                          &newfvec,
                          mlfIndexRef(newfvec, "(?)", mlfCreateColonIndex()));
                    /*
                     * case 'fun_then_grad'
                     */
                    } else if (mclSwitchCompare(
                                 t_, mxCreateString("fun_then_grad"))) {
                        /*
                         * newfvec = feval(funfcn{3},xcurr,varargin{:});
                         */
                        mlfAssign(
                          &newfvec,
                          mlfFeval(
                            mclValueVarargout(),
                            mclFevalLookup(
                              mlfIndexRef(funfcn, "{?}", mlfScalar(3.0)),
                              0,
                              NULL),
                            xcurr,
                            mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                            NULL));
                        /*
                         * if ~isempty(YDATA)
                         */
                        if (mlfTobool(mlfNot(mlfIsempty(YDATA)))) {
                            /*
                             * newfvec = newfvec - YDATA;
                             */
                            mlfAssign(&newfvec, mlfMinus(newfvec, YDATA));
                        /*
                         * end
                         */
                        }
                        /*
                         * newfvec = newfvec(:);
                         */
                        mlfAssign(
                          &newfvec,
                          mlfIndexRef(newfvec, "(?)", mlfCreateColonIndex()));
                        /*
                         * newA = feval(funfcn{4},xcurr,varargin{:});
                         */
                        mlfAssign(
                          &newA,
                          mlfFeval(
                            mclValueVarargout(),
                            mclFevalLookup(
                              mlfIndexRef(funfcn, "{?}", mlfScalar(4.0)),
                              0,
                              NULL),
                            xcurr,
                            mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
                            NULL));
                        /*
                         * numGradEvals=numGradEvals+1;
                         */
                        mlfAssign(
                          &numGradEvals, mlfPlus(numGradEvals, mlfScalar(1.0)));
                    /*
                     * otherwise
                     */
                    } else {
                        /*
                         * error(['Undefined calltype in ',caller]);
                         */
                        mlfError(
                          mlfHorzcat(
                            mxCreateString("Undefined calltype in "),
                            caller,
                            NULL));
                    /*
                     * end
                     */
                    }
                    mxDestroyArray(t_);
                }
            /*
             * end
             */
            }
            /*
             * numFunEvals = numFunEvals + 1 + findiffevals;
             */
            mlfAssign(
              &numFunEvals,
              mlfPlus(mlfPlus(numFunEvals, mlfScalar(1.0)), findiffevals));
            /*
             * 
             * [mm,pp] = size(newfvec);
             */
            mlfSize(mlfVarargout(&mm, &pp, NULL), newfvec, NULL);
            /*
             * if mm < n, 
             */
            if (mlfTobool(mlfLt(mm, n))) {
                /*
                 * error('The number of eqns must be greater than n'); end
                 */
                mlfError(
                  mxCreateString("The number of eqns must be greater than n"));
            }
            /*
             * 
             * %       Accept or reject trial point
             * newgrad = feval(mtxmpy,newfvec(:,1),newA,[],-1);  
             */
            mlfAssign(
              &newgrad,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(mtxmpy, 0, NULL),
                mlfIndexRef(
                  newfvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0)),
                newA,
                mclCreateEmptyArray(),
                mlfScalar(-1.0),
                NULL));
            /*
             * newval = newfvec(:,1)'*newfvec(:,1);
             */
            mlfAssign(
              &newval,
              mlfMtimes(
                mlfCtranspose(
                  mlfIndexRef(
                    newfvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0))),
                mlfIndexRef(
                  newfvec, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0))));
            /*
             * aug = .5*snod'*((dv.*abs(g)).*snod); 
             */
            mlfAssign(
              &aug,
              mlfMtimes(
                mlfMtimes(mlfScalar(.5), mlfCtranspose(snod)),
                mlfTimes(mlfTimes(dv, mlfAbs(g)), snod)));
            /*
             * ratio = (0.5*(newval-val)+aug)/qp;     % we compute val = f'*f, not val = 0.5*(f'*f)
             */
            mlfAssign(
              &ratio,
              mlfMrdivide(
                mlfPlus(mlfMtimes(mlfScalar(0.5), mlfMinus(newval, val)), aug),
                qp));
            /*
             * if (ratio >= .75) & (nrmsx >= .9*delta),
             */
            {
                mxArray * a_ = mclInitialize(mlfGe(ratio, mlfScalar(.75)));
                if (mlfTobool(a_)
                    && mlfTobool(
                         mlfAnd(
                           a_,
                           mlfGe(nrmsx, mlfMtimes(mlfScalar(.9), delta))))) {
                    mxDestroyArray(a_);
                    /*
                     * delta = min(delbnd,2*delta);
                     */
                    mlfAssign(
                      &delta,
                      mlfMin(
                        NULL, delbnd, mlfMtimes(mlfScalar(2.0), delta), NULL));
                /*
                 * elseif ratio <= .25,  
                 */
                } else {
                    mxDestroyArray(a_);
                    if (mlfTobool(mlfLe(ratio, mlfScalar(.25)))) {
                        /*
                         * delta = min(nrmsx/4,delta/4);
                         */
                        mlfAssign(
                          &delta,
                          mlfMin(
                            NULL,
                            mlfMrdivide(nrmsx, mlfScalar(4.0)),
                            mlfMrdivide(delta, mlfScalar(4.0)),
                            NULL));
                    }
                }
            /*
             * end
             */
            }
            /*
             * if isinf(newval) 
             */
            if (mlfTobool(mlfIsinf(newval))) {
                /*
                 * delta = min(nrmsx/20,delta/20); 
                 */
                mlfAssign(
                  &delta,
                  mlfMin(
                    NULL,
                    mlfMrdivide(nrmsx, mlfScalar(20.0)),
                    mlfMrdivide(delta, mlfScalar(20.0)),
                    NULL));
            /*
             * end
             */
            }
            /*
             * 
             * %       Update
             * if newval < val
             */
            if (mlfTobool(mlfLt(newval, val))) {
                /*
                 * xold = x; 
                 */
                mlfAssign(&xold, x);
                /*
                 * x=newx; 
                 */
                mlfAssign(&x, newx);
                /*
                 * val = newval; 
                 */
                mlfAssign(&val, newval);
                /*
                 * g= newgrad; 
                 */
                mlfAssign(&g, newgrad);
                /*
                 * A = newA; 
                 */
                mlfAssign(&A, newA);
                /*
                 * Z = [];
                 */
                mlfAssign(&Z, mclCreateEmptyArray());
                /*
                 * fvec = newfvec;
                 */
                mlfAssign(fvec, newfvec);
                /*
                 * 
                 * %          Extract the Newton direction?
                 * if pp == 2, 
                 */
                if (mlfTobool(mlfEq(pp, mlfScalar(2.0)))) {
                    /*
                     * dnewt = newfvec(1:n,2); 
                     */
                    mlfAssign(
                      &dnewt,
                      mlfIndexRef(
                        newfvec,
                        "(?,?)",
                        mlfColon(mlfScalar(1.0), n, NULL),
                        mlfScalar(2.0)));
                /*
                 * end
                 */
                }
            /*
             * end
             */
            }
            /*
             * it=it+1; 
             */
            mlfAssign(&it, mlfPlus(it, mlfScalar(1.0)));
            /*
             * vval(it,1) = val;
             */
            mlfIndexAssign(&vval, "(?,?)", it, mlfScalar(1.0), val);
        /*
         * end
         */
        }
        /*
         * if it > itb 
         */
        if (mlfTobool(mlfGt(it, itb))) {
            /*
             * ex=4; EXITFLAG = 0;
             */
            mlfAssign(&ex, mlfScalar(4.0));
            mlfAssign(EXITFLAG, mlfScalar(0.0));
            /*
             * it = it-1; 
             */
            mlfAssign(&it, mlfMinus(it, mlfScalar(1.0)));
            /*
             * if verb > 0
             */
            if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                /*
                 * disp('Maximum number of iterations exceeded;')
                 */
                mlfDisp(
                  mxCreateString("Maximum number of iterations exceeded;"));
                /*
                 * disp('   increase options.MaxIter')
                 */
                mlfDisp(mxCreateString("   increase options.MaxIter"));
            /*
             * end       
             */
            }
        /*
         * end
         */
        }
        /*
         * if numFunEvals > maxfunevals 
         */
        if (mlfTobool(mlfGt(numFunEvals, maxfunevals))) {
            /*
             * ex=4; EXITFLAG = 0;
             */
            mlfAssign(&ex, mlfScalar(4.0));
            mlfAssign(EXITFLAG, mlfScalar(0.0));
            /*
             * it = it - 1;
             */
            mlfAssign(&it, mlfMinus(it, mlfScalar(1.0)));
            /*
             * if verb > 0
             */
            if (mlfTobool(mlfGt(verb, mlfScalar(0.0)))) {
                /*
                 * disp('Maximum number of function evaluations exceeded;')
                 */
                mlfDisp(
                  mxCreateString(
                    "Maximum number of function evaluations exceeded;"));
                /*
                 * disp('   increase options.MaxFunEvals')
                 */
                mlfDisp(mxCreateString("   increase options.MaxFunEvals"));
            /*
             * end       
             */
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * %
     * %   Display
     * if showstat > 1 
     */
    if (mlfTobool(mlfGt(showstat, mlfScalar(1.0)))) {
        /*
         * display1('final',figtr);
         */
        mclAssignAns(
          &ans,
          mlfOptim_private_display1(
            mclAnsVarargout(), mxCreateString("final"), figtr, NULL));
    /*
     * end
     */
    }
    /*
     * if showstat 
     */
    if (mlfTobool(showstat)) {
        /*
         * xplot(it,vval,voptnrm,vflops,vpos,vdeg,vpcg);
         */
        mclAssignAns(
          &ans,
          mlfOptim_private_xplot(it, vval, voptnrm, vflops, vpos, vdeg, vpcg));
    /*
     * end
     */
    }
    /*
     * JACOB = sparse(A);     % A is the Jacobian, not the gradient.
     */
    mlfAssign(JACOB, mlfSparse(A, NULL, NULL, NULL, NULL, NULL));
    /*
     * OUTPUT.firstorderopt = optnrm;
     */
    mlfIndexAssign(OUTPUT, ".firstorderopt", optnrm);
    /*
     * OUTPUT.iterations = it;
     */
    mlfIndexAssign(OUTPUT, ".iterations", it);
    /*
     * OUTPUT.funcCount = numFunEvals;
     */
    mlfIndexAssign(OUTPUT, ".funcCount", numFunEvals);
    /*
     * OUTPUT.cgiterations = npcg;
     */
    mlfIndexAssign(OUTPUT, ".cgiterations", npcg);
    /*
     * OUTPUT.algorithm = 'large-scale: trust-region reflective Newton'; 
     */
    mlfIndexAssign(
      OUTPUT,
      ".algorithm",
      mxCreateString("large-scale: trust-region reflective Newton"));
    /*
     * xcurr(:)=x;
     */
    mlfIndexAssign(&xcurr, "(?)", mlfCreateColonIndex(), x);
    /*
     * 
     * if computeLambda
     */
    if (mlfTobool(computeLambda)) {
        /*
         * LAMBDA.lower = zeros(length(l),1);
         */
        mlfIndexAssign(
          LAMBDA, ".lower", mlfZeros(mlfLength(l), mlfScalar(1.0), NULL));
        /*
         * LAMBDA.upper = zeros(length(u),1);
         */
        mlfIndexAssign(
          LAMBDA, ".upper", mlfZeros(mlfLength(u), mlfScalar(1.0), NULL));
        /*
         * argl = logical(abs(x-l) < active_tol);
         */
        mlfAssign(&argl, mlfLogical(mlfLt(mlfAbs(mlfMinus(x, l)), active_tol)));
        /*
         * argu = logical(abs(x-u) < active_tol);
         */
        mlfAssign(&argu, mlfLogical(mlfLt(mlfAbs(mlfMinus(x, u)), active_tol)));
        /*
         * 
         * g = full(g);
         */
        mlfAssign(&g, mlfFull(g));
        /*
         * 
         * LAMBDA.lower(argl) = (g(argl));
         */
        mlfIndexAssign(LAMBDA, ".lower(?)", argl, mlfIndexRef(g, "(?)", argl));
        /*
         * LAMBDA.upper(argu) = -(g(argu));
         */
        mlfIndexAssign(
          LAMBDA, ".upper(?)", argu, mlfUminus(mlfIndexRef(g, "(?)", argu)));
    /*
     * else
     */
    } else {
        /*
         * LAMBDA = [];
         */
        mlfAssign(LAMBDA, mclCreateEmptyArray());
    /*
     * end
     */
    }
    mclValidateOutputs(
      "optim/private/snls",
      6,
      nargout_,
      &xcurr,
      fvec,
      LAMBDA,
      JACOB,
      EXITFLAG,
      OUTPUT);
    mxDestroyArray(A);
    mxDestroyArray(D);
    mxDestroyArray(DS);
    mxDestroyArray(Z);
    mxDestroyArray(active_tol);
    mxDestroyArray(ans);
    mxDestroyArray(arg);
    mxDestroyArray(arg2);
    mxDestroyArray(argl);
    mxDestroyArray(argu);
    mxDestroyArray(aug);
    mxDestroyArray(bndfeas);
    mxDestroyArray(currOutput);
    mxDestroyArray(dd);
    mxDestroyArray(degen);
    mxDestroyArray(del);
    mxDestroyArray(delbnd);
    mxDestroyArray(delta);
    mxDestroyArray(diff);
    mxDestroyArray(dnewt);
    mxDestroyArray(dv);
    mxDestroyArray(errmsg);
    mxDestroyArray(ex);
    mxDestroyArray(fdata);
    mxDestroyArray(figtr);
    mxDestroyArray(findiffevals);
    mxDestroyArray(formatstr);
    mxDestroyArray(g);
    mxDestroyArray(gopt);
    mxDestroyArray(grad);
    mxDestroyArray(gradflag);
    mxDestroyArray(group);
    mxDestroyArray(header);
    mxDestroyArray(it);
    mxDestroyArray(itb);
    mxDestroyArray(kmax);
    mxDestroyArray(l);
    mxDestroyArray(lsotframe);
    mxDestroyArray(maxfunevals);
    mxDestroyArray(mm);
    mxDestroyArray(mtxmpy);
    mxDestroyArray(n);
    mxDestroyArray(nbnds);
    mxDestroyArray(newA);
    mxDestroyArray(newfvec);
    mxDestroyArray(newgrad);
    mxDestroyArray(newval);
    mxDestroyArray(newx);
    mxDestroyArray(npcg);
    mxDestroyArray(nrmsx);
    mxDestroyArray(numFunEvals);
    mxDestroyArray(numGradEvals);
    mxDestroyArray(numberOfVariables);
    mxDestroyArray(oposdef);
    mxDestroyArray(optnrm);
    mxDestroyArray(oval);
    mxDestroyArray(p);
    mxDestroyArray(pcflags);
    mxDestroyArray(pcgit);
    mxDestroyArray(pcgtol);
    mxDestroyArray(pcmtx);
    mxDestroyArray(pert);
    mxDestroyArray(posdef);
    mxDestroyArray(pp);
    mxDestroyArray(prev_diff);
    mxDestroyArray(qp);
    mxDestroyArray(r);
    mxDestroyArray(ratio);
    mxDestroyArray(showstat);
    mxDestroyArray(snod);
    mxDestroyArray(sx);
    mxDestroyArray(theta);
    mxDestroyArray(tol);
    mxDestroyArray(tol1);
    mxDestroyArray(tol2);
    mxDestroyArray(totls);
    mxDestroyArray(typx);
    mxDestroyArray(u);
    mxDestroyArray(v);
    mxDestroyArray(val);
    mxDestroyArray(vdeg);
    mxDestroyArray(vflops);
    mxDestroyArray(voptnrm);
    mxDestroyArray(vpcg);
    mxDestroyArray(vpos);
    mxDestroyArray(vval);
    mxDestroyArray(warnstr);
    mxDestroyArray(x);
    mxDestroyArray(xold);
    mxDestroyArray(xstart);
    /*
     * 
     * 
     * 
     * 
     * 
     * 
     */
    return xcurr;
}

/*
 * The function "mlfOptim_private_snls" contains the normal interface for the
 * "optim/private/snls" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\snls.m" (lines 1-424). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_snls(mxArray * * fvec,
                                mxArray * * LAMBDA,
                                mxArray * * JACOB,
                                mxArray * * EXITFLAG,
                                mxArray * * OUTPUT,
                                mxArray * funfcn,
                                mxArray * xstart,
                                mxArray * l,
                                mxArray * u,
                                mxArray * verb,
                                mxArray * options,
                                mxArray * fval,
                                mxArray * JACval,
                                mxArray * YDATA,
                                mxArray * caller,
                                mxArray * Jstr,
                                mxArray * computeLambda,
                                ...) {
    mxArray * varargin = mclUnassigned();
    int nargout = 1;
    mxArray * xcurr = mclGetUninitializedArray();
    mxArray * fvec__ = mclGetUninitializedArray();
    mxArray * LAMBDA__ = mclGetUninitializedArray();
    mxArray * JACOB__ = mclGetUninitializedArray();
    mxArray * EXITFLAG__ = mclGetUninitializedArray();
    mxArray * OUTPUT__ = mclGetUninitializedArray();
    mlfVarargin(&varargin, computeLambda, 0);
    mlfEnterNewContext(
      5,
      -13,
      fvec,
      LAMBDA,
      JACOB,
      EXITFLAG,
      OUTPUT,
      funfcn,
      xstart,
      l,
      u,
      verb,
      options,
      fval,
      JACval,
      YDATA,
      caller,
      Jstr,
      computeLambda,
      varargin);
    if (fvec != NULL) {
        ++nargout;
    }
    if (LAMBDA != NULL) {
        ++nargout;
    }
    if (JACOB != NULL) {
        ++nargout;
    }
    if (EXITFLAG != NULL) {
        ++nargout;
    }
    if (OUTPUT != NULL) {
        ++nargout;
    }
    xcurr
      = Moptim_private_snls(
          &fvec__,
          &LAMBDA__,
          &JACOB__,
          &EXITFLAG__,
          &OUTPUT__,
          nargout,
          funfcn,
          xstart,
          l,
          u,
          verb,
          options,
          fval,
          JACval,
          YDATA,
          caller,
          Jstr,
          computeLambda,
          varargin);
    mlfRestorePreviousContext(
      5,
      12,
      fvec,
      LAMBDA,
      JACOB,
      EXITFLAG,
      OUTPUT,
      funfcn,
      xstart,
      l,
      u,
      verb,
      options,
      fval,
      JACval,
      YDATA,
      caller,
      Jstr,
      computeLambda);
    mxDestroyArray(varargin);
    if (fvec != NULL) {
        mclCopyOutputArg(fvec, fvec__);
    } else {
        mxDestroyArray(fvec__);
    }
    if (LAMBDA != NULL) {
        mclCopyOutputArg(LAMBDA, LAMBDA__);
    } else {
        mxDestroyArray(LAMBDA__);
    }
    if (JACOB != NULL) {
        mclCopyOutputArg(JACOB, JACOB__);
    } else {
        mxDestroyArray(JACOB__);
    }
    if (EXITFLAG != NULL) {
        mclCopyOutputArg(EXITFLAG, EXITFLAG__);
    } else {
        mxDestroyArray(EXITFLAG__);
    }
    if (OUTPUT != NULL) {
        mclCopyOutputArg(OUTPUT, OUTPUT__);
    } else {
        mxDestroyArray(OUTPUT__);
    }
    return mlfReturnValue(xcurr);
}

/*
 * The function "mlxOptim_private_snls" contains the feval interface for the
 * "optim/private/snls" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\snls.m" (lines 1-424). The feval
 * function calls the implementation version of optim/private/snls through this
 * function. This function processes any input arguments and passes them to the
 * implementation version of the function, appearing above.
 */
void mlxOptim_private_snls(int nlhs,
                           mxArray * plhs[],
                           int nrhs,
                           mxArray * prhs[]) {
    mxArray * mprhs[13];
    mxArray * mplhs[6];
    int i;
    if (nlhs > 6) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/snls Line: 1 Colu"
            "mn: 0 The function \"optim/private/snls\" was called "
            "with more than the declared number of outputs (6)"));
    }
    for (i = 0; i < 6; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 12 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 12; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      12,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11]);
    mprhs[12] = NULL;
    mlfAssign(&mprhs[12], mclCreateVararginCell(nrhs - 12, prhs + 12));
    mplhs[0]
      = Moptim_private_snls(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          &mplhs[5],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7],
          mprhs[8],
          mprhs[9],
          mprhs[10],
          mprhs[11],
          mprhs[12]);
    mlfRestorePreviousContext(
      0,
      12,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 6 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 6; ++i) {
        mxDestroyArray(mplhs[i]);
    }
    mxDestroyArray(mprhs[12]);
}
