/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_trdog.h"
#include "optim_private_pcgr.h"
#include "optim_private_quad1d.h"
#include "optim_private_trust.h"

/*
 * The function "Moptim_private_trdog" is the implementation version of the
 * "optim/private/trdog" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trdog.m" (lines 1-226). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function[s,snod,qpval,posdef,pcgit,Z] = trdog(x,g,H,fdata,D,delta,dv,...
 */
static mxArray * Moptim_private_trdog(mxArray * * snod,
                                      mxArray * * qpval,
                                      mxArray * * posdef,
                                      mxArray * * pcgit,
                                      mxArray * * Z,
                                      int nargout_,
                                      mxArray * x,
                                      mxArray * g,
                                      mxArray * H,
                                      mxArray * fdata,
                                      mxArray * D,
                                      mxArray * delta,
                                      mxArray * dv,
                                      mxArray * mtxmpy,
                                      mxArray * pcmtx,
                                      mxArray * pcoptions,
                                      mxArray * tol,
                                      mxArray * kmax,
                                      mxArray * theta,
                                      mxArray * l,
                                      mxArray * u,
                                      mxArray * Z_,
                                      mxArray * dnewt,
                                      mxArray * preconflag) {
    mxArray * s = mclGetUninitializedArray();
    mxArray * DG = mclGetUninitializedArray();
    mxArray * DM = mclGetUninitializedArray();
    mxArray * HH = mclGetUninitializedArray();
    mxArray * MM = mclGetUninitializedArray();
    mxArray * R = mclGetUninitializedArray();
    mxArray * W = mclGetUninitializedArray();
    mxArray * WW = mclGetUninitializedArray();
    mxArray * ZZ = mclGetUninitializedArray();
    mxArray * alpha = mclGetUninitializedArray();
    mxArray * arg = mclGetUninitializedArray();
    mxArray * dis = mclGetUninitializedArray();
    mxArray * fcnt = mclGetUninitializedArray();
    mxArray * grad = mclGetUninitializedArray();
    mxArray * ipt = mclGetUninitializedArray();
    mxArray * lambda = mclGetUninitializedArray();
    mxArray * mdis = mclGetUninitializedArray();
    mxArray * mmdis = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * ng = mclGetUninitializedArray();
    mxArray * ngrad = mclGetUninitializedArray();
    mxArray * nrhs = mclGetUninitializedArray();
    mxArray * nrmv2 = mclGetUninitializedArray();
    mxArray * ns = mclGetUninitializedArray();
    mxArray * nss = mclGetUninitializedArray();
    mxArray * nst = mclGetUninitializedArray();
    mxArray * nx = mclGetUninitializedArray();
    mxArray * permR = mclGetUninitializedArray();
    mxArray * po = mclGetUninitializedArray();
    mxArray * qpval0 = mclGetUninitializedArray();
    mxArray * qpval1 = mclGetUninitializedArray();
    mxArray * qpval2 = mclGetUninitializedArray();
    mxArray * qpval3 = mclGetUninitializedArray();
    mxArray * r = mclGetUninitializedArray();
    mxArray * rhs = mclGetUninitializedArray();
    mxArray * sg = mclGetUninitializedArray();
    mxArray * ss = mclGetUninitializedArray();
    mxArray * ssave = mclGetUninitializedArray();
    mxArray * ssg = mclGetUninitializedArray();
    mxArray * sssave = mclGetUninitializedArray();
    mxArray * ssssave = mclGetUninitializedArray();
    mxArray * st = mclGetUninitializedArray();
    mxArray * stsave = mclGetUninitializedArray();
    mxArray * tau = mclGetUninitializedArray();
    mxArray * tol2 = mclGetUninitializedArray();
    mxArray * v1 = mclGetUninitializedArray();
    mxArray * v2 = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/trdog",
      18,
      &x,
      &g,
      &H,
      &fdata,
      &D,
      &delta,
      &dv,
      &mtxmpy,
      &pcmtx,
      &pcoptions,
      &tol,
      &kmax,
      &theta,
      &l,
      &u,
      &Z_,
      &dnewt,
      &preconflag);
    mclCopyArray(&tol);
    mclCopyInputArg(Z, Z_);
    /*
     * mtxmpy,pcmtx,pcoptions,tol,kmax,theta,l,u,Z,dnewt,preconflag);
     * %TRDOG Reflected (2-D) trust region trial step (box constraints)
     * %
     * % [s,snod,qpval,posdef,pcgit,Z] = TRDOG(x,g,H,fdata,D,delta,dv,...
     * %                 mtxmpy,pcmtx,pcoptions,tol,theta,l,u,Z,dnewt,preconflag);
     * %
     * %   Determine the trial step `s', an approx. trust region solution.
     * %   `s' is chosen as the best of 3 steps: the scaled gradient
     * %   (truncated to  maintain strict feasibility),
     * %   a 2-D trust region solution (truncated to remain strictly feas.),
     * %   and the reflection of the 2-D trust region solution,
     * %   (truncated to remain strictly feasible).
     * %
     * %   The 2-D subspace (defining the trust region
     * %   problem) is defined by the scaled gradient
     * %   direction and a CG process (returning
     * %   either an approximate Newton step of a dirn of negative curvature.
     * %   See ?? for more detail. 
     * %   Driver function is SFMIN
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.5 $  $Date: 1998/09/15 22:43:40 $
     * 
     * % Initialization
     * n = length(g);  
     */
    mlfAssign(&n, mlfLength(g));
    /*
     * pcgit = 0; 
     */
    mlfAssign(pcgit, mlfScalar(0.0));
    /*
     * grad = D*g;
     */
    mlfAssign(&grad, mlfMtimes(D, g));
    /*
     * DM = D; 
     */
    mlfAssign(&DM, D);
    /*
     * DG = sparse(1:n,1:n,full(abs(g).*dv));
     */
    mlfAssign(
      &DG,
      mlfSparse(
        mlfColon(mlfScalar(1.0), n, NULL),
        mlfColon(mlfScalar(1.0), n, NULL),
        mlfFull(mlfTimes(mlfAbs(g), dv)),
        NULL,
        NULL,
        NULL));
    /*
     * posdef = 1; 
     */
    mlfAssign(posdef, mlfScalar(1.0));
    /*
     * pcgit = 0; 
     */
    mlfAssign(pcgit, mlfScalar(0.0));
    /*
     * tol2 = sqrt(eps);
     */
    mlfAssign(&tol2, mlfSqrt(mlfEps()));
    /*
     * v1 = dnewt; 
     */
    mlfAssign(&v1, dnewt);
    /*
     * qpval1 = inf; 
     */
    mlfAssign(&qpval1, mlfInf());
    /*
     * qpval2 = inf; 
     */
    mlfAssign(&qpval2, mlfInf());
    /*
     * qpval3 = inf;
     */
    mlfAssign(&qpval3, mlfInf());
    /*
     * 
     * % DETERMINE A 2-DIMENSIONAL SUBSPACE
     * if isempty(Z)
     */
    if (mlfTobool(mlfIsempty(*Z))) {
        /*
         * if isempty(v1)
         */
        if (mlfTobool(mlfIsempty(v1))) {
            /*
             * switch preconflag
             * case 'hessprecon'
             */
            if (mclSwitchCompare(preconflag, mxCreateString("hessprecon"))) {
                /*
                 * HH = DM*H*DM + DG;
                 */
                mlfAssign(&HH, mlfPlus(mlfMtimes(mlfMtimes(DM, H), DM), DG));
                /*
                 * [R,permR] = feval(pcmtx,HH,pcoptions);
                 */
                mlfFeval(
                  mlfVarargout(&R, &permR, NULL),
                  mclFevalLookup(pcmtx, 0, NULL),
                  HH,
                  pcoptions,
                  NULL);
            /*
             * case 'jacobprecon'
             */
            } else if (mclSwitchCompare(
                         preconflag, mxCreateString("jacobprecon"))) {
                /*
                 * [R,permR] = feval(pcmtx,DM,DG,H,pcoptions);
                 */
                mlfFeval(
                  mlfVarargout(&R, &permR, NULL),
                  mclFevalLookup(pcmtx, 0, NULL),
                  DM,
                  DG,
                  H,
                  pcoptions,
                  NULL);
            /*
             * otherwise
             */
            } else {
                /*
                 * error('Invalid string used for PRECONFLAG argument to TRDOG');
                 */
                mlfError(
                  mxCreateString(
                    "Invalid string used for PRECONFLAG argument to TRDOG"));
            /*
             * end
             */
            }
            /*
             * % We now pass kmax in from calling function
             * %kmax = max(1,floor(n/2));
             * if tol <= 0, 
             */
            if (mlfTobool(mlfLe(tol, mlfScalar(0.0)))) {
                /*
                 * tol = .1; 
                 */
                mlfAssign(&tol, mlfScalar(.1));
            /*
             * end 
             */
            }
            /*
             * [v1,posdef,pcgit] = pcgr(DM,DG,grad,kmax,tol,mtxmpy,fdata,H,R,permR);
             */
            mlfAssign(
              &v1,
              mlfOptim_private_pcgr(
                posdef,
                pcgit,
                DM,
                DG,
                grad,
                kmax,
                tol,
                mtxmpy,
                fdata,
                H,
                R,
                permR));
        /*
         * end
         */
        }
        /*
         * if norm(v1) > 0
         */
        if (mlfTobool(mlfGt(mlfNorm(v1, NULL), mlfScalar(0.0)))) {
            /*
             * v1 = v1/norm(v1);
             */
            mlfAssign(&v1, mlfMrdivide(v1, mlfNorm(v1, NULL)));
        /*
         * end
         */
        }
        /*
         * Z(:,1) = v1;
         */
        mlfIndexAssign(Z, "(?,?)", mlfCreateColonIndex(), mlfScalar(1.0), v1);
        /*
         * if n > 1
         */
        if (mlfTobool(mlfGt(n, mlfScalar(1.0)))) {
            /*
             * if (posdef < 1)
             */
            if (mlfTobool(mlfLt(*posdef, mlfScalar(1.0)))) {
                /*
                 * v2 = D*sign(grad); 
                 */
                mlfAssign(&v2, mlfMtimes(D, mlfSign(grad)));
                /*
                 * if norm(v2) > 0
                 */
                if (mlfTobool(mlfGt(mlfNorm(v2, NULL), mlfScalar(0.0)))) {
                    /*
                     * v2 = v2/norm(v2);
                     */
                    mlfAssign(&v2, mlfMrdivide(v2, mlfNorm(v2, NULL)));
                /*
                 * end
                 */
                }
                /*
                 * v2 = v2 - v1*(v1'*v2); 
                 */
                mlfAssign(
                  &v2,
                  mlfMinus(
                    v2, mlfMtimes(v1, mlfMtimes(mlfCtranspose(v1), v2))));
                /*
                 * nrmv2 = norm(v2);
                 */
                mlfAssign(&nrmv2, mlfNorm(v2, NULL));
                /*
                 * if nrmv2 > tol2
                 */
                if (mlfTobool(mlfGt(nrmv2, tol2))) {
                    /*
                     * v2 = v2/nrmv2; 
                     */
                    mlfAssign(&v2, mlfMrdivide(v2, nrmv2));
                    /*
                     * Z(:,2) = v2;
                     */
                    mlfIndexAssign(
                      Z, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0), v2);
                /*
                 * end
                 */
                }
            /*
             * else
             */
            } else {
                /*
                 * if norm(grad) > 0
                 */
                if (mlfTobool(mlfGt(mlfNorm(grad, NULL), mlfScalar(0.0)))) {
                    /*
                     * v2 = grad/norm(grad);
                     */
                    mlfAssign(&v2, mlfMrdivide(grad, mlfNorm(grad, NULL)));
                /*
                 * else
                 */
                } else {
                    /*
                     * v2 = grad;
                     */
                    mlfAssign(&v2, grad);
                /*
                 * end
                 */
                }
                /*
                 * v2 = v2 - v1*(v1'*v2); 
                 */
                mlfAssign(
                  &v2,
                  mlfMinus(
                    v2, mlfMtimes(v1, mlfMtimes(mlfCtranspose(v1), v2))));
                /*
                 * nrmv2 = norm(v2);
                 */
                mlfAssign(&nrmv2, mlfNorm(v2, NULL));
                /*
                 * if nrmv2 > tol2
                 */
                if (mlfTobool(mlfGt(nrmv2, tol2))) {
                    /*
                     * v2 = v2/nrmv2; 
                     */
                    mlfAssign(&v2, mlfMrdivide(v2, nrmv2));
                    /*
                     * Z(:,2) = v2; 
                     */
                    mlfIndexAssign(
                      Z, "(?,?)", mlfCreateColonIndex(), mlfScalar(2.0), v2);
                /*
                 * end
                 */
                }
            /*
             * end
             */
            }
        /*
         * end
         */
        }
    /*
     * end
     */
    }
    /*
     * 
     * %  REDUCE TO THE CHOSEN SUBSPACE
     * W = DM*Z;  
     */
    mlfAssign(&W, mlfMtimes(DM, *Z));
    /*
     * WW = feval(mtxmpy,W,H,fdata); 
     */
    mlfAssign(
      &WW,
      mlfFeval(
        mclValueVarargout(),
        mclFevalLookup(mtxmpy, 0, NULL),
        W,
        H,
        fdata,
        NULL));
    /*
     * W = DM*WW;
     */
    mlfAssign(&W, mlfMtimes(DM, WW));
    /*
     * MM = full(Z'*W + Z'*DG*Z); 
     */
    mlfAssign(
      &MM,
      mlfFull(
        mlfPlus(
          mlfMtimes(mlfCtranspose(*Z), W),
          mlfMtimes(mlfMtimes(mlfCtranspose(*Z), DG), *Z))));
    /*
     * rhs=full(Z'*grad);
     */
    mlfAssign(&rhs, mlfFull(mlfMtimes(mlfCtranspose(*Z), grad)));
    /*
     * 
     * %  Determine 2-D TR soln
     * [st,qpval,po,fcnt,lambda] = trust(rhs,MM,delta);
     */
    mlfAssign(
      &st, mlfOptim_private_trust(qpval, &po, &fcnt, &lambda, rhs, MM, delta));
    /*
     * ss = Z*st;  
     */
    mlfAssign(&ss, mlfMtimes(*Z, st));
    /*
     * s = abs(diag(D)).*ss; 
     */
    mlfAssign(&s, mlfTimes(mlfAbs(mlfDiag(D, NULL)), ss));
    /*
     * s = full(s); 
     */
    mlfAssign(&s, mlfFull(s));
    /*
     * ssave = s;
     */
    mlfAssign(&ssave, s);
    /*
     * sssave = ss; 
     */
    mlfAssign(&sssave, ss);
    /*
     * stsave = st;
     */
    mlfAssign(&stsave, st);
    /*
     * 
     * % Truncate the TR solution?
     * arg = (abs(s) > 0);
     */
    mlfAssign(&arg, mlfGt(mlfAbs(s), mlfScalar(0.0)));
    /*
     * if isnan(s)
     */
    if (mlfTobool(mlfIsnan(s))) {
        /*
         * error('Trust region step contains NaN''s.')
         */
        mlfError(mxCreateString("Trust region step contains NaN's."));
    /*
     * end
     */
    }
    /*
     * % No truncation if s is zero length
     * if isempty(find(arg))   
     */
    if (mlfTobool(mlfIsempty(mlfFind(NULL, NULL, arg)))) {
        /*
         * alpha = 1;
         */
        mlfAssign(&alpha, mlfScalar(1.0));
    /*
     * else
     */
    } else {
        /*
         * mdis = inf;
         */
        mlfAssign(&mdis, mlfInf());
        /*
         * dis = max((u(arg)-x(arg))./s(arg), (l(arg)-x(arg))./s(arg));
         */
        mlfAssign(
          &dis,
          mlfMax(
            NULL,
            mlfRdivide(
              mlfMinus(mlfIndexRef(u, "(?)", arg), mlfIndexRef(x, "(?)", arg)),
              mlfIndexRef(s, "(?)", arg)),
            mlfRdivide(
              mlfMinus(mlfIndexRef(l, "(?)", arg), mlfIndexRef(x, "(?)", arg)),
              mlfIndexRef(s, "(?)", arg)),
            NULL));
        /*
         * [mmdis,ipt] = min(dis);  
         */
        mlfAssign(&mmdis, mlfMin(&ipt, dis, NULL, NULL));
        /*
         * mdis = theta*mmdis;
         */
        mlfAssign(&mdis, mlfMtimes(theta, mmdis));
        /*
         * alpha = min(1,mdis);
         */
        mlfAssign(&alpha, mlfMin(NULL, mlfScalar(1.0), mdis, NULL));
    /*
     * end
     */
    }
    /*
     * s = alpha*s; 
     */
    mlfAssign(&s, mlfMtimes(alpha, s));
    /*
     * st = alpha*st; 
     */
    mlfAssign(&st, mlfMtimes(alpha, st));
    /*
     * ss = full(alpha*ss);
     */
    mlfAssign(&ss, mlfFull(mlfMtimes(alpha, ss)));
    /*
     * qpval1 = rhs'*st + (.5*st)'*MM*st;
     */
    mlfAssign(
      &qpval1,
      mlfPlus(
        mlfMtimes(mlfCtranspose(rhs), st),
        mlfMtimes(
          mlfMtimes(mlfCtranspose(mlfMtimes(mlfScalar(.5), st)), MM), st)));
    /*
     * if n > 1 
     */
    if (mlfTobool(mlfGt(n, mlfScalar(1.0)))) {
        /*
         * %   Evaluate along the reflected direction?
         * qpval3 = inf; 
         */
        mlfAssign(&qpval3, mlfInf());
        /*
         * ssssave = mmdis*sssave;
         */
        mlfAssign(&ssssave, mlfMtimes(mmdis, sssave));
        /*
         * if norm(ssssave) < .9*delta
         */
        if (mlfTobool(
              mlfLt(mlfNorm(ssssave, NULL), mlfMtimes(mlfScalar(.9), delta)))) {
            /*
             * r = mmdis*ssave; 
             */
            mlfAssign(&r, mlfMtimes(mmdis, ssave));
            /*
             * ns = ssave; 
             */
            mlfAssign(&ns, ssave);
            /*
             * ns(ipt) = -ns(ipt); 
             */
            mlfIndexAssign(
              &ns, "(?)", ipt, mlfUminus(mlfIndexRef(ns, "(?)", ipt)));
            /*
             * nx = x+r;
             */
            mlfAssign(&nx, mlfPlus(x, r));
            /*
             * stsave = mmdis*stsave;
             */
            mlfAssign(&stsave, mlfMtimes(mmdis, stsave));
            /*
             * qpval0 = rhs'*stsave + (.5*stsave)'*MM*stsave;
             */
            mlfAssign(
              &qpval0,
              mlfPlus(
                mlfMtimes(mlfCtranspose(rhs), stsave),
                mlfMtimes(
                  mlfMtimes(
                    mlfCtranspose(mlfMtimes(mlfScalar(.5), stsave)), MM),
                  stsave)));
            /*
             * ng = feval(mtxmpy,r,H,fdata); 
             */
            mlfAssign(
              &ng,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(mtxmpy, 0, NULL),
                r,
                H,
                fdata,
                NULL));
            /*
             * ng = ng + g; 
             */
            mlfAssign(&ng, mlfPlus(ng, g));
            /*
             * ngrad = D*ng;
             */
            mlfAssign(&ngrad, mlfMtimes(D, ng));
            /*
             * ngrad = ngrad + DG*ssssave;
             */
            mlfAssign(&ngrad, mlfPlus(ngrad, mlfMtimes(DG, ssssave)));
            /*
             * 
             * %      nss is the reflected direction
             * nss = sssave; 
             */
            mlfAssign(&nss, sssave);
            /*
             * nss(ipt) = -nss(ipt); 
             */
            mlfIndexAssign(
              &nss, "(?)", ipt, mlfUminus(mlfIndexRef(nss, "(?)", ipt)));
            /*
             * ZZ(:,1) = nss/norm(nss);
             */
            mlfIndexAssign(
              &ZZ,
              "(?,?)",
              mlfCreateColonIndex(),
              mlfScalar(1.0),
              mlfMrdivide(nss, mlfNorm(nss, NULL)));
            /*
             * W = DM*ZZ; 
             */
            mlfAssign(&W, mlfMtimes(DM, ZZ));
            /*
             * WW = feval(mtxmpy,W,H,fdata); 
             */
            mlfAssign(
              &WW,
              mlfFeval(
                mclValueVarargout(),
                mclFevalLookup(mtxmpy, 0, NULL),
                W,
                H,
                fdata,
                NULL));
            /*
             * W = DM*WW;
             */
            mlfAssign(&W, mlfMtimes(DM, WW));
            /*
             * MM = full(ZZ'*W + ZZ'*DG*ZZ);
             */
            mlfAssign(
              &MM,
              mlfFull(
                mlfPlus(
                  mlfMtimes(mlfCtranspose(ZZ), W),
                  mlfMtimes(mlfMtimes(mlfCtranspose(ZZ), DG), ZZ))));
            /*
             * nrhs=full(ZZ'*ngrad);
             */
            mlfAssign(&nrhs, mlfFull(mlfMtimes(mlfCtranspose(ZZ), ngrad)));
            /*
             * [nss,tau] = quad1d(nss,ssssave,delta); 
             */
            mlfAssign(&nss, mlfOptim_private_quad1d(&tau, nss, ssssave, delta));
            /*
             * nst = tau/norm(nss);
             */
            mlfAssign(&nst, mlfMrdivide(tau, mlfNorm(nss, NULL)));
            /*
             * ns = abs(diag(D)).*nss; 
             */
            mlfAssign(&ns, mlfTimes(mlfAbs(mlfDiag(D, NULL)), nss));
            /*
             * ns = full(ns);
             */
            mlfAssign(&ns, mlfFull(ns));
            /*
             * 
             * %      Truncate the reflected direction?
             * arg = (abs(ns) > 0); 
             */
            mlfAssign(&arg, mlfGt(mlfAbs(ns), mlfScalar(0.0)));
            /*
             * if isnan(ns)
             */
            if (mlfTobool(mlfIsnan(ns))) {
                /*
                 * error('Reflected trust region step contains NaN''s.')
                 */
                mlfError(
                  mxCreateString(
                    "Reflected trust region step contains NaN's."));
            /*
             * end
             */
            }
            /*
             * % No truncation if s is zero length
             * if isempty(find(arg))   
             */
            if (mlfTobool(mlfIsempty(mlfFind(NULL, NULL, arg)))) {
                /*
                 * alpha = 1;
                 */
                mlfAssign(&alpha, mlfScalar(1.0));
            /*
             * else
             */
            } else {
                /*
                 * mdis = inf;
                 */
                mlfAssign(&mdis, mlfInf());
                /*
                 * dis = max((u(arg)-nx(arg))./ns(arg), (l(arg)-nx(arg))./ns(arg));
                 */
                mlfAssign(
                  &dis,
                  mlfMax(
                    NULL,
                    mlfRdivide(
                      mlfMinus(
                        mlfIndexRef(u, "(?)", arg),
                        mlfIndexRef(nx, "(?)", arg)),
                      mlfIndexRef(ns, "(?)", arg)),
                    mlfRdivide(
                      mlfMinus(
                        mlfIndexRef(l, "(?)", arg),
                        mlfIndexRef(nx, "(?)", arg)),
                      mlfIndexRef(ns, "(?)", arg)),
                    NULL));
                /*
                 * mdis = min(dis);  
                 */
                mlfAssign(&mdis, mlfMin(NULL, dis, NULL, NULL));
                /*
                 * mdis = theta*mdis;
                 */
                mlfAssign(&mdis, mlfMtimes(theta, mdis));
                /*
                 * alpha = min(1,mdis); 
                 */
                mlfAssign(&alpha, mlfMin(NULL, mlfScalar(1.0), mdis, NULL));
            /*
             * end
             */
            }
            /*
             * ns = alpha*ns; 
             */
            mlfAssign(&ns, mlfMtimes(alpha, ns));
            /*
             * nst = alpha*nst; 
             */
            mlfAssign(&nst, mlfMtimes(alpha, nst));
            /*
             * nss = full(alpha*nss);
             */
            mlfAssign(&nss, mlfFull(mlfMtimes(alpha, nss)));
            /*
             * qpval3 = qpval0 +  nrhs'*nst + (.5*nst)'*MM*nst;
             */
            mlfAssign(
              &qpval3,
              mlfPlus(
                mlfPlus(qpval0, mlfMtimes(mlfCtranspose(nrhs), nst)),
                mlfMtimes(
                  mlfMtimes(mlfCtranspose(mlfMtimes(mlfScalar(.5), nst)), MM),
                  nst)));
        /*
         * end
         */
        }
        /*
         * 
         * %   Evaluate along gradient direction
         * ZZ(:,1) = grad/norm(grad);
         */
        mlfIndexAssign(
          &ZZ,
          "(?,?)",
          mlfCreateColonIndex(),
          mlfScalar(1.0),
          mlfMrdivide(grad, mlfNorm(grad, NULL)));
        /*
         * W = DM*ZZ; 
         */
        mlfAssign(&W, mlfMtimes(DM, ZZ));
        /*
         * WW = feval(mtxmpy,W,H,fdata); 
         */
        mlfAssign(
          &WW,
          mlfFeval(
            mclValueVarargout(),
            mclFevalLookup(mtxmpy, 0, NULL),
            W,
            H,
            fdata,
            NULL));
        /*
         * W = DM*WW;
         */
        mlfAssign(&W, mlfMtimes(DM, WW));
        /*
         * MM = full(ZZ'*W + ZZ'*DG*ZZ); 
         */
        mlfAssign(
          &MM,
          mlfFull(
            mlfPlus(
              mlfMtimes(mlfCtranspose(ZZ), W),
              mlfMtimes(mlfMtimes(mlfCtranspose(ZZ), DG), ZZ))));
        /*
         * rhs=full(ZZ'*grad);
         */
        mlfAssign(&rhs, mlfFull(mlfMtimes(mlfCtranspose(ZZ), grad)));
        /*
         * [st,qpval,po,fcnt,lambda] = trust(rhs,MM,delta);
         */
        mlfAssign(
          &st,
          mlfOptim_private_trust(qpval, &po, &fcnt, &lambda, rhs, MM, delta));
        /*
         * ssg = ZZ*st; 
         */
        mlfAssign(&ssg, mlfMtimes(ZZ, st));
        /*
         * sg = abs(diag(D)).*ssg; 
         */
        mlfAssign(&sg, mlfTimes(mlfAbs(mlfDiag(D, NULL)), ssg));
        /*
         * sg = full(sg);
         */
        mlfAssign(&sg, mlfFull(sg));
        /*
         * 
         * %   Truncate the gradient direction?
         * arg = (abs(sg) > 0); 
         */
        mlfAssign(&arg, mlfGt(mlfAbs(sg), mlfScalar(0.0)));
        /*
         * if isnan(arg)
         */
        if (mlfTobool(mlfIsnan(arg))) {
            /*
             * % No truncation if s is zero length
             * error('Gradient step contains NaN''s.')
             */
            mlfError(mxCreateString("Gradient step contains NaN's."));
        /*
         * end
         */
        }
        /*
         * if  isempty(find(arg))   
         */
        if (mlfTobool(mlfIsempty(mlfFind(NULL, NULL, arg)))) {
            /*
             * alpha = 1;
             */
            mlfAssign(&alpha, mlfScalar(1.0));
        /*
         * else
         */
        } else {
            /*
             * mdis = inf;
             */
            mlfAssign(&mdis, mlfInf());
            /*
             * dis = max((u(arg)-x(arg))./sg(arg), (l(arg)-x(arg))./sg(arg));
             */
            mlfAssign(
              &dis,
              mlfMax(
                NULL,
                mlfRdivide(
                  mlfMinus(
                    mlfIndexRef(u, "(?)", arg), mlfIndexRef(x, "(?)", arg)),
                  mlfIndexRef(sg, "(?)", arg)),
                mlfRdivide(
                  mlfMinus(
                    mlfIndexRef(l, "(?)", arg), mlfIndexRef(x, "(?)", arg)),
                  mlfIndexRef(sg, "(?)", arg)),
                NULL));
            /*
             * mdis = min(dis); 
             */
            mlfAssign(&mdis, mlfMin(NULL, dis, NULL, NULL));
            /*
             * mdis = theta*mdis;
             */
            mlfAssign(&mdis, mlfMtimes(theta, mdis));
            /*
             * alpha = min(1,mdis); 
             */
            mlfAssign(&alpha, mlfMin(NULL, mlfScalar(1.0), mdis, NULL));
        /*
         * end
         */
        }
        /*
         * sg = alpha*sg; 
         */
        mlfAssign(&sg, mlfMtimes(alpha, sg));
        /*
         * st = alpha*st; 
         */
        mlfAssign(&st, mlfMtimes(alpha, st));
        /*
         * ssg = full(alpha*ssg);
         */
        mlfAssign(&ssg, mlfFull(mlfMtimes(alpha, ssg)));
        /*
         * qpval2 = rhs'*st + (.5*st)'*MM*st;
         */
        mlfAssign(
          &qpval2,
          mlfPlus(
            mlfMtimes(mlfCtranspose(rhs), st),
            mlfMtimes(
              mlfMtimes(mlfCtranspose(mlfMtimes(mlfScalar(.5), st)), MM), st)));
    /*
     * end
     */
    }
    /*
     * 
     * % Choose the best of s, sg, ns.
     * if qpval2 <= min(qpval1,qpval3)
     */
    if (mlfTobool(mlfLe(qpval2, mlfMin(NULL, qpval1, qpval3, NULL)))) {
        /*
         * qpval = qpval2; 
         */
        mlfAssign(qpval, qpval2);
        /*
         * s = sg; 
         */
        mlfAssign(&s, sg);
        /*
         * snod = ssg;
         */
        mlfAssign(snod, ssg);
    /*
     * elseif qpval1 <= min(qpval2,qpval3)
     */
    } else if (mlfTobool(mlfLe(qpval1, mlfMin(NULL, qpval2, qpval3, NULL)))) {
        /*
         * qpval = qpval1; 
         */
        mlfAssign(qpval, qpval1);
        /*
         * snod = ss;
         */
        mlfAssign(snod, ss);
    /*
     * else
     */
    } else {
        /*
         * qpval = qpval3; 
         */
        mlfAssign(qpval, qpval3);
        /*
         * s = ns + r; 
         */
        mlfAssign(&s, mlfPlus(ns, r));
        /*
         * snod = nss + ssssave;
         */
        mlfAssign(snod, mlfPlus(nss, ssssave));
    /*
     * end
     */
    }
    mclValidateOutputs(
      "optim/private/trdog", 6, nargout_, &s, snod, qpval, posdef, pcgit, Z);
    mxDestroyArray(DG);
    mxDestroyArray(DM);
    mxDestroyArray(HH);
    mxDestroyArray(MM);
    mxDestroyArray(R);
    mxDestroyArray(W);
    mxDestroyArray(WW);
    mxDestroyArray(ZZ);
    mxDestroyArray(alpha);
    mxDestroyArray(arg);
    mxDestroyArray(dis);
    mxDestroyArray(fcnt);
    mxDestroyArray(grad);
    mxDestroyArray(ipt);
    mxDestroyArray(lambda);
    mxDestroyArray(mdis);
    mxDestroyArray(mmdis);
    mxDestroyArray(n);
    mxDestroyArray(ng);
    mxDestroyArray(ngrad);
    mxDestroyArray(nrhs);
    mxDestroyArray(nrmv2);
    mxDestroyArray(ns);
    mxDestroyArray(nss);
    mxDestroyArray(nst);
    mxDestroyArray(nx);
    mxDestroyArray(permR);
    mxDestroyArray(po);
    mxDestroyArray(qpval0);
    mxDestroyArray(qpval1);
    mxDestroyArray(qpval2);
    mxDestroyArray(qpval3);
    mxDestroyArray(r);
    mxDestroyArray(rhs);
    mxDestroyArray(sg);
    mxDestroyArray(ss);
    mxDestroyArray(ssave);
    mxDestroyArray(ssg);
    mxDestroyArray(sssave);
    mxDestroyArray(ssssave);
    mxDestroyArray(st);
    mxDestroyArray(stsave);
    mxDestroyArray(tau);
    mxDestroyArray(tol);
    mxDestroyArray(tol2);
    mxDestroyArray(v1);
    mxDestroyArray(v2);
    /*
     * 
     * 
     * 
     * 
     */
    return s;
}

/*
 * The function "mlfOptim_private_trdog" contains the normal interface for the
 * "optim/private/trdog" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trdog.m" (lines 1-226). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_trdog(mxArray * * snod,
                                 mxArray * * qpval,
                                 mxArray * * posdef,
                                 mxArray * * pcgit,
                                 mxArray * * Z,
                                 mxArray * x,
                                 mxArray * g,
                                 mxArray * H,
                                 mxArray * fdata,
                                 mxArray * D,
                                 mxArray * delta,
                                 mxArray * dv,
                                 mxArray * mtxmpy,
                                 mxArray * pcmtx,
                                 mxArray * pcoptions,
                                 mxArray * tol,
                                 mxArray * kmax,
                                 mxArray * theta,
                                 mxArray * l,
                                 mxArray * u,
                                 mxArray * Z_,
                                 mxArray * dnewt,
                                 mxArray * preconflag) {
    int nargout = 1;
    mxArray * s = mclGetUninitializedArray();
    mxArray * snod__ = mclGetUninitializedArray();
    mxArray * qpval__ = mclGetUninitializedArray();
    mxArray * posdef__ = mclGetUninitializedArray();
    mxArray * pcgit__ = mclGetUninitializedArray();
    mxArray * Z__ = mclGetUninitializedArray();
    mlfEnterNewContext(
      5,
      18,
      snod,
      qpval,
      posdef,
      pcgit,
      Z,
      x,
      g,
      H,
      fdata,
      D,
      delta,
      dv,
      mtxmpy,
      pcmtx,
      pcoptions,
      tol,
      kmax,
      theta,
      l,
      u,
      Z_,
      dnewt,
      preconflag);
    if (snod != NULL) {
        ++nargout;
    }
    if (qpval != NULL) {
        ++nargout;
    }
    if (posdef != NULL) {
        ++nargout;
    }
    if (pcgit != NULL) {
        ++nargout;
    }
    if (Z != NULL) {
        ++nargout;
    }
    s
      = Moptim_private_trdog(
          &snod__,
          &qpval__,
          &posdef__,
          &pcgit__,
          &Z__,
          nargout,
          x,
          g,
          H,
          fdata,
          D,
          delta,
          dv,
          mtxmpy,
          pcmtx,
          pcoptions,
          tol,
          kmax,
          theta,
          l,
          u,
          Z_,
          dnewt,
          preconflag);
    mlfRestorePreviousContext(
      5,
      18,
      snod,
      qpval,
      posdef,
      pcgit,
      Z,
      x,
      g,
      H,
      fdata,
      D,
      delta,
      dv,
      mtxmpy,
      pcmtx,
      pcoptions,
      tol,
      kmax,
      theta,
      l,
      u,
      Z_,
      dnewt,
      preconflag);
    if (snod != NULL) {
        mclCopyOutputArg(snod, snod__);
    } else {
        mxDestroyArray(snod__);
    }
    if (qpval != NULL) {
        mclCopyOutputArg(qpval, qpval__);
    } else {
        mxDestroyArray(qpval__);
    }
    if (posdef != NULL) {
        mclCopyOutputArg(posdef, posdef__);
    } else {
        mxDestroyArray(posdef__);
    }
    if (pcgit != NULL) {
        mclCopyOutputArg(pcgit, pcgit__);
    } else {
        mxDestroyArray(pcgit__);
    }
    if (Z != NULL) {
        mclCopyOutputArg(Z, Z__);
    } else {
        mxDestroyArray(Z__);
    }
    return mlfReturnValue(s);
}

/*
 * The function "mlxOptim_private_trdog" contains the feval interface for the
 * "optim/private/trdog" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\trdog.m" (lines 1-226). The feval
 * function calls the implementation version of optim/private/trdog through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxOptim_private_trdog(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[18];
    mxArray * mplhs[6];
    int i;
    if (nlhs > 6) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/trdog Line: 1 Colu"
            "mn: 0 The function \"optim/private/trdog\" was called "
            "with more than the declared number of outputs (6)"));
    }
    if (nrhs > 18) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/trdog Line: 1 Colu"
            "mn: 0 The function \"optim/private/trdog\" was called "
            "with more than the declared number of inputs (18)"));
    }
    for (i = 0; i < 6; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 18 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 18; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      18,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15],
      mprhs[16],
      mprhs[17]);
    mplhs[0]
      = Moptim_private_trdog(
          &mplhs[1],
          &mplhs[2],
          &mplhs[3],
          &mplhs[4],
          &mplhs[5],
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7],
          mprhs[8],
          mprhs[9],
          mprhs[10],
          mprhs[11],
          mprhs[12],
          mprhs[13],
          mprhs[14],
          mprhs[15],
          mprhs[16],
          mprhs[17]);
    mlfRestorePreviousContext(
      0,
      18,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15],
      mprhs[16],
      mprhs[17]);
    plhs[0] = mplhs[0];
    for (i = 1; i < 6 && i < nlhs; ++i) {
        plhs[i] = mplhs[i];
    }
    for (; i < 6; ++i) {
        mxDestroyArray(mplhs[i]);
    }
}
