/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:22 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_display1.h"
#include "optim_private_xtrack.h"

static double __Array0_r[4] = { .1, .45, .8, .5 };

static double __Array1_r[4] = { .74, .04, .17, .22 };

static double __Array2_r[4] = { .75, .15, .15, .1 };

static double __Array3_r[4] = { .75, .05, .15, .1 };

static double __Array4_r[4] = { 0.1, 0.05, 0.36, 0.30 };

static double __Array5_r[4] = { .25, .05, .5, .21 };

static double __Array6_r[4] = { .26, .16, .48, .1 };

static double __Array7_r[4] = { .26, .06, .48, .1 };

static double __Array8_r[4] = { 0.0, 0.3, 1.0, .7 };

static double __Array9_r[3] = { .0, .0, .0 };

static double __Array10_r[3] = { 1.0, 1.0, 1.0 };

static void Mdisplay1_displayProgress(mxArray * it,
                                      mxArray * csnrm,
                                      mxArray * val,
                                      mxArray * pcgit,
                                      mxArray * npcg,
                                      mxArray * degen,
                                      mxArray * bndfeas,
                                      mxArray * showstat,
                                      mxArray * nbnds,
                                      mxArray * x,
                                      mxArray * g,
                                      mxArray * l,
                                      mxArray * u,
                                      mxArray * figtr,
                                      mxArray * posdef,
                                      mxArray * linfeas);
static void mlfDisplay1_displayProgress(mxArray * it,
                                        mxArray * csnrm,
                                        mxArray * val,
                                        mxArray * pcgit,
                                        mxArray * npcg,
                                        mxArray * degen,
                                        mxArray * bndfeas,
                                        mxArray * showstat,
                                        mxArray * nbnds,
                                        mxArray * x,
                                        mxArray * g,
                                        mxArray * l,
                                        mxArray * u,
                                        mxArray * figtr,
                                        mxArray * posdef,
                                        mxArray * linfeas);
static void mlxDisplay1_displayProgress(int nlhs,
                                        mxArray * plhs[],
                                        int nrhs,
                                        mxArray * prhs[]);
static mxArray * Mdisplay1_displayInit(int nargout_,
                                       mxArray * itbnd,
                                       mxArray * tol,
                                       mxArray * showstat,
                                       mxArray * nbnds,
                                       mxArray * x,
                                       mxArray * g,
                                       mxArray * l,
                                       mxArray * u);
static mxArray * mlfDisplay1_displayInit(mxArray * itbnd,
                                         mxArray * tol,
                                         mxArray * showstat,
                                         mxArray * nbnds,
                                         mxArray * x,
                                         mxArray * g,
                                         mxArray * l,
                                         mxArray * u);
static void mlxDisplay1_displayInit(int nlhs,
                                    mxArray * plhs[],
                                    int nrhs,
                                    mxArray * prhs[]);
static void Mdisplay1_displayFinal(mxArray * figtr, mxArray * figps);
static void mlfDisplay1_displayFinal(mxArray * figtr, mxArray * figps);
static void mlxDisplay1_displayFinal(int nlhs,
                                     mxArray * plhs[],
                                     int nrhs,
                                     mxArray * prhs[]);

/*
 * The function "Moptim_private_display1" is the implementation version of the
 * "optim/private/display1" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 1-27). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function varargout = display1(flag,varargin)
 */
static mxArray * Moptim_private_display1(mxArray * flag, mxArray * varargin) {
    mxArray * varargout = mclGetUninitializedArray();
    mclValidateInputs("optim/private/display1", 1, &flag);
    /*
     * % DISPLAY1 displays progress information during optimization.
     * %   FIGTR =  DISPLAY1('init',itbnd,tol,showstat,nbnds,x,g,l,u)
     * %   does the initialization of the windows.
     * %
     * %   DISPLAY1('progress',it,csnrm,val,pcgit,npcg,degen,bndfeas,...
     * %                     showstat,nbnds,x,g,l,u,figtr,posdef,linfeas)
     * %   displays the current values.
     * %
     * %	DISPLAY1('final',figtr,figps) displays end of optimization messages.
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.7 $  $Date: 1998/07/09 16:30:13 $
     * 
     * switch flag
     * case 'progress'
     */
    if (mclSwitchCompare(flag, mxCreateString("progress"))) {
        /*
         * displayProgress(varargin{:});
         */
        mlfFeval(
          mclAnsVarargout(),
          mlxDisplay1_displayProgress,
          mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
          NULL);
    /*
     * case 'init'
     */
    } else if (mclSwitchCompare(flag, mxCreateString("init"))) {
        /*
         * varargout{1} = displayInit(varargin{:});
         */
        mlfIndexAssign(
          &varargout,
          "{?}",
          mlfScalar(1.0),
          mlfFeval(
            mclValueVarargout(),
            mlxDisplay1_displayInit,
            mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
            NULL));
    /*
     * case 'final'
     */
    } else if (mclSwitchCompare(flag, mxCreateString("final"))) {
        /*
         * displayFinal(varargin{:});
         */
        mlfFeval(
          mclAnsVarargout(),
          mlxDisplay1_displayFinal,
          mlfIndexRef(varargin, "{?}", mlfCreateColonIndex()),
          NULL);
    /*
     * otherwise
     */
    } else {
        /*
         * error('Invalid string used for FLAG argument to DISPLAY1');
         */
        mlfError(
          mxCreateString("Invalid string used for FLAG argument to DISPLAY1"));
    /*
     * end
     */
    }
    /*
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * function displayProgress(it,csnrm,val,pcgit,npcg,degen,bndfeas,...
     * showstat,nbnds,x,g,l,u,figtr,posdef,linfeas)
     * %DISPLAYPROGRESS displays current values of several parameters.
     * %
     * %   DISPLAYPROGRESS(it,csnrm,val,pcgit,npcg,degen,bndfeas,...
     * %                     showstat,nbnds,x,g,l,u,figtr,posdef,linfeas)
     * %   displays current values of several parameters after the Progress
     * %   information window has already been created.
     * %
     * 
     * 
     * %
     * if nargin < 6, degen = -1; end
     * if nargin < 7, bndfeas = inf; end
     * if isempty(bndfeas), bndfeas = inf; end
     * if nargin < 15, posdef = []; end
     * if nargin < 16, linfeas = -1; end 
     * if isempty(linfeas), linfeas = -1; end
     * lastParam = [] ;
     * if degen >= 0
     * lastParam = str2mat(lastParam, ...
     * sprintf(' Degeneracy measure = %-6.2e',degen)); 
     * end
     * if bndfeas < inf
     * lastParam = str2mat(lastParam, ...
     * sprintf(' Feasibility wrt bounds = %-6.2e',bndfeas));
     * end
     * if posdef > 0
     * lastParam = str2mat(lastParam, ...
     * sprintf(' Curvature: Positive')) ;
     * elseif posdef <= 0
     * lastParam = str2mat(lastParam, ...
     * sprintf(' Curvature: Negative')) ;
     * end ;
     * if linfeas >= 0
     * lastParam = str2mat(lastParam, ...
     * sprintf(' Feasibility wrt linear equalities = %-6.2e',linfeas));
     * end ;
     * if ~isempty(lastParam)
     * lastParam(1,:) = [] ; 
     * end 
     * figure(figtr) ;
     * ParamTitl = str2mat('', ...
     * sprintf(' Iteration =  %-4.0f',it), ...
     * sprintf(' First-order optimality accuracy = %-6.2e',csnrm), ...
     * sprintf(' Objective function value =   %-12.10e',val), ...
     * sprintf(' CG iterations  = %-5.0f',pcgit), ...
     * sprintf(' Total CG iterations to date = %-7.0f',npcg), ...
     * lastParam) ;
     * ParamTitlHndl = findobj(figtr,'type','uicontrol',...
     * 'Userdata','Report Progress') ;
     * set(ParamTitlHndl,'String',ParamTitl) ;
     * drawnow 
     * 
     * % Write the same thing to the log file
     * % temporarily disable this feature
     * if 0
     * logfile = fopen('lsot.log','at') ;
     * fprintf(logfile,'\n\n***********************************************************\n') ;
     * fprintf(logfile,[ParamTitl';10*ones(1,size(ParamTitl,1))]) ;
     * fclose(logfile) ;
     * end
     * 
     * if (showstat >=3 & nbnds)
     * figure(figtr) ; 
     * xtrack(x,g,l,u); 
     * end
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return varargout;
}

/*
 * The function "mlfOptim_private_display1" contains the normal interface for
 * the "optim/private/display1" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 1-27). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_display1(mlfVarargoutList * varargout,
                                    mxArray * flag,
                                    ...) {
    mxArray * varargin = mclUnassigned();
    mlfVarargin(&varargin, flag, 0);
    mlfEnterNewContext(0, -2, flag, varargin);
    *mlfGetVarargoutCellPtr(varargout)
      = Moptim_private_display1(flag, varargin);
    mlfRestorePreviousContext(0, 1, flag);
    mxDestroyArray(varargin);
    return mlfAssignOutputs(varargout);
}

/*
 * The function "mlxOptim_private_display1" contains the feval interface for
 * the "optim/private/display1" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 1-27). The feval
 * function calls the implementation version of optim/private/display1 through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxOptim_private_display1(int nlhs,
                               mxArray * plhs[],
                               int nrhs,
                               mxArray * prhs[]) {
    mxArray * mprhs[2];
    mxArray * mplhs[1];
    int i;
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 1 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 1; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 1, mprhs[0]);
    mprhs[1] = NULL;
    mlfAssign(&mprhs[1], mclCreateVararginCell(nrhs - 1, prhs + 1));
    mplhs[0] = Moptim_private_display1(mprhs[0], mprhs[1]);
    mclAssignVarargoutCell(nlhs, plhs, mplhs[0]);
    mlfRestorePreviousContext(0, 1, mprhs[0]);
    mxDestroyArray(mprhs[1]);
}

/*
 * The function "Mdisplay1_displayProgress" is the implementation version of
 * the "display1/displayProgress" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 27-98). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function displayProgress(it,csnrm,val,pcgit,npcg,degen,bndfeas,...
 */
static void Mdisplay1_displayProgress(mxArray * it,
                                      mxArray * csnrm,
                                      mxArray * val,
                                      mxArray * pcgit,
                                      mxArray * npcg,
                                      mxArray * degen,
                                      mxArray * bndfeas,
                                      mxArray * showstat,
                                      mxArray * nbnds,
                                      mxArray * x,
                                      mxArray * g,
                                      mxArray * l,
                                      mxArray * u,
                                      mxArray * figtr,
                                      mxArray * posdef,
                                      mxArray * linfeas) {
    mxArray * ParamTitl = mclGetUninitializedArray();
    mxArray * ParamTitlHndl = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * lastParam = mclGetUninitializedArray();
    mxArray * logfile = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mlfAssign(
      &nargin_,
      mlfNargin(
        0,
        it,
        csnrm,
        val,
        pcgit,
        npcg,
        degen,
        bndfeas,
        showstat,
        nbnds,
        x,
        g,
        l,
        u,
        figtr,
        posdef,
        linfeas,
        NULL));
    mclValidateInputs(
      "display1/displayProgress",
      16,
      &it,
      &csnrm,
      &val,
      &pcgit,
      &npcg,
      &degen,
      &bndfeas,
      &showstat,
      &nbnds,
      &x,
      &g,
      &l,
      &u,
      &figtr,
      &posdef,
      &linfeas);
    mclCopyArray(&degen);
    mclCopyArray(&bndfeas);
    mclCopyArray(&posdef);
    mclCopyArray(&linfeas);
    /*
     * showstat,nbnds,x,g,l,u,figtr,posdef,linfeas)
     * %DISPLAYPROGRESS displays current values of several parameters.
     * %
     * %   DISPLAYPROGRESS(it,csnrm,val,pcgit,npcg,degen,bndfeas,...
     * %                     showstat,nbnds,x,g,l,u,figtr,posdef,linfeas)
     * %   displays current values of several parameters after the Progress
     * %   information window has already been created.
     * %
     * 
     * 
     * %
     * if nargin < 6, degen = -1; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(6.0)))) {
        mlfAssign(&degen, mlfScalar(-1.0));
    }
    /*
     * if nargin < 7, bndfeas = inf; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(7.0)))) {
        mlfAssign(&bndfeas, mlfInf());
    }
    /*
     * if isempty(bndfeas), bndfeas = inf; end
     */
    if (mlfTobool(mlfIsempty(bndfeas))) {
        mlfAssign(&bndfeas, mlfInf());
    }
    /*
     * if nargin < 15, posdef = []; end
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(15.0)))) {
        mlfAssign(&posdef, mclCreateEmptyArray());
    }
    /*
     * if nargin < 16, linfeas = -1; end 
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(16.0)))) {
        mlfAssign(&linfeas, mlfScalar(-1.0));
    }
    /*
     * if isempty(linfeas), linfeas = -1; end
     */
    if (mlfTobool(mlfIsempty(linfeas))) {
        mlfAssign(&linfeas, mlfScalar(-1.0));
    }
    /*
     * lastParam = [] ;
     */
    mlfAssign(&lastParam, mclCreateEmptyArray());
    /*
     * if degen >= 0
     */
    if (mlfTobool(mlfGe(degen, mlfScalar(0.0)))) {
        /*
         * lastParam = str2mat(lastParam, ...
         */
        mlfAssign(
          &lastParam,
          mlfStr2mat(
            lastParam,
            mlfSprintf(
              NULL,
              mxCreateString(" Degeneracy measure = %-6.2e"),
              degen,
              NULL),
            NULL));
    /*
     * sprintf(' Degeneracy measure = %-6.2e',degen)); 
     * end
     */
    }
    /*
     * if bndfeas < inf
     */
    if (mlfTobool(mlfLt(bndfeas, mlfInf()))) {
        /*
         * lastParam = str2mat(lastParam, ...
         */
        mlfAssign(
          &lastParam,
          mlfStr2mat(
            lastParam,
            mlfSprintf(
              NULL,
              mxCreateString(" Feasibility wrt bounds = %-6.2e"),
              bndfeas,
              NULL),
            NULL));
    /*
     * sprintf(' Feasibility wrt bounds = %-6.2e',bndfeas));
     * end
     */
    }
    /*
     * if posdef > 0
     */
    if (mlfTobool(mlfGt(posdef, mlfScalar(0.0)))) {
        /*
         * lastParam = str2mat(lastParam, ...
         */
        mlfAssign(
          &lastParam,
          mlfStr2mat(
            lastParam,
            mlfSprintf(NULL, mxCreateString(" Curvature: Positive"), NULL),
            NULL));
    /*
     * sprintf(' Curvature: Positive')) ;
     * elseif posdef <= 0
     */
    } else if (mlfTobool(mlfLe(posdef, mlfScalar(0.0)))) {
        /*
         * lastParam = str2mat(lastParam, ...
         */
        mlfAssign(
          &lastParam,
          mlfStr2mat(
            lastParam,
            mlfSprintf(NULL, mxCreateString(" Curvature: Negative"), NULL),
            NULL));
    /*
     * sprintf(' Curvature: Negative')) ;
     * end ;
     */
    }
    /*
     * if linfeas >= 0
     */
    if (mlfTobool(mlfGe(linfeas, mlfScalar(0.0)))) {
        /*
         * lastParam = str2mat(lastParam, ...
         */
        mlfAssign(
          &lastParam,
          mlfStr2mat(
            lastParam,
            mlfSprintf(
              NULL,
              mxCreateString(" Feasibility wrt linear equalities = %-6.2e"),
              linfeas,
              NULL),
            NULL));
    /*
     * sprintf(' Feasibility wrt linear equalities = %-6.2e',linfeas));
     * end ;
     */
    }
    /*
     * if ~isempty(lastParam)
     */
    if (mlfTobool(mlfNot(mlfIsempty(lastParam)))) {
        /*
         * lastParam(1,:) = [] ; 
         */
        mlfIndexDelete(
          &lastParam, "(?,?)", mlfScalar(1.0), mlfCreateColonIndex());
    /*
     * end 
     */
    }
    /*
     * figure(figtr) ;
     */
    mclAssignAns(&ans, mlfNFigure(0, figtr, NULL));
    /*
     * ParamTitl = str2mat('', ...
     */
    mlfAssign(
      &ParamTitl,
      mlfStr2mat(
        mxCreateString(""),
        mlfSprintf(NULL, mxCreateString(" Iteration =  %-4.0f"), it, NULL),
        mlfSprintf(
          NULL,
          mxCreateString(" First-order optimality accuracy = %-6.2e"),
          csnrm,
          NULL),
        mlfSprintf(
          NULL,
          mxCreateString(" Objective function value =   %-12.10e"),
          val,
          NULL),
        mlfSprintf(
          NULL, mxCreateString(" CG iterations  = %-5.0f"), pcgit, NULL),
        mlfSprintf(
          NULL,
          mxCreateString(" Total CG iterations to date = %-7.0f"),
          npcg,
          NULL),
        lastParam,
        NULL));
    /*
     * sprintf(' Iteration =  %-4.0f',it), ...
     * sprintf(' First-order optimality accuracy = %-6.2e',csnrm), ...
     * sprintf(' Objective function value =   %-12.10e',val), ...
     * sprintf(' CG iterations  = %-5.0f',pcgit), ...
     * sprintf(' Total CG iterations to date = %-7.0f',npcg), ...
     * lastParam) ;
     * ParamTitlHndl = findobj(figtr,'type','uicontrol',...
     */
    mlfAssign(
      &ParamTitlHndl,
      mlfFindobj(
        figtr,
        mxCreateString("type"),
        mxCreateString("uicontrol"),
        mxCreateString("Userdata"),
        mxCreateString("Report Progress"),
        NULL));
    /*
     * 'Userdata','Report Progress') ;
     * set(ParamTitlHndl,'String',ParamTitl) ;
     */
    mclAssignAns(
      &ans,
      mlfNSet(0, ParamTitlHndl, mxCreateString("String"), ParamTitl, NULL));
    /*
     * drawnow 
     */
    mlfDrawnow(NULL);
    /*
     * 
     * % Write the same thing to the log file
     * % temporarily disable this feature
     * if 0
     */
    if (mlfTobool(mlfScalar(0.0))) {
        /*
         * logfile = fopen('lsot.log','at') ;
         */
        mlfAssign(
          &logfile,
          mlfFopen(
            NULL,
            NULL,
            mxCreateString("lsot.log"),
            mxCreateString("at"),
            NULL));
        /*
         * fprintf(logfile,'\n\n***********************************************************\n') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "\\n\\n*****************************"
              "******************************\\n"),
            NULL));
        /*
         * fprintf(logfile,[ParamTitl';10*ones(1,size(ParamTitl,1))]) ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mlfVertcat(
              mlfHorzcat(mlfCtranspose(ParamTitl), NULL),
              mlfHorzcat(
                mlfMtimes(
                  mlfScalar(10.0),
                  mlfOnes(
                    mlfScalar(1.0),
                    mlfSize(mclValueVarargout(), ParamTitl, mlfScalar(1.0)),
                    NULL)),
                NULL),
              NULL),
            NULL));
        /*
         * fclose(logfile) ;
         */
        mclAssignAns(&ans, mlfFclose(logfile));
    /*
     * end
     */
    }
    /*
     * 
     * if (showstat >=3 & nbnds)
     */
    {
        mxArray * a_ = mclInitialize(mlfGe(showstat, mlfScalar(3.0)));
        if (mlfTobool(a_) && mlfTobool(mlfAnd(a_, nbnds))) {
            mxDestroyArray(a_);
            /*
             * figure(figtr) ; 
             */
            mclAssignAns(&ans, mlfNFigure(0, figtr, NULL));
            /*
             * xtrack(x,g,l,u); 
             */
            mlfOptim_private_xtrack(x, g, l, u, NULL);
        } else {
            mxDestroyArray(a_);
        }
    /*
     * end
     */
    }
    mxDestroyArray(ParamTitl);
    mxDestroyArray(ParamTitlHndl);
    mxDestroyArray(ans);
    mxDestroyArray(bndfeas);
    mxDestroyArray(degen);
    mxDestroyArray(lastParam);
    mxDestroyArray(linfeas);
    mxDestroyArray(logfile);
    mxDestroyArray(nargin_);
    mxDestroyArray(posdef);
/*
 * 
 * 
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 * 
 */
}

/*
 * The function "mlfDisplay1_displayProgress" contains the normal interface for
 * the "display1/displayProgress" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 27-98). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
static void mlfDisplay1_displayProgress(mxArray * it,
                                        mxArray * csnrm,
                                        mxArray * val,
                                        mxArray * pcgit,
                                        mxArray * npcg,
                                        mxArray * degen,
                                        mxArray * bndfeas,
                                        mxArray * showstat,
                                        mxArray * nbnds,
                                        mxArray * x,
                                        mxArray * g,
                                        mxArray * l,
                                        mxArray * u,
                                        mxArray * figtr,
                                        mxArray * posdef,
                                        mxArray * linfeas) {
    mlfEnterNewContext(
      0,
      16,
      it,
      csnrm,
      val,
      pcgit,
      npcg,
      degen,
      bndfeas,
      showstat,
      nbnds,
      x,
      g,
      l,
      u,
      figtr,
      posdef,
      linfeas);
    Mdisplay1_displayProgress(
      it,
      csnrm,
      val,
      pcgit,
      npcg,
      degen,
      bndfeas,
      showstat,
      nbnds,
      x,
      g,
      l,
      u,
      figtr,
      posdef,
      linfeas);
    mlfRestorePreviousContext(
      0,
      16,
      it,
      csnrm,
      val,
      pcgit,
      npcg,
      degen,
      bndfeas,
      showstat,
      nbnds,
      x,
      g,
      l,
      u,
      figtr,
      posdef,
      linfeas);
}

/*
 * The function "mlxDisplay1_displayProgress" contains the feval interface for
 * the "display1/displayProgress" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 27-98). The feval
 * function calls the implementation version of display1/displayProgress
 * through this function. This function processes any input arguments and
 * passes them to the implementation version of the function, appearing above.
 */
static void mlxDisplay1_displayProgress(int nlhs,
                                        mxArray * plhs[],
                                        int nrhs,
                                        mxArray * prhs[]) {
    mxArray * mprhs[16];
    int i;
    if (nlhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayProgress Line: 27 C"
            "olumn: 0 The function \"display1/displayProgress\" was ca"
            "lled with more than the declared number of outputs (0)"));
    }
    if (nrhs > 16) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayProgress Line: 27 C"
            "olumn: 0 The function \"display1/displayProgress\" was ca"
            "lled with more than the declared number of inputs (16)"));
    }
    for (i = 0; i < 16 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 16; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      16,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15]);
    Mdisplay1_displayProgress(
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15]);
    mlfRestorePreviousContext(
      0,
      16,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7],
      mprhs[8],
      mprhs[9],
      mprhs[10],
      mprhs[11],
      mprhs[12],
      mprhs[13],
      mprhs[14],
      mprhs[15]);
}

/*
 * The function "Mdisplay1_displayInit" is the implementation version of the
 * "display1/displayInit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 98-280). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function figtr =  displayInit(itbnd,tol,showstat,nbnds,x,g,l,u)
 */
static mxArray * Mdisplay1_displayInit(int nargout_,
                                       mxArray * itbnd,
                                       mxArray * tol,
                                       mxArray * showstat,
                                       mxArray * nbnds,
                                       mxArray * x,
                                       mxArray * g,
                                       mxArray * l,
                                       mxArray * u) {
    mxArray * figtr = mclGetUninitializedArray();
    mxArray * ParamTitl = mclGetUninitializedArray();
    mxArray * ParamTitlHdln = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * axx = mclGetUninitializedArray();
    mxArray * clk = mclGetUninitializedArray();
    mxArray * logfile = mclGetUninitializedArray();
    mxArray * n = mclGetUninitializedArray();
    mxArray * screensize = mclGetUninitializedArray();
    mxArray * xpos = mclGetUninitializedArray();
    mxArray * ypos = mclGetUninitializedArray();
    mclValidateInputs(
      "display1/displayInit",
      8,
      &itbnd,
      &tol,
      &showstat,
      &nbnds,
      &x,
      &g,
      &l,
      &u);
    /*
     * %DISPLAYINIT Display initial parameter values. 
     * %
     * %   figtr =  DISPLAYINIT(itbnd,tol,showstat,nbnds,x,g,l,u)
     * %   sets the layout for LSOT Progress Information figure.
     * %
     * 
     * 
     * %
     * if (nbnds & showstat >= 3 )
     */
    if (mlfTobool(nbnds)
        && mlfTobool(mlfAnd(nbnds, mlfGe(showstat, mlfScalar(3.0))))) {
        /*
         * 
         * % Produce Large figure window
         * 
         * figtr = findobj('Type','figure','Name','Progress Information') ;
         */
        mlfAssign(
          &figtr,
          mlfFindobj(
            mxCreateString("Type"),
            mxCreateString("figure"),
            mxCreateString("Name"),
            mxCreateString("Progress Information"),
            NULL));
        /*
         * 
         * % Have to check if it has the right size, for that purpose see 
         * % how many axes there are.
         * if ~isempty(figtr) 
         */
        if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
            /*
             * axx = findobj(figtr,'type','axes') ;
             */
            mlfAssign(
              &axx,
              mlfFindobj(
                figtr, mxCreateString("type"), mxCreateString("axes"), NULL));
            /*
             * if sum(size(axx)) < 4 % is small
             */
            if (mlfTobool(
                  mlfLt(
                    mlfSum(mlfSize(mclValueVarargout(), axx, NULL), NULL),
                    mlfScalar(4.0)))) {
                /*
                 * close(figtr) ;
                 */
                mclAssignAns(&ans, mlfNClose(0, figtr, NULL));
                /*
                 * figtr = [] ;
                 */
                mlfAssign(&figtr, mclCreateEmptyArray());
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
        /*
         * 
         * if isempty(figtr)
         */
        if (mlfTobool(mlfIsempty(figtr))) {
            /*
             * 
             * screensize = get(0,'ScreenSize') ;
             */
            mlfAssign(
              &screensize,
              mlfGet(mlfScalar(0.0), mxCreateString("ScreenSize"), NULL));
            /*
             * xpos = floor((screensize(3) - 950)/2) ;
             */
            mlfAssign(
              &xpos,
              mlfFloor(
                mlfMrdivide(
                  mlfMinus(
                    mlfIndexRef(screensize, "(?)", mlfScalar(3.0)),
                    mlfScalar(950.0)),
                  mlfScalar(2.0))));
            /*
             * ypos = floor((screensize(4) - 520)/2) ;
             */
            mlfAssign(
              &ypos,
              mlfFloor(
                mlfMrdivide(
                  mlfMinus(
                    mlfIndexRef(screensize, "(?)", mlfScalar(4.0)),
                    mlfScalar(520.0)),
                  mlfScalar(2.0))));
            /*
             * 
             * figtr=figure( ...
             */
            mlfAssign(
              &figtr,
              mlfNFigure(
                1,
                mxCreateString("NumberTitle"),
                mxCreateString("off"),
                mxCreateString("Name"),
                mxCreateString("Progress Information"),
                mxCreateString("position"),
                mlfHorzcat(
                  xpos, ypos, mlfScalar(950.0), mlfScalar(520.0), NULL),
                NULL));
            /*
             * 'NumberTitle','off', ...        
             * 'Name', 'Progress Information', ...
             * 'position',[xpos ypos 950 520]);
             * 
             * set(figtr,'DefaultAxesPosition',[.1 .45 .8 .5]) ;
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                figtr,
                mxCreateString("DefaultAxesPosition"),
                mlfDoubleMatrix(1, 4, __Array0_r, NULL),
                NULL));
            /*
             * 
             * uicontrol(figtr,...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("frame"),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array1_r, NULL),
                mxCreateString("Value"),
                mlfScalar(0.0),
                mxCreateString("Userdata"),
                mxCreateString("LSOT frame"),
                NULL));
            /*
             * 'Style','frame',...
             * 'Units','normalized',...
             * 'Position',[.74 .04 .17 .22],...
             * 'Value',0,...
             * 'Userdata','LSOT frame');
             * uicontrol(figtr,...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("text"),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array2_r, NULL),
                mxCreateString("Userdata"),
                mxCreateString("lsotlabel"),
                mxCreateString("String"),
                mxCreateString("RUNNING"),
                NULL));
            /*
             * 'Style','text', ...
             * 'Units','normalized', ...
             * 'Position',[.75 .15 .15 .1], ...
             * 'Userdata','lsotlabel',...
             * 'String', 'RUNNING');
             * uicontrol(figtr, ...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("pushbutton"),
                mxCreateString("Units"),
                mxCreateString("Normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array3_r, NULL),
                mxCreateString("String"),
                mxCreateString("STOP Execution"),
                mxCreateString("Userdata"),
                mxCreateString("stop button"),
                mxCreateString("Callback"),
                mxCreateString(
                  "set(findobj(gcf,'Userdata','LSOT frame'),'Value',1);"),
                NULL));
            /*
             * 'Style','pushbutton',...
             * 'Units','Normalized',...
             * 'Position',[.75 .05 .15 .1],...
             * 'String','STOP Execution',...
             * 'Userdata','stop button',...
             * 'Callback', ...
             * 'set(findobj(gcf,''Userdata'',''LSOT frame''),''Value'',1);') ;
             * 
             * 
             * 
             * xtrack(x,g,l,u,'init');
             */
            mlfOptim_private_xtrack(x, g, l, u, mxCreateString("init"));
            /*
             * ParamTitlHdln = uicontrol( ...
             */
            mlfAssign(
              &ParamTitlHdln,
              mlfNUicontrol(
                1,
                mxCreateString("HorizontalAlignment"),
                mxCreateString("left"),
                mxCreateString("Style"),
                mxCreateString("text"),
                mxCreateString("Max"),
                mlfScalar(10.0),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array4_r, NULL),
                mxCreateString("UserData"),
                mxCreateString("Report Progress"),
                NULL));
        /*
         * 'HorizontalAlignment','left',...
         * 'Style','text', ...
         * 'Max',10,...
         * 'Units','normalized', ...
         * 'Position',[0.1 0.05 0.36 0.30], ...
         * 'UserData','Report Progress');
         * %            'Position',[0.1 0.05 0.36 0.35], ...
         * 
         * else
         */
        } else {
            /*
             * 
             * figure(figtr) ;
             */
            mclAssignAns(&ans, mlfNFigure(0, figtr, NULL));
            /*
             * set(findobj(figtr,'Userdata','LSOT frame'),'Value',0) ;
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("LSOT frame"),
                  NULL),
                mxCreateString("Value"),
                mlfScalar(0.0),
                NULL));
            /*
             * set(findobj(figtr,'Userdata','lsotlabel'),'String','RUNNING') ;
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("lsotlabel"),
                  NULL),
                mxCreateString("String"),
                mxCreateString("RUNNING"),
                NULL));
            /*
             * set(findobj(figtr,'Userdata','stop button'), ...
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("stop button"),
                  NULL),
                mxCreateString("String"),
                mxCreateString("STOP Execution"),
                mxCreateString("Callback"),
                mxCreateString(
                  "set(findobj(gcf,'Userdata','LSOT frame'),'Value',1);"),
                NULL));
            /*
             * 'String','STOP Execution',...
             * 'Callback', ...
             * 'set(findobj(gcf,''Userdata'',''LSOT frame''),''Value'',1);');
             * ParamTitlHdln = findobj(figtr,'Userdata','Report Progress');
             */
            mlfAssign(
              &ParamTitlHdln,
              mlfFindobj(
                figtr,
                mxCreateString("Userdata"),
                mxCreateString("Report Progress"),
                NULL));
            /*
             * 
             * % Erase the axes and start the plots again
             * n = length(x) ;
             */
            mlfAssign(&n, mlfLength(x));
            /*
             * delete(findobj(figtr,'type','axes')) ;
             */
            mlfDelete(
              mlfFindobj(
                figtr, mxCreateString("type"), mxCreateString("axes"), NULL),
              NULL);
            /*
             * xtrack(x,g,l,u,'init') ;
             */
            mlfOptim_private_xtrack(x, g, l, u, mxCreateString("init"));
        /*
         * end ;
         */
        }
    /*
     * else
     */
    } else {
        /*
         * 
         * % Produce small figure window
         * 
         * figtr = findobj('Type','figure','Name','Progress Information') ;
         */
        mlfAssign(
          &figtr,
          mlfFindobj(
            mxCreateString("Type"),
            mxCreateString("figure"),
            mxCreateString("Name"),
            mxCreateString("Progress Information"),
            NULL));
        /*
         * % Have to check if it has the right size, for that purpose see 
         * % how many axes there are.
         * if ~isempty(figtr) 
         */
        if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
            /*
             * axx = findobj(figtr,'type','axes') ;
             */
            mlfAssign(
              &axx,
              mlfFindobj(
                figtr, mxCreateString("type"), mxCreateString("axes"), NULL));
            /*
             * if sum(size(axx)) >= 4 % is big
             */
            if (mlfTobool(
                  mlfGe(
                    mlfSum(mlfSize(mclValueVarargout(), axx, NULL), NULL),
                    mlfScalar(4.0)))) {
                /*
                 * close(figtr) ;
                 */
                mclAssignAns(&ans, mlfNClose(0, figtr, NULL));
                /*
                 * figtr = [] ;
                 */
                mlfAssign(&figtr, mclCreateEmptyArray());
            /*
             * end ;
             */
            }
        /*
         * end ;
         */
        }
        /*
         * if isempty(figtr)
         */
        if (mlfTobool(mlfIsempty(figtr))) {
            /*
             * % Have to create the whole figure
             * 
             * screensize = get(0,'ScreenSize') ;
             */
            mlfAssign(
              &screensize,
              mlfGet(mlfScalar(0.0), mxCreateString("ScreenSize"), NULL));
            /*
             * xpos = floor((screensize(3) - 360)/2) ;
             */
            mlfAssign(
              &xpos,
              mlfFloor(
                mlfMrdivide(
                  mlfMinus(
                    mlfIndexRef(screensize, "(?)", mlfScalar(3.0)),
                    mlfScalar(360.0)),
                  mlfScalar(2.0))));
            /*
             * ypos = floor((screensize(4) - 300)/2) ;
             */
            mlfAssign(
              &ypos,
              mlfFloor(
                mlfMrdivide(
                  mlfMinus(
                    mlfIndexRef(screensize, "(?)", mlfScalar(4.0)),
                    mlfScalar(300.0)),
                  mlfScalar(2.0))));
            /*
             * 
             * figtr=figure( ...
             */
            mlfAssign(
              &figtr,
              mlfNFigure(
                1,
                mxCreateString("NumberTitle"),
                mxCreateString("off"),
                mxCreateString("Name"),
                mxCreateString("Progress Information"),
                mxCreateString("position"),
                mlfHorzcat(
                  xpos, ypos, mlfScalar(360.0), mlfScalar(300.0), NULL),
                NULL));
            /*
             * 'NumberTitle','off', ...        
             * 'Name', 'Progress Information', ...
             * 'position',[xpos ypos 360 300]);
             * 
             * 
             * uicontrol(figtr,...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("frame"),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array5_r, NULL),
                mxCreateString("Value"),
                mlfScalar(0.0),
                mxCreateString("Userdata"),
                mxCreateString("LSOT frame"),
                NULL));
            /*
             * 'Style','frame',...
             * 'Units','normalized',...
             * 'Position',[.25 .05 .5 .21],...
             * 'Value',0,...
             * 'Userdata','LSOT frame');
             * uicontrol(figtr,...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("text"),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array6_r, NULL),
                mxCreateString("Userdata"),
                mxCreateString("lsotlabel"),
                mxCreateString("String"),
                mxCreateString("RUNNING"),
                NULL));
            /*
             * 'Style','text', ...
             * 'Units','normalized', ...
             * 'Position',[.26 .16 .48 .1], ...
             * 'Userdata','lsotlabel',...
             * 'String', 'RUNNING');
             * uicontrol(figtr, ...
             */
            mclAssignAns(
              &ans,
              mlfNUicontrol(
                0,
                figtr,
                mxCreateString("Style"),
                mxCreateString("pushbutton"),
                mxCreateString("Units"),
                mxCreateString("Normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array7_r, NULL),
                mxCreateString("String"),
                mxCreateString("STOP Execution"),
                mxCreateString("Userdata"),
                mxCreateString("stop button"),
                mxCreateString("Callback"),
                mxCreateString(
                  "set(findobj(gcf,'Userdata','LSOT frame'),'Value',1);"),
                NULL));
            /*
             * 'Style','pushbutton',...
             * 'Units','Normalized',...
             * 'Position',[.26 .06 .48 .1],...
             * 'String','STOP Execution',...
             * 'Userdata','stop button',...
             * 'Callback','set(findobj(gcf,''Userdata'',''LSOT frame''),''Value'',1);') ;
             * 
             * %   'HorizontalAlignment','left',...
             * ParamTitlHdln = uicontrol( ...
             */
            mlfAssign(
              &ParamTitlHdln,
              mlfNUicontrol(
                1,
                mxCreateString("Style"),
                mxCreateString("text"),
                mxCreateString("Max"),
                mlfScalar(10.0),
                mxCreateString("Units"),
                mxCreateString("normalized"),
                mxCreateString("Position"),
                mlfDoubleMatrix(1, 4, __Array8_r, NULL),
                mxCreateString("Background"),
                mlfDoubleMatrix(1, 3, __Array9_r, NULL),
                mxCreateString("Foreground"),
                mlfDoubleMatrix(1, 3, __Array10_r, NULL),
                mxCreateString("UserData"),
                mxCreateString("Report Progress"),
                NULL));
        /*
         * 'Style','text',...
         * 'Max',10, ...
         * 'Units','normalized', ...
         * 'Position',[0 0.3 1 .7], ...
         * 'Background',[.0 .0 .0], ...
         * 'Foreground',[1 1 1],...
         * 'UserData','Report Progress');
         * 
         * else
         */
        } else {
            /*
             * figure(figtr) ;
             */
            mclAssignAns(&ans, mlfNFigure(0, figtr, NULL));
            /*
             * set(findobj(figtr,'Userdata','LSOT frame'),'Value',0) ;
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("LSOT frame"),
                  NULL),
                mxCreateString("Value"),
                mlfScalar(0.0),
                NULL));
            /*
             * set(findobj(figtr,'Userdata','lsotlabel'),'String','RUNNING') ;
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("lsotlabel"),
                  NULL),
                mxCreateString("String"),
                mxCreateString("RUNNING"),
                NULL));
            /*
             * set(findobj(figtr,'Userdata','stop button'),...
             */
            mclAssignAns(
              &ans,
              mlfNSet(
                0,
                mlfFindobj(
                  figtr,
                  mxCreateString("Userdata"),
                  mxCreateString("stop button"),
                  NULL),
                mxCreateString("String"),
                mxCreateString("STOP Execution"),
                mxCreateString("Callback"),
                mxCreateString(
                  "set(findobj(gcf,'Userdata','LSOT frame'),'Value',1);"),
                NULL));
            /*
             * 'String','STOP Execution',...
             * 'Callback',...
             * 'set(findobj(gcf,''Userdata'',''LSOT frame''),''Value'',1);') ;
             * ParamTitlHdln = findobj(figtr,'Userdata','Report Progress');
             */
            mlfAssign(
              &ParamTitlHdln,
              mlfFindobj(
                figtr,
                mxCreateString("Userdata"),
                mxCreateString("Report Progress"),
                NULL));
        /*
         * end 
         */
        }
    /*
     * end
     */
    }
    /*
     * ParamTitl = str2mat([], ...
     */
    mlfAssign(
      &ParamTitl,
      mlfStr2mat(
        mclCreateEmptyArray(),
        mlfSprintf(
          NULL,
          mxCreateString(" Effective dimension of problem = %-4.0f"),
          mlfLength(x),
          NULL),
        mlfSprintf(
          NULL,
          mxCreateString(" Maximum number of iterations = %-4.0f"),
          itbnd,
          NULL),
        mlfSprintf(
          NULL, mxCreateString(" Termination Tolerance =  %-6.2e"), tol, NULL),
        mlfSprintf(
          NULL,
          mxCreateString(" Output display level =   %-4.0f"),
          showstat,
          NULL),
        NULL));
    /*
     * sprintf(' Effective dimension of problem = %-4.0f', ...
     * length(x)), ...
     * sprintf(' Maximum number of iterations = %-4.0f', ...
     * itbnd), ...
     * sprintf(' Termination Tolerance =  %-6.2e',tol), ...
     * sprintf(' Output display level =   %-4.0f',showstat)) ;
     * set(ParamTitlHdln,'String',ParamTitl) ;
     */
    mclAssignAns(
      &ans,
      mlfNSet(0, ParamTitlHdln, mxCreateString("String"), ParamTitl, NULL));
    /*
     * 
     * % Create log file and write the same thing to it
     * % temporarily disable this feature
     * if 0
     */
    if (mlfTobool(mlfScalar(0.0))) {
        /*
         * logfile = fopen('lsot.log','wt') ;
         */
        mlfAssign(
          &logfile,
          mlfFopen(
            NULL,
            NULL,
            mxCreateString("lsot.log"),
            mxCreateString("wt"),
            NULL));
        /*
         * clk = clock ;
         */
        mlfAssign(&clk, mlfClock());
        /*
         * fprintf(logfile,'** LSOT log file. Produced %d-%d-%d at %d:%d:%d \n\n',...
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "** LSOT log file. Produced %d-%d-%d at %d:%d:%d \\n\\n"),
            mlfIndexRef(
              clk, "(?)", mlfColon(mlfScalar(2.0), mlfScalar(3.0), NULL)),
            mlfIndexRef(clk, "(?)", mlfScalar(1.0)),
            mlfIndexRef(
              clk, "(?)", mlfColon(mlfScalar(4.0), mlfScalar(5.0), NULL)),
            mlfFloor(mlfIndexRef(clk, "(?)", mlfScalar(6.0))),
            NULL));
        /*
         * clk(2:3),clk(1),clk(4:5),floor(clk(6))) ;
         * fprintf(logfile,'***********************************************************') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "***********************************************************"),
            NULL));
        /*
         * fprintf(logfile,'\n************************LSOT BEGINS************************') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "\\n************************LSOT BEGINS************************"),
            NULL));
        /*
         * fprintf(logfile,'\n***********************************************************\n') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "\\n*******************************"
              "****************************\\n"),
            NULL));
        /*
         * fprintf(logfile,[ParamTitl';10*ones(1,size(ParamTitl,1))]) ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mlfVertcat(
              mlfHorzcat(mlfCtranspose(ParamTitl), NULL),
              mlfHorzcat(
                mlfMtimes(
                  mlfScalar(10.0),
                  mlfOnes(
                    mlfScalar(1.0),
                    mlfSize(mclValueVarargout(), ParamTitl, mlfScalar(1.0)),
                    NULL)),
                NULL),
              NULL),
            NULL));
        /*
         * fclose(logfile) ;
         */
        mclAssignAns(&ans, mlfFclose(logfile));
    /*
     * end
     */
    }
    /*
     * drawnow ;
     */
    mlfDrawnow(NULL);
    mclValidateOutputs("display1/displayInit", 1, nargout_, &figtr);
    mxDestroyArray(ParamTitl);
    mxDestroyArray(ParamTitlHdln);
    mxDestroyArray(ans);
    mxDestroyArray(axx);
    mxDestroyArray(clk);
    mxDestroyArray(logfile);
    mxDestroyArray(n);
    mxDestroyArray(screensize);
    mxDestroyArray(xpos);
    mxDestroyArray(ypos);
    /*
     * 
     * 
     * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
     * 
     */
    return figtr;
}

/*
 * The function "mlfDisplay1_displayInit" contains the normal interface for the
 * "display1/displayInit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 98-280). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
static mxArray * mlfDisplay1_displayInit(mxArray * itbnd,
                                         mxArray * tol,
                                         mxArray * showstat,
                                         mxArray * nbnds,
                                         mxArray * x,
                                         mxArray * g,
                                         mxArray * l,
                                         mxArray * u) {
    int nargout = 1;
    mxArray * figtr = mclGetUninitializedArray();
    mlfEnterNewContext(0, 8, itbnd, tol, showstat, nbnds, x, g, l, u);
    figtr
      = Mdisplay1_displayInit(
          nargout, itbnd, tol, showstat, nbnds, x, g, l, u);
    mlfRestorePreviousContext(0, 8, itbnd, tol, showstat, nbnds, x, g, l, u);
    return mlfReturnValue(figtr);
}

/*
 * The function "mlxDisplay1_displayInit" contains the feval interface for the
 * "display1/displayInit" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 98-280). The feval
 * function calls the implementation version of display1/displayInit through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
static void mlxDisplay1_displayInit(int nlhs,
                                    mxArray * plhs[],
                                    int nrhs,
                                    mxArray * prhs[]) {
    mxArray * mprhs[8];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayInit Line: 98 Col"
            "umn: 0 The function \"display1/displayInit\" was called"
            " with more than the declared number of outputs (1)"));
    }
    if (nrhs > 8) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayInit Line: 98 Co"
            "lumn: 0 The function \"display1/displayInit\" was call"
            "ed with more than the declared number of inputs (8)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 8 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 8; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    mplhs[0]
      = Mdisplay1_displayInit(
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6],
          mprhs[7]);
    mlfRestorePreviousContext(
      0,
      8,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6],
      mprhs[7]);
    plhs[0] = mplhs[0];
}

/*
 * The function "Mdisplay1_displayFinal" is the implementation version of the
 * "display1/displayFinal" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 280-323). It contains
 * the actual compiled code for that M-function. It is a static function and
 * must only be called from one of the interface functions, appearing below.
 */
/*
 * function displayFinal(figtr,figps)
 */
static void Mdisplay1_displayFinal(mxArray * figtr, mxArray * figps) {
    mxArray * ans = mclInitializeAns();
    mxArray * callbackstr = mclGetUninitializedArray();
    mxArray * logfile = mclGetUninitializedArray();
    mxArray * nargin_ = mclGetUninitializedArray();
    mlfAssign(&nargin_, mlfNargin(0, figtr, figps, NULL));
    mclValidateInputs("display1/displayFinal", 2, &figtr, &figps);
    mclCopyArray(&figtr);
    mclCopyArray(&figps);
    /*
     * %DISPLAYFINAL Final output and cleanup.
     * %
     * %	DISPLAYFINAL(figtr,figps) displays end-of-the-line notification.
     * %
     * 
     * 
     * if nargin < 2, figps = [] ;
     */
    if (mlfTobool(mlfLt(nargin_, mlfScalar(2.0)))) {
        mlfAssign(&figps, mclCreateEmptyArray());
    /*
     * end ;
     */
    }
    /*
     * 
     * figtr = findobj('type','figure','Name','Progress Information') ;
     */
    mlfAssign(
      &figtr,
      mlfFindobj(
        mxCreateString("type"),
        mxCreateString("figure"),
        mxCreateString("Name"),
        mxCreateString("Progress Information"),
        NULL));
    /*
     * 
     * if ~isempty(figtr)
     */
    if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
        /*
         * set(findobj(figtr,'Userdata','lsotlabel'),'String','DONE') ;
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0,
            mlfFindobj(
              figtr,
              mxCreateString("Userdata"),
              mxCreateString("lsotlabel"),
              NULL),
            mxCreateString("String"),
            mxCreateString("DONE"),
            NULL));
        /*
         * 
         * callbackstr = ['figtr = findobj(''type'',''figure'',',...
         */
        mlfAssign(
          &callbackstr,
          mlfHorzcat(
            mxCreateString("figtr = findobj('type','figure',"),
            mxCreateString("'Name','Algorithm Performance Statistics') ;"),
            mxCreateString("figps = findobj('type','figure',"),
            mxCreateString("'Name', 'Progress Information') ;"),
            mxCreateString("close([figtr, figps])"),
            NULL));
        /*
         * '''Name'',''Algorithm Performance Statistics'') ;', ...
         * 'figps = findobj(''type'',''figure'',',...
         * '''Name'', ''Progress Information'') ;', ...
         * 'close([figtr, figps])'] ;
         * 
         * set(findobj(figtr,'Userdata','stop button'),...
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0,
            mlfFindobj(
              figtr,
              mxCreateString("Userdata"),
              mxCreateString("stop button"),
              NULL),
            mxCreateString("String"),
            mxCreateString("Close optimization windows"),
            mxCreateString("Callback"),
            callbackstr,
            NULL));
    /*
     * 'String','Close optimization windows',...
     * 'Callback',callbackstr) ;
     * 
     * end ;
     */
    }
    /*
     * 
     * % disable this feature
     * if 0
     */
    if (mlfTobool(mlfScalar(0.0))) {
        /*
         * logfile = fopen('lsot.log','at') ;
         */
        mlfAssign(
          &logfile,
          mlfFopen(
            NULL,
            NULL,
            mxCreateString("lsot.log"),
            mxCreateString("at"),
            NULL));
        /*
         * fprintf(logfile,'\n***********************************************************\n') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "\\n*******************************"
              "****************************\\n"),
            NULL));
        /*
         * fprintf(logfile,'*************************LSOT ENDS*************************\n') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "*************************LSOT ENDS*************************\\n"),
            NULL));
        /*
         * fprintf(logfile,'***********************************************************') ;
         */
        mclAssignAns(
          &ans,
          mlfFprintf(
            logfile,
            mxCreateString(
              "***********************************************************"),
            NULL));
    /*
     * end 
     */
    }
    mxDestroyArray(ans);
    mxDestroyArray(callbackstr);
    mxDestroyArray(figps);
    mxDestroyArray(figtr);
    mxDestroyArray(logfile);
    mxDestroyArray(nargin_);
/*
 * 
 * %['figtr = findobj(''type'',''figure'',''Name'', ''Algorithm Performance Statistics'') ;', ...
 * %                   'figps = findobj(''type'',''figure'',''Name'', ''Progress Information'') ;', ...
 * %                    'close([figtr, figps])']);
 * 
 * 
 * 
 * 
 * %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 */
}

/*
 * The function "mlfDisplay1_displayFinal" contains the normal interface for
 * the "display1/displayFinal" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 280-323). This
 * function processes any input arguments and passes them to the implementation
 * version of the function, appearing above.
 */
static void mlfDisplay1_displayFinal(mxArray * figtr, mxArray * figps) {
    mlfEnterNewContext(0, 2, figtr, figps);
    Mdisplay1_displayFinal(figtr, figps);
    mlfRestorePreviousContext(0, 2, figtr, figps);
}

/*
 * The function "mlxDisplay1_displayFinal" contains the feval interface for the
 * "display1/displayFinal" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\display1.m" (lines 280-323). The feval
 * function calls the implementation version of display1/displayFinal through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
static void mlxDisplay1_displayFinal(int nlhs,
                                     mxArray * plhs[],
                                     int nrhs,
                                     mxArray * prhs[]) {
    mxArray * mprhs[2];
    int i;
    if (nlhs > 0) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayFinal Line: 280 Co"
            "lumn: 0 The function \"display1/displayFinal\" was calle"
            "d with more than the declared number of outputs (0)"));
    }
    if (nrhs > 2) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: display1/displayFinal Line: 280 C"
            "olumn: 0 The function \"display1/displayFinal\" was cal"
            "led with more than the declared number of inputs (2)"));
    }
    for (i = 0; i < 2 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 2; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(0, 2, mprhs[0], mprhs[1]);
    Mdisplay1_displayFinal(mprhs[0], mprhs[1]);
    mlfRestorePreviousContext(0, 2, mprhs[0], mprhs[1]);
}
