/*
 * MATLAB Compiler: 2.0.1
 * Date: Tue May 08 21:28:23 2001
 * Arguments: "-B" "sgl" "-m" "-W" "mainhg" "-L" "C" "asufit.m" "absfun.m"
 * "absfunfree.m" "absfunshift.m" "absfunwidth.m" "dispfit.m" "dispfitdisp.m"
 * "dispfitfree.m" "dispfitwidth.m" "seqmodfree.m" "spcfun.m" "spcfun1.m"
 * "atamult.m" "aprecon.m" 
 */
#include "optim_private_xplot.h"
#include "subplot.h"
#include "title.h"
#include "xlabel.h"
#include "ylabel.h"

static double __Array0_r[2] = { -1.0, 1.0 };

/*
 * The function "Moptim_private_xplot" is the implementation version of the
 * "optim/private/xplot" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\xplot.m" (lines 1-87). It contains the
 * actual compiled code for that M-function. It is a static function and must
 * only be called from one of the interface functions, appearing below.
 */
/*
 * function [figps] = xplot(it,vval,vfnrm,vflops,vpos,vdeg,vpcg)
 */
static mxArray * Moptim_private_xplot(int nargout_,
                                      mxArray * it,
                                      mxArray * vval,
                                      mxArray * vfnrm,
                                      mxArray * vflops,
                                      mxArray * vpos,
                                      mxArray * vdeg,
                                      mxArray * vpcg) {
    mxArray * figps = mclGetUninitializedArray();
    mxArray * ans = mclInitializeAns();
    mxArray * closebtn = mclGetUninitializedArray();
    mxArray * currsubplot = mclGetUninitializedArray();
    mxArray * figtr = mclGetUninitializedArray();
    mxArray * itv = mclGetUninitializedArray();
    mxArray * len = mclGetUninitializedArray();
    mxArray * one = mclGetUninitializedArray();
    mxArray * screensize = mclGetUninitializedArray();
    mxArray * ypos = mclGetUninitializedArray();
    mclValidateInputs(
      "optim/private/xplot",
      7,
      &it,
      &vval,
      &vfnrm,
      &vflops,
      &vpos,
      &vdeg,
      &vpcg);
    mclCopyArray(&vpos);
    mclCopyArray(&vdeg);
    /*
     * %XPLOT 4 performance graphs
     * %
     * %	figps = xplot(it,vval,vfnrm,vflops,vpos,vdeg,vpcg)
     * %
     * %	PLOT 4 OUTPUT GRAPHS ON 2-BY-2 DISPLAY   
     * 
     * %   Copyright (c) 1990-98 by The MathWorks, Inc.
     * %   $Revision: 1.3 $  $Date: 1998/07/09 16:30:10 $
     * 
     * % This is to avoid closing the figps window by accident
     * figtr = findobj('type','figure',...
     */
    mlfAssign(
      &figtr,
      mlfFindobj(
        mxCreateString("type"),
        mxCreateString("figure"),
        mxCreateString("Name"),
        mxCreateString("Progress Information"),
        NULL));
    /*
     * 'Name','Progress Information') ; 
     * if ~isempty(figtr) 
     */
    if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
        /*
         * closebtn = findobj(figtr,'name','Close optimization windows') ;
         */
        mlfAssign(
          &closebtn,
          mlfFindobj(
            figtr,
            mxCreateString("name"),
            mxCreateString("Close optimization windows"),
            NULL));
        /*
         * set(closebtn,'enable','off') ;
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0,
            closebtn,
            mxCreateString("enable"),
            mxCreateString("off"),
            NULL));
    /*
     * end ;
     */
    }
    /*
     * 
     * if it <= 0, 
     */
    if (mlfTobool(mlfLe(it, mlfScalar(0.0)))) {
        /*
         * return; 
         */
        goto return_;
    /*
     * end
     */
    }
    /*
     * 
     * figps = findobj('type','figure',...
     */
    mlfAssign(
      &figps,
      mlfFindobj(
        mxCreateString("type"),
        mxCreateString("figure"),
        mxCreateString("Name"),
        mxCreateString("Algorithm Performance Statistics"),
        NULL));
    /*
     * 'Name','Algorithm Performance Statistics') ;
     * if isempty(figps)
     */
    if (mlfTobool(mlfIsempty(figps))) {
        /*
         * screensize = get(0,'ScreenSize') ;
         */
        mlfAssign(
          &screensize,
          mlfGet(mlfScalar(0.0), mxCreateString("ScreenSize"), NULL));
        /*
         * ypos = floor((screensize(4) - 550)/2) ;
         */
        mlfAssign(
          &ypos,
          mlfFloor(
            mlfMrdivide(
              mlfMinus(
                mlfIndexRef(screensize, "(?)", mlfScalar(4.0)),
                mlfScalar(550.0)),
              mlfScalar(2.0))));
        /*
         * figps = figure('Name', 'Algorithm Performance Statistics', ...
         */
        mlfAssign(
          &figps,
          mlfNFigure(
            1,
            mxCreateString("Name"),
            mxCreateString("Algorithm Performance Statistics"),
            mxCreateString("Position"),
            mlfHorzcat(
              mlfScalar(1.0), ypos, mlfScalar(560.0), mlfScalar(550.0), NULL),
            NULL));
    /*
     * 'Position',[1 ypos 560 550]);
     * end ;
     */
    }
    /*
     * figure(figps) ;
     */
    mclAssignAns(&ans, mlfNFigure(0, figps, NULL));
    /*
     * itv = (1:it)';
     */
    mlfAssign(&itv, mlfCtranspose(mlfColon(mlfScalar(1.0), it, NULL)));
    /*
     * subplot(2,2,1), 
     */
    mclPrintAns(
      &ans, mlfNSubplot(0, mlfScalar(2.0), mlfScalar(2.0), mlfScalar(1.0)));
    /*
     * %plot(itv,log10(vfnrm),'-',itv,log10(vfnrm),'go')
     * semilogy(itv,vfnrm,'-',itv,vfnrm,'go')
     */
    mclPrintAns(
      &ans,
      mlfNSemilogy(
        0,
        itv,
        vfnrm,
        mxCreateString("-"),
        itv,
        vfnrm,
        mxCreateString("go"),
        NULL));
    /*
     * %title('First-order Optimality (log 10)')
     * title('Optimality progress per iteration');
     */
    mclAssignAns(
      &ans,
      mlfNTitle(0, mxCreateString("Optimality progress per iteration"), NULL));
    /*
     * xlabel('iteration')
     */
    mclPrintAns(&ans, mlfNXlabel(0, mxCreateString("iteration"), NULL));
    /*
     * ylabel('first-order optimality')
     */
    mclPrintAns(
      &ans, mlfNYlabel(0, mxCreateString("first-order optimality"), NULL));
    /*
     * %
     * 
     * len = length(vpcg); itv = 1:1:len; itv = itv';
     */
    mlfAssign(&len, mlfLength(vpcg));
    mlfAssign(&itv, mlfColon(mlfScalar(1.0), mlfScalar(1.0), len));
    mlfAssign(&itv, mlfCtranspose(itv));
    /*
     * currsubplot=subplot(2,2,2);
     */
    mlfAssign(
      &currsubplot,
      mlfNSubplot(1, mlfScalar(2.0), mlfScalar(2.0), mlfScalar(2.0)));
    /*
     * plot(itv,vpcg,'-',itv,vpcg,'go');
     */
    mclAssignAns(
      &ans,
      mlfNPlot(
        0,
        itv,
        vpcg,
        mxCreateString("-"),
        itv,
        vpcg,
        mxCreateString("go"),
        NULL));
    /*
     * if it < 6
     */
    if (mlfTobool(mlfLt(it, mlfScalar(6.0)))) {
        /*
         * set(currsubplot,'Ytick',0:it);
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0,
            currsubplot,
            mxCreateString("Ytick"),
            mlfColon(mlfScalar(0.0), it, NULL),
            NULL));
    /*
     * end
     */
    }
    /*
     * title('PCG iterations per iteration');
     */
    mclAssignAns(
      &ans, mlfNTitle(0, mxCreateString("PCG iterations per iteration"), NULL));
    /*
     * xlabel('iteration')
     */
    mclPrintAns(&ans, mlfNXlabel(0, mxCreateString("iteration"), NULL));
    /*
     * 
     * itv = (1:length(vpos))';
     */
    mlfAssign(
      &itv, mlfCtranspose(mlfColon(mlfScalar(1.0), mlfLength(vpos), NULL)));
    /*
     * if length(vpos) > 1
     */
    if (mlfTobool(mlfGt(mlfLength(vpos), mlfScalar(1.0)))) {
        /*
         * vpos(1,1) = vpos(2,1);
         */
        mlfIndexAssign(
          &vpos,
          "(?,?)",
          mlfScalar(1.0),
          mlfScalar(1.0),
          mlfIndexRef(vpos, "(?,?)", mlfScalar(2.0), mlfScalar(1.0)));
    /*
     * end
     */
    }
    /*
     * vpos(vpos ==0)= -ones(length(vpos(vpos==0)),1);
     */
    mlfIndexAssign(
      &vpos,
      "(?)",
      mlfEq(vpos, mlfScalar(0.0)),
      mlfUminus(
        mlfOnes(
          mlfLength(mlfIndexRef(vpos, "(?)", mlfEq(vpos, mlfScalar(0.0)))),
          mlfScalar(1.0),
          NULL)));
    /*
     * currsubplot=subplot(2,2,3); 
     */
    mlfAssign(
      &currsubplot,
      mlfNSubplot(1, mlfScalar(2.0), mlfScalar(2.0), mlfScalar(3.0)));
    /*
     * plot(itv(vpos==1),vpos(vpos==1),'xr');
     */
    mclAssignAns(
      &ans,
      mlfNPlot(
        0,
        mlfIndexRef(itv, "(?)", mlfEq(vpos, mlfScalar(1.0))),
        mlfIndexRef(vpos, "(?)", mlfEq(vpos, mlfScalar(1.0))),
        mxCreateString("xr"),
        NULL));
    /*
     * axis([0 it -2 2]);
     */
    mclAssignAns(
      &ans,
      mlfNAxis(
        0,
        NULL,
        NULL,
        mlfHorzcat(mlfScalar(0.0), it, mlfScalar(-2.0), mlfScalar(2.0), NULL),
        NULL));
    /*
     * 
     * hold on
     */
    mlfHold(mxCreateString("on"));
    /*
     * currsubplot = subplot(2,2,3);
     */
    mlfAssign(
      &currsubplot,
      mlfNSubplot(1, mlfScalar(2.0), mlfScalar(2.0), mlfScalar(3.0)));
    /*
     * plot(itv(vpos==-1),vpos(vpos==-1),'ob');
     */
    mclAssignAns(
      &ans,
      mlfNPlot(
        0,
        mlfIndexRef(itv, "(?)", mlfEq(vpos, mlfScalar(-1.0))),
        mlfIndexRef(vpos, "(?)", mlfEq(vpos, mlfScalar(-1.0))),
        mxCreateString("ob"),
        NULL));
    /*
     * set(currsubplot,'YTick',[-1 1]);
     */
    mclAssignAns(
      &ans,
      mlfNSet(
        0,
        currsubplot,
        mxCreateString("YTick"),
        mlfDoubleMatrix(1, 2, __Array0_r, NULL),
        NULL));
    /*
     * set(currsubplot,'YTickLabel',{'negative';'positive'});
     */
    mclAssignAns(
      &ans,
      mlfNSet(
        0,
        currsubplot,
        mxCreateString("YTickLabel"),
        mlfVertcat(
          mlfCellhcat(mxCreateString("negative"), NULL),
          mlfCellhcat(mxCreateString("positive"), NULL),
          NULL),
        NULL));
    /*
     * title('Curvature of current direction');
     */
    mclAssignAns(
      &ans,
      mlfNTitle(0, mxCreateString("Curvature of current direction"), NULL));
    /*
     * xlabel('iteration');
     */
    mclAssignAns(&ans, mlfNXlabel(0, mxCreateString("iteration"), NULL));
    /*
     * hold off
     */
    mlfHold(mxCreateString("off"));
    /*
     * %
     * if isempty(vdeg)
     */
    if (mlfTobool(mlfIsempty(vdeg))) {
        /*
         * vdeg = ones(it,1);
         */
        mlfAssign(&vdeg, mlfOnes(it, mlfScalar(1.0), NULL));
    /*
     * end
     */
    }
    /*
     * len = length(vdeg); 
     */
    mlfAssign(&len, mlfLength(vdeg));
    /*
     * itv = 1:1:len; 
     */
    mlfAssign(&itv, mlfColon(mlfScalar(1.0), mlfScalar(1.0), len));
    /*
     * itv = itv';
     */
    mlfAssign(&itv, mlfCtranspose(itv));
    /*
     * one = ones(len,1);
     */
    mlfAssign(&one, mlfOnes(len, mlfScalar(1.0), NULL));
    /*
     * subplot(2,2,4)
     */
    mclPrintAns(
      &ans, mlfNSubplot(0, mlfScalar(2.0), mlfScalar(2.0), mlfScalar(4.0)));
    /*
     * %plot(itv,log10(vdeg),'-',itv,log10(vdeg),'go');
     * semilogy(itv,vdeg,'-',itv,vdeg,'go');
     */
    mclAssignAns(
      &ans,
      mlfNSemilogy(
        0,
        itv,
        vdeg,
        mxCreateString("-"),
        itv,
        vdeg,
        mxCreateString("go"),
        NULL));
    /*
     * title('Constraint degeneracy')
     */
    mclPrintAns(
      &ans, mlfNTitle(0, mxCreateString("Constraint degeneracy"), NULL));
    /*
     * xlabel('iteration')
     */
    mclPrintAns(&ans, mlfNXlabel(0, mxCreateString("iteration"), NULL));
    /*
     * 
     * if ~isempty(figtr) 
     */
    if (mlfTobool(mlfNot(mlfIsempty(figtr)))) {
        /*
         * set(closebtn,'Enable','on') ; 
         */
        mclAssignAns(
          &ans,
          mlfNSet(
            0, closebtn, mxCreateString("Enable"), mxCreateString("on"), NULL));
    /*
     * end
     */
    }
    /*
     * 
     * 
     */
    return_:
    mclValidateOutputs("optim/private/xplot", 1, nargout_, &figps);
    mxDestroyArray(ans);
    mxDestroyArray(closebtn);
    mxDestroyArray(currsubplot);
    mxDestroyArray(figtr);
    mxDestroyArray(itv);
    mxDestroyArray(len);
    mxDestroyArray(one);
    mxDestroyArray(screensize);
    mxDestroyArray(vdeg);
    mxDestroyArray(vpos);
    mxDestroyArray(ypos);
    return figps;
}

/*
 * The function "mlfOptim_private_xplot" contains the normal interface for the
 * "optim/private/xplot" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\xplot.m" (lines 1-87). This function
 * processes any input arguments and passes them to the implementation version
 * of the function, appearing above.
 */
mxArray * mlfOptim_private_xplot(mxArray * it,
                                 mxArray * vval,
                                 mxArray * vfnrm,
                                 mxArray * vflops,
                                 mxArray * vpos,
                                 mxArray * vdeg,
                                 mxArray * vpcg) {
    int nargout = 1;
    mxArray * figps = mclGetUninitializedArray();
    mlfEnterNewContext(0, 7, it, vval, vfnrm, vflops, vpos, vdeg, vpcg);
    figps
      = Moptim_private_xplot(
          nargout, it, vval, vfnrm, vflops, vpos, vdeg, vpcg);
    mlfRestorePreviousContext(0, 7, it, vval, vfnrm, vflops, vpos, vdeg, vpcg);
    return mlfReturnValue(figps);
}

/*
 * The function "mlxOptim_private_xplot" contains the feval interface for the
 * "optim/private/xplot" M-function from file
 * "C:\MATLABR11\toolbox\optim\private\xplot.m" (lines 1-87). The feval
 * function calls the implementation version of optim/private/xplot through
 * this function. This function processes any input arguments and passes them
 * to the implementation version of the function, appearing above.
 */
void mlxOptim_private_xplot(int nlhs,
                            mxArray * plhs[],
                            int nrhs,
                            mxArray * prhs[]) {
    mxArray * mprhs[7];
    mxArray * mplhs[1];
    int i;
    if (nlhs > 1) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/xplot Line: 1 Colu"
            "mn: 0 The function \"optim/private/xplot\" was called "
            "with more than the declared number of outputs (1)"));
    }
    if (nrhs > 7) {
        mlfError(
          mxCreateString(
            "Run-time Error: File: optim/private/xplot Line: 1 Col"
            "umn: 0 The function \"optim/private/xplot\" was calle"
            "d with more than the declared number of inputs (7)"));
    }
    for (i = 0; i < 1; ++i) {
        mplhs[i] = NULL;
    }
    for (i = 0; i < 7 && i < nrhs; ++i) {
        mprhs[i] = prhs[i];
    }
    for (; i < 7; ++i) {
        mprhs[i] = NULL;
    }
    mlfEnterNewContext(
      0,
      7,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6]);
    mplhs[0]
      = Moptim_private_xplot(
          nlhs,
          mprhs[0],
          mprhs[1],
          mprhs[2],
          mprhs[3],
          mprhs[4],
          mprhs[5],
          mprhs[6]);
    mlfRestorePreviousContext(
      0,
      7,
      mprhs[0],
      mprhs[1],
      mprhs[2],
      mprhs[3],
      mprhs[4],
      mprhs[5],
      mprhs[6]);
    plhs[0] = mplhs[0];
}
